<?php
/**
 * @package		Gantry Template Framework - RocketTheme
 * @version		1.1 February 9, 2012
 * @author		RocketTheme http://www.rockettheme.com
 * @copyright 	Copyright (C) 2007 - 2012 RocketTheme, LLC
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 * Gantry uses the Joomla Framework (http://www.joomla.org), a GNU/GPLv2 content management system
 *
 */
defined('JPATH_BASE') or die();

gantry_import('core.gantryfeature');

class GantryFeatureStyleDeclaration extends GantryFeature {
    var $_feature_name = 'styledeclaration';

    function isEnabled() {
        global $gantry;
        $menu_enabled = $this->get('enabled');

        if (1 == (int)$menu_enabled) return true;
        return false;
    }
    
function init() {
        global $gantry;
		$browser = $gantry->browser;

		// COLORCHOOSER

		// TopBlock
		$css = '#rt-top-surround, #roksearch_results,#rt-top-surround #rokajaxsearch .rokajaxsearch .inputbox {background-color:'.$gantry->get('topblock-background').';}'."\n";
        $css .= '#rt-top a, #rt-header a, .menutop li > .item, #rt-top-surround .roktabs-wrapper .roktabs-links ul li.active span  {color:'.$gantry->get('topblock-link').';}'."\n";

        // BottomBlock
        $css .= '#rt-footer-surround,#rt-footer-surround #rokajaxsearch .rokajaxsearch .inputbox {background-color:'.$gantry->get('bottomblock-background').';}'."\n";
        $css .= '#rt-footer-surround a, #rt-bottom a, #rt-footer a,#rt-footer-surround .roktabs-wrapper .roktabs-links ul li.active span {color:'.$gantry->get('bottomblock-link').';}'."\n";

		// Static file
        if ($gantry->get('static-enabled')) {
            // do file stuff
            jimport('joomla.filesystem.file');
            $filename = $gantry->templatePath.DS.'css'.DS.'static-styles.css';

            if (file_exists($filename)) {
                if ($gantry->get('static-check')) {
                    //check to see if it's outdated

                    $md5_static = md5_file($filename);
                    $md5_inline = md5($css);

                    if ($md5_static != $md5_inline) {
                        JFile::write($filename, $css);
                    }
                }
            } else {
                // file missing, save it
                JFile::write($filename, $css);
            }
            // add reference to static file
            $gantry->addStyle('static-styles.css',99);

        } else {
            // add inline style
            $gantry->addInlineStyle($css);
        }

		$this->_disableRokBoxForiPhone();

		// Style Inclusion
		$mainstyle = $gantry->get('main-body');
        $gantry->addStyle('main-'.$mainstyle.".css");
		$colorstyle = $gantry->get('main-color');
        $gantry->addStyle($colorstyle.".css");
		if ($gantry->get('typography-enabled')) $gantry->addStyle('typography.css');
		if ($gantry->get('extensions')) $gantry->addStyle('extensions.css');
		if ($gantry->get('extensions')) $gantry->addStyle('extensions-overlays.css');
		if ($gantry->get('extensions')) $gantry->addStyle('extensions-'.$mainstyle.'.css');

        //third party
        if ($gantry->get('ecwid')) $gantry->addStyle('ecwid.css');
        if ($gantry->get('ecwid')) $gantry->addStyle('ecwid-'.$mainstyle.'.css');

	}

	function _disableRokBoxForiPhone() {
		global $gantry;

		if ($gantry->browser->platform == 'iphone') {
			$gantry->addInlineScript("window.addEvent('domready', function() {\$\$('a[rel^=rokbox]').removeEvents('click');});");
		}
	}

}