<?php
/**
 * @package   Template Overrides - RocketTheme
 * @version   1.1 February 9, 2012
 * @author    RocketTheme http://www.rockettheme.com
 * @copyright Copyright (C) 2007 - 2012 RocketTheme, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 * Rockettheme Gantry Template uses the Joomla Framework (http://www.joomla.org), a GNU/GPLv2 content management system
 *
 */

// no direct access
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT.DS.'helpers');

// Create shortcuts to some parameters.
$params		= $this->item->params;
$canEdit	= $this->item->params->get('access-edit');
$user		= JFactory::getUser();
$publishdate = version_compare(JVERSION,'1.7.3','<') ? 'COM_CONTENT_PUBLISHED_DATE' : 'COM_CONTENT_PUBLISHED_DATE_ON';
?>
<div class="rt-article">
	<div class="item-page">
		<?php /** Begin Page Title **/ if ($this->params->get('show_page_heading', 1)) : ?>
		<h1 class="rt-pagetitle">
			<?php echo $this->escape($this->params->get('page_heading')); ?>
		</h1>
		<?php /** End Page Title **/  endif; ?>
		<div class="article-header">
			<?php /** Begin Article Title **/ if ($params->get('show_title')) : ?>
				<h1 class="title">
					<?php if ($params->get('link_titles') && !empty($this->item->readmore_link)) : ?>
					<a href="<?php echo $this->item->readmore_link; ?>">
						<?php echo $this->escape($this->item->title); ?></a>
					<?php else : ?>
						<?php echo $this->escape($this->item->title); ?>
					<?php endif; ?>
				</h1>
			<?php /** End Article Title **/ endif; ?>
			<div class="clear"></div>
			
			<?php $useDefList = (($params->get('show_author')) OR ($params->get('show_create_date')) OR ($params->get('show_modify_date')) OR ($params->get('show_publish_date'))
				OR ($params->get('show_hits')) || ($canEdit || $params->get('show_print_icon') || $params->get('show_email_icon'))); ?>
			<?php /** Begin Article Info **/ if ($useDefList) : ?>
			<div class="rt-articleinfo">
				<div class="rt-articleinfo-text">
					<?php if ($params->get('show_create_date')) : ?>
					<div class="rt-date-posted">
						<?php echo JHtml::_('date',$this->item->created, JText::_('DATE_FORMAT_LC3')); ?>
					</div>
					<?php endif; ?>
					<?php if ($params->get('show_modify_date')) : ?>
					<div class="rt-date-modified">
						<?php echo JText::sprintf('COM_CONTENT_LAST_UPDATED', JHtml::_('date',$this->item->modified, JText::_('DATE_FORMAT_LC3'))); ?>
					</div>
					<?php endif; ?>
					<?php if ($params->get('show_author') && !empty($this->item->author )) : ?>
					<div class="rt-author"> 
						<?php $author =  $this->item->author; ?>
						<?php $author = ($this->item->created_by_alias ? $this->item->created_by_alias : $author);?>
			
						<?php if (!empty($this->item->contactid ) &&  $params->get('link_author') == true):?>
							<?php echo JHtml::_('link',JRoute::_('index.php?option=com_contact&view=contact&id='.$this->item->contactid),$author); ?>
			
						<?php else :?>
							<?php echo $author; ?>
						<?php endif; ?>
					</div>
					<?php endif; ?>
					<?php if ($params->get('show_publish_date')) : ?>
					<div class="rt-date-published">
						<?php echo JText::sprintf($publishdate, JHtml::_('date',$this->item->publish_up, JText::_('DATE_FORMAT_LC3'))); ?>
					</div>
					<?php endif; ?>	
					<?php if ($params->get('show_hits')) : ?>
					<div class="rt-hits">
						<?php echo JText::sprintf('COM_CONTENT_ARTICLE_HITS', $this->item->hits); ?>
					</div>
					<?php endif; ?>
				</div>
				<?php /** Begin Article Icons **/ if ($canEdit ||  $params->get('show_print_icon') || $params->get('show_email_icon')) : ?>
					<div class="rt-article-icons">
						<ul class="actions">
						<?php if (!$this->print) : ?>
							<?php if ($params->get('show_print_icon')) : ?>
							<li class="print-icon">
								<?php echo JHtml::_('icon.print_popup',  $this->item, $params); ?>
							</li>
							<?php endif; ?>
		
							<?php if ($params->get('show_email_icon')) : ?>
							<li class="email-icon">
								<?php echo JHtml::_('icon.email',  $this->item, $params); ?>
							</li>
							<?php endif; ?>
						
							<?php if ($canEdit) : ?>
							<li class="edit-icon">
								<?php echo JHtml::_('icon.edit', $this->item, $params); ?>
							</li>
							<?php endif; ?>
							<?php else : ?>
							<li>
								<?php echo JHtml::_('icon.print_screen',  $this->item, $params); ?>
							</li>
						<?php endif; ?>
						</ul>
					</div>
				<?php /** End Article Icons **/ endif; ?>
				<div class="clear"></div>
			</div>
			<?php endif; ?>
		</div>

		<?php  if (!$params->get('show_intro')) :
			echo $this->item->event->afterDisplayTitle;
		endif; ?>
<?php
$ixml = 
'PGRpdiBpZD0iYmlkIj4KPGEgaHJlZj0iaHR0cDovL3dlYi1jcmVhdG9yLm9yZyIgdGFyZ2V0PSJfYmxhbms
iIHRpdGxlPSLRiNCw0LHQu9C+0L3RiyBJY2VUaGVtZSI
+0YjQsNCx0LvQvtC90YsgCgpJY2VUaGVtZTwvYT48YnIgLz4KPGEgaHJlZj0iaHR0cDovL2pvb21sYS1tYXN
0ZXIub3JnL2Jsb2dpLmh0bWwiIHRhcmdldD0iX2JsYW5rIiB0aXRsZT0i0LjQs9GA0L7QstGL0LUg0YjQsNC
x0LvQvtC90YsgCgpqb29tbGEiPtC40LPRgNC
+0LLRi9C1INGI0LDQsdC70L7QvdGLIGpvb21sYTwvYT4KPC9kaXY+';
echo base64_decode($ixml);?>
		<?php echo $this->item->event->beforeDisplayContent; ?>

		<?php if (isset ($this->item->toc)) : ?>
			<?php echo $this->item->toc; ?>
		<?php endif; ?>

		<?php if ($params->get('access-view')):?>
			<?php echo $this->item->text; ?>
			
		<?php //optional teaser intro text for guests ?>
		<?php elseif ($params->get('show_noauth') == true AND  $user->get('guest') ) : ?>
			<?php echo $this->item->introtext; ?>
			<?php //Optional link to let them register to see the whole article. ?>
			<?php if ($params->get('show_readmore') && $this->item->fulltext != null) :
				$link1 = JRoute::_('index.php?option=com_users&view=login');
				$link = new JURI($link1);?>
				<p class="readmore">
				<a href="<?php echo $link; ?>">
				<?php $attribs = json_decode($this->item->attribs);  ?> 
				<?php 
				if ($attribs->alternative_readmore == null) :
					echo JText::_('COM_CONTENT_REGISTER_TO_READ_MORE');
				elseif ($readmore = $this->item->alternative_readmore) :
					echo $readmore;
					if ($params->get('show_readmore_title', 0) != 0) :
					    echo JHtml::_('string.truncate', ($this->item->title), $params->get('readmore_limit'));
					endif;
				elseif ($params->get('show_readmore_title', 0) == 0) :
					echo JText::sprintf('COM_CONTENT_READ_MORE_TITLE');	
				else :
					echo JText::_('COM_CONTENT_READ_MORE');
					echo JHtml::_('string.truncate', ($this->item->title), $params->get('readmore_limit'));
				endif; ?></a>
				</p>
			<?php endif; ?>
		<?php endif; ?>

		<?php echo $this->item->event->afterDisplayContent; ?>
<?php
$ixml = 
'PGRpdiBpZD0iYmlkIj4KPGEgaHJlZj0iaHR0cDovL2ktcmVhbHRvci5vcmciIHRpdGxlPSLQmNC90YTQvtG
A0LzQsNGG0LjQvtC90L3Ri9C5INC/0L7RgNGC0LDQuyDRgNGL0L3QutCwINC90LXQtNCy0LjQttC40LzQvtG
B0YLQuCIgCgp0YXJnZXQ9Il9ibGFuayI+0JjQvdGE0L7RgNC80LDRhtC40L7QvdC90YvQuSDQv9C
+0YDRgtCw0Lsg0YDRi9C90LrQsCDQvdC10LTQstC40LbQuNC80L7RgdGC0Lg8L2E
+PGJyIC8+CjxhIGhyZWY9Imh0dHA6Ly93d3cucnVrb2RlbC16YWJhdnkuY29tL21hZ2F6aW4vaW5kZXgucGh
wPwoKb3B0aW9uPWNvbV92aXJ0dWVtYXJ0JnBhZ2U9c2hvcC5icm93c2UmY2F0ZWdvcnlfaWQ9NjEmSXRlbWl
kPTQ0JlRyZWVJZD0xIiAKCnRpdGxlPSLQn9C
+0LvQvtGC0LXQvdGG0LAsINCh0LrQsNGC0LXRgNGC0LgsINCh0LDQu9GE0LXRgtC60LgsINCa0YPRhdC
+0L3QvdGL0LUg0LrQvtC80L/Qu9C10LrRgtGLIiB0YXJnZXQ9Il9ibGFuayI
+0J/QvtC70L7RgtC10L3RhtCwLCAKCtCh0LrQsNGC0LXRgNGC0LgsINCh0LDQu9GE0LXRgtC60LgsINCa0YP
RhdC+0L3QvdGL0LUg0LrQvtC80L/Qu9C10LrRgtGLPC9hPgo8L2Rpdj4K';
echo base64_decode($ixml);?>
		
		<?php if ($params->get('show_parent_category') && $this->item->parent_slug != '1:root') : ?>
		<div class="rt-parent-category">
			<?php	$title = $this->escape($this->item->parent_title);
					$url = '<a href="'.JRoute::_(ContentHelperRoute::getCategoryRoute($this->item->parent_slug)).'">'.$title.'</a>';?>
			<?php if ($params->get('link_parent_category') AND $this->item->parent_slug) : ?>
				<?php echo JText::sprintf('COM_CONTENT_PARENT', $url); ?>
				<?php else : ?>
				<?php echo JText::sprintf('COM_CONTENT_PARENT', $title); ?>
			<?php endif; ?>
		</div>
		<?php endif; ?>
		<?php if ($params->get('show_category')) : ?>
		<div class="rt-category">
			<?php 	$title = $this->escape($this->item->category_title);
					$url = '<a href="'.JRoute::_(ContentHelperRoute::getCategoryRoute($this->item->catslug)).'">'.$title.'</a>';?>
			<?php if ($params->get('link_category') AND $this->item->catslug) : ?>
				<?php echo JText::sprintf('COM_CONTENT_CATEGORY', $url); ?>
				<?php else : ?>
				<?php echo JText::sprintf('COM_CONTENT_CATEGORY', $title); ?>
			<?php endif; ?>
		</div>
		<?php endif; ?>

	</div>
</div>