-- Halcuon RocketLauncher Package
-- January 2012 Joomla template release
-- http://www.rockettheme.com
--

-- --------------------------------------------------------

--
-- Table structure for table `#__assets`
--

DROP TABLE IF EXISTS `#__assets`;
CREATE TABLE IF NOT EXISTS `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
);

--
-- Dumping data for table `#__assets`
--

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(1, 0, 1, 502, 0, 'root.1', 'Root Asset', '{"core.login.site":{"6":1,"2":1},"core.login.admin":{"6":1},"core.login.offline":{"6":1},"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(2, 1, 1, 2, 1, 'com_admin', 'com_admin', '{}'),
(3, 1, 3, 6, 1, 'com_banners', 'com_banners', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(4, 1, 7, 8, 1, 'com_cache', 'com_cache', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(5, 1, 9, 10, 1, 'com_checkin', 'com_checkin', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(6, 1, 11, 12, 1, 'com_config', 'com_config', '{}'),
(7, 1, 13, 18, 1, 'com_contact', 'com_contact', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(8, 1, 19, 92, 1, 'com_content', 'com_content', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(9, 1, 93, 94, 1, 'com_cpanel', 'com_cpanel', '{}'),
(10, 1, 95, 96, 1, 'com_installer', 'com_installer', '{"core.admin":{"7":1},"core.manage":{"7":1},"core.delete":[],"core.edit.state":[]}'),
(11, 1, 97, 98, 1, 'com_languages', 'com_languages', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(12, 1, 99, 100, 1, 'com_login', 'com_login', '{}'),
(13, 1, 101, 102, 1, 'com_mailto', 'com_mailto', '{}'),
(14, 1, 103, 104, 1, 'com_massmail', 'com_massmail', '{}'),
(15, 1, 105, 106, 1, 'com_media', 'com_media', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":{"5":1}}'),
(16, 1, 107, 108, 1, 'com_menus', 'com_menus', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(17, 1, 109, 110, 1, 'com_messages', 'com_messages', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(18, 1, 111, 112, 1, 'com_modules', 'com_modules', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(19, 1, 113, 116, 1, 'com_newsfeeds', 'com_newsfeeds', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(20, 1, 117, 118, 1, 'com_plugins', 'com_plugins', '{"core.admin":{"7":1},"core.manage":[],"core.edit":[],"core.edit.state":[]}'),
(21, 1, 119, 120, 1, 'com_redirect', 'com_redirect', '{"core.admin":{"7":1},"core.manage":[]}'),
(22, 1, 121, 122, 1, 'com_search', 'com_search', '{"core.admin":{"7":1},"core.manage":{"6":1}}'),
(23, 1, 123, 124, 1, 'com_templates', 'com_templates', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(24, 1, 125, 126, 1, 'com_users', 'com_users', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.own":{"6":1},"core.edit.state":[]}'),
(25, 1, 127, 132, 1, 'com_weblinks', 'com_weblinks', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(26, 1, 133, 134, 1, 'com_wrapper', 'com_wrapper', '{}'),
(27, 8, 20, 21, 2, 'com_content.category.2', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(28, 3, 4, 5, 2, 'com_banners.category.3', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(29, 7, 14, 15, 2, 'com_contact.category.4', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(30, 19, 114, 115, 2, 'com_newsfeeds.category.5', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(31, 25, 128, 129, 2, 'com_weblinks.category.6', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(32, 1, 488, 489, 1, 'com_gantry', 'gantry', '{}'),
(33, 1, 490, 491, 1, 'com_rokmodule', 'rokmodule', '{}'),
(34, 1, 492, 493, 1, 'com_rokcandy.category.7', 'Basic', ''),
(35, 1, 494, 495, 1, 'com_rokcandy.category.8', 'Typography', ''),
(36, 1, 496, 497, 1, 'com_rokcandy.category.9', 'Uncategorised', ''),
(37, 1, 498, 499, 1, 'com_rokcandy', 'rokcandy', '{}'),
(38, 8, 22, 57, 2, 'com_content.category.10', 'Demo Articles', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(39, 38, 23, 24, 3, 'com_content.article.1', 'Template Features', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(40, 38, 25, 26, 3, 'com_content.article.2', 'Module Variations', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(41, 38, 27, 28, 3, 'com_content.article.3', 'Module Positions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(42, 38, 29, 30, 3, 'com_content.article.4', 'Template Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(43, 38, 31, 32, 3, 'com_content.article.5', 'Integrated Extensions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(44, 38, 33, 34, 3, 'com_content.article.6', 'Tutorials and Guides', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(45, 38, 35, 36, 3, 'com_content.article.7', 'Installation Instructions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(46, 38, 37, 38, 3, 'com_content.article.8', 'Menu Options', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(47, 38, 39, 40, 3, 'com_content.article.9', 'Logo Editing', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(48, 38, 41, 42, 3, 'com_content.article.10', 'Preset Styles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(49, 38, 43, 44, 3, 'com_content.article.11', 'Sample Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(50, 8, 58, 75, 2, 'com_content.category.11', 'Sample Content ', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(51, 50, 59, 60, 3, 'com_content.article.12', 'Sample Content 01', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(52, 50, 61, 62, 3, 'com_content.article.13', 'Sample Content 02', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(53, 50, 63, 64, 3, 'com_content.article.14', 'Sample Content 03', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(54, 50, 65, 66, 3, 'com_content.article.15', 'Sample Content 04', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(55, 50, 67, 68, 3, 'com_content.article.16', 'Sample Content 05', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(56, 50, 69, 70, 3, 'com_content.article.17', 'Sample Content 06', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(57, 50, 71, 72, 3, 'com_content.article.18', 'Sample Content 07', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(58, 50, 73, 74, 3, 'com_content.article.19', 'Sample Content 08', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(59, 25, 130, 131, 2, 'com_weblinks.category.12', 'RocketTheme', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(60, 7, 16, 17, 2, 'com_contact.category.13', 'Contact', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(61, 38, 45, 46, 3, 'com_content.article.20', 'RokStories Module (J1.5/1.7)', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(62, 38, 47, 48, 3, 'com_content.article.21', 'RokNewsPager Module (J1.5/1.7)', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(63, 38, 49, 50, 3, 'com_content.article.22', 'RokTabs Module (J1.5/1.7)', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(64, 38, 51, 52, 3, 'com_content.article.23', 'RokFeatureTable (J1.5/1.7)', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(65, 1, 500, 501, 1, 'com_rokecwid', 'rokecwid', '{}'),
(66, 8, 76, 83, 2, 'com_content.category.14', 'FP RokTabs', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(67, 66, 77, 78, 3, 'com_content.article.24', 'Featured Products', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(68, 66, 79, 80, 3, 'com_content.article.25', 'Most Popular', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(69, 66, 81, 82, 3, 'com_content.article.26', 'Latest Arrivals', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(70, 38, 53, 54, 3, 'com_content.article.27', 'Frontpage Article', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(71, 8, 84, 91, 2, 'com_content.category.15', 'FP RokStories', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(72, 71, 85, 86, 3, 'com_content.article.28', 'Macbook Pro — From $1299.99', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(73, 71, 87, 88, 3, 'com_content.article.29', 'Macbook Air — From $1199.99', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(74, 71, 89, 90, 3, 'com_content.article.30', 'iPhone 4S — From $499.99', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(75, 38, 55, 56, 3, 'com_content.article.31', 'RokAjaxSearch Module (J1.5/1.7)', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}');

-- --------------------------------------------------------

--
-- Table structure for table `#__associations`
--

DROP TABLE IF EXISTS `#__associations`;
CREATE TABLE IF NOT EXISTS `#__associations` (
  `id` varchar(50) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
);

--
-- Dumping data for table `#__associations`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__banners`
--

DROP TABLE IF EXISTS `#__banners`;
CREATE TABLE IF NOT EXISTS `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
);

--
-- Dumping data for table `#__banners`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__banner_clients`
--

DROP TABLE IF EXISTS `#__banner_clients`;
CREATE TABLE IF NOT EXISTS `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
);

--
-- Dumping data for table `#__banner_clients`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__banner_tracks`
--

DROP TABLE IF EXISTS `#__banner_tracks`;
CREATE TABLE IF NOT EXISTS `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
);

--
-- Dumping data for table `#__banner_tracks`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__categories`
--

DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE IF NOT EXISTS `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
);

--
-- Dumping data for table `#__categories`
--

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`) VALUES
(1, 0, 0, 0, 29, 0, '', 'system', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '', 0, '2009-10-18 16:07:09', 0, '0000-00-00 00:00:00', 0, '*'),
(2, 27, 1, 1, 2, 1, 'uncategorised', 'com_content', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-06-28 13:26:37', 0, '0000-00-00 00:00:00', 0, '*'),
(3, 28, 1, 3, 4, 1, 'uncategorised', 'com_banners', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":"","foobar":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-06-28 13:27:35', 0, '0000-00-00 00:00:00', 0, '*'),
(4, 29, 1, 5, 6, 1, 'uncategorised', 'com_contact', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-06-28 13:27:57', 0, '0000-00-00 00:00:00', 0, '*'),
(5, 30, 1, 7, 8, 1, 'uncategorised', 'com_newsfeeds', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-06-28 13:28:15', 0, '0000-00-00 00:00:00', 0, '*'),
(6, 31, 1, 9, 10, 1, 'uncategorised', 'com_weblinks', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-06-28 13:28:33', 0, '0000-00-00 00:00:00', 0, '*'),
(7, 34, 1, 11, 12, 1, 'basic', 'com_rokcandy', 'Basic', 'basic', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2011-12-15 14:00:49', 0, '0000-00-00 00:00:00', 0, ''),
(8, 35, 1, 13, 14, 1, 'typography', 'com_rokcandy', 'Typography', 'typography', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2011-12-15 14:00:49', 0, '0000-00-00 00:00:00', 0, ''),
(9, 36, 1, 15, 16, 1, 'uncategorised', 'com_rokcandy', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2011-12-15 14:00:49', 0, '0000-00-00 00:00:00', 0, ''),
(10, 38, 1, 17, 18, 1, 'demo-articles', 'com_content', 'Demo Articles', 'demo-articles', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-15 14:54:05', 0, '0000-00-00 00:00:00', 0, '*'),
(11, 50, 1, 19, 20, 1, 'sample-content', 'com_content', 'Sample Content ', 'sample-content', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-15 15:34:41', 0, '0000-00-00 00:00:00', 0, '*'),
(12, 59, 1, 21, 22, 1, 'rockettheme', 'com_weblinks', 'RocketTheme', 'rockettheme', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-15 16:13:47', 0, '0000-00-00 00:00:00', 0, '*'),
(13, 60, 1, 23, 24, 1, 'contact', 'com_contact', 'Contact', 'contact', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-15 16:16:05', 0, '0000-00-00 00:00:00', 0, '*'),
(14, 66, 1, 25, 26, 1, 'fp-roktabs', 'com_content', 'FP RokTabs', 'fp-roktabs', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-27 22:36:45', 0, '0000-00-00 00:00:00', 0, '*'),
(15, 71, 1, 27, 28, 1, 'fp-rokstories', 'com_content', 'FP RokStories', 'fp-rokstories', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2011-12-27 23:06:52', 0, '0000-00-00 00:00:00', 0, '*');

-- --------------------------------------------------------

--
-- Table structure for table `#__contact_details`
--

DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE IF NOT EXISTS `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
);

--
-- Dumping data for table `#__contact_details`
--

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES
(1, 'Halcyon', 'halcyon', 'Site Owner', '7001 St. Thomas Avenue', 'Seattle', 'WA', 'United States of America', '00000', '+1 555-555-5555', '+1 555-555-5555', '', 'images/stories/halcyon.jpg', NULL, 'email@jan12.demo.rockettheme.com', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","contact_layout":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 13, 1, '+1 555-555-5555', 'http://demo.rockettheme.com/jan12', '', '', '', '*', '2011-12-15 16:17:52', 42, '', '0000-00-00 00:00:00', 0, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');

-- --------------------------------------------------------

--
-- Table structure for table `#__content`
--

DROP TABLE IF EXISTS `#__content`;
CREATE TABLE IF NOT EXISTS `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `title_alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '' COMMENT 'Deprecated in Joomla! 3.0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
);

--
-- Dumping data for table `#__content`
--

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(1, 39, 'Template Features', 'template-features', '', '<a href="http://gantry-framework.org/" target="_blank"><img src="images/stories/demo/general/tutorial1.jpg" alt="tutorial" class="rt-image floatleft" height="150" width="225" /></a>\r\n\r\n<p>The <strong>Gantry Framework</strong> is the foundation of the <strong>features</strong> and functions of the template.</p> \r\n\r\n<p>Notably, it provides for a rich, friendly <strong>user interface</strong> to control major theme elements.</p>\r\n<div class="clear"></div>\r\n\r\n<h4>Video Documentation</h4>\r\n		                	\r\n<div class="floatleft" style="width: 130px;">\r\n	<a href="http://gantry-framework.org/documentation" target="_blank"><img src="images/stories/demo/general/tutorial2.jpg" alt="tutorial" class="rt-image" height="82" width="124" /></a>\r\n</div>\r\n<div class="floatleft" style="width: 130px;">\r\n	<a href="http://gantry-framework.org/documentation" target="_blank"><img src="images/stories/demo/general/tutorial3.jpg" alt="tutorial" class="rt-image" height="82" width="124" /></a>\r\n</div>\r\n<div class="floatleft nomarginright" style="width: 130px;">\r\n	<a href="http://gantry-framework.org/documentation" target="_blank"><img src="images/stories/demo/general/tutorial4.jpg" alt="tutorial" class="rt-image" height="82" width="124" /></a>\r\n</div>\r\n<div class="clear"></div><br />', '', 1, 0, 0, 10, '2011-12-15 14:54:50', 42, '', '2011-12-29 02:26:23', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:54:50', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 2, '', '', 1, 11, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(2, 40, 'Module Variations', 'module-variations', '', '<p>Module Variations allow you to individually style a module Enter any available suffixes at <strong>Extensions &rarr; Module Manager &rarr; <em>Module</em> &rarr; Module Class Suffix</strong></p>\r\n\r\n<p>There are 59 suffixes: <strong>box1-3</strong>, <strong>title1-3</strong>, <strong>icon1-30</strong>, <strong>shadow2-10</strong>; <strong>rounded</strong>, <strong>square</strong>, <strong>rt-center</strong>; <strong>nomargintop</strong>, <strong>nomarginbottom</strong>, <strong>nomarginright</strong>, <strong>nomarginleft</strong>, <strong>nopaddingtop</strong>, <strong>nopaddingbottom</strong>, <strong>nopaddingright</strong> and <strong>nopaddingleft</strong>; plus <strong>standardcase</strong>, <strong>uppercase</strong> and <strong>lowercase</strong>.</p>\r\n\r\n<p class="notice">Note: You can compound multiple suffixes together such as <em class="bold">box1 shadow2 nomarginleft standardcase</em>.</p>\r\n\r\n<ul class="bullet-1">\r\n	<li><strong>Title:</strong> 3 variations to change the module title.</li>\r\n	<li><strong>Box:</strong> 3 variations to change the module background.</li>\r\n	<li><strong>Icon:</strong> 30 icon variations for the module title.</li>\r\n	<li><strong>Shadow:</strong> 9 variations to add shadows to the module.</li>\r\n	<li><strong>Rounded/Square:</strong> changes the module border to round or square.</li>\r\n	<li><strong>RT-Center:</strong> centres the content of the module.</li>\r\n	<li><strong>Standard/Upper/Lower Case:</strong> change the case of the module title.</li>\r\n	<li><strong>NoMarginTop/Bottom/Left/Right:</strong> removes the various margins around the module.</li>\r\n	<li class="nomarginbottom"><strong>NoPaddingTop/Bottom/Left/Right:</strong> removes the various paddings around the module</li>\r\n</ul>', '', 1, 0, 0, 10, '2011-12-15 14:55:07', 42, '', '2011-12-29 02:26:23', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:55:07', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 3, '', '', 1, 29, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(3, 41, 'Module Positions', 'module-positions', '', '<p>There are <em class="bold2">80</em> module positions. If no module is published to a position, it will not appear, collapsing the entire area.</p>\r\n\r\n<p><em class="bold2">Non-Standard Elements</em></p>\r\n\r\n<p>There are <strong>non-standard</strong> elements that are injected into the template grid structure when enabled via the <strong>template parameter</strong>, such as the <strong>logo</strong> into <strong>header-a</strong>. These features <strong>stack</strong> vertically with any modules published to that position.</p>\r\n\r\n<p class="notice">You can change the positions of these elements at <strong>Extensions &rarr; Template Manager &rarr; <em>(J15) rt_halcyon_j15 or (J17) rt_halcyon</em></strong></p>\r\n\r\n<p><em class="bold2">Layout Control</em></p>\r\n\r\n<p>Control all modules positions with Gantry, in terms of widths within the module row, and left/right/middle placement for the mainbody/sidebar area.</p>\r\n\r\n<p><img src="images/stories/demo/general/position-1.jpg" alt="image" width="559" height="92" class="rt-image" /></p>\r\n<p><img src="images/stories/demo/general/position-2.jpg" alt="image" width="559" height="92" class="rt-image" /></p>\r\n\r\n[readon url="http://www.gantry-framework.org/documentation/joomla/configure/layouts"]Gantry Framework : Layouts Documentation[/readon]\r\n\r\n<p><em class="bold2">Preview Positions</em></p>\r\n\r\n<p class="notice">View all module positions live by appending <strong>?tp=1</strong> or <strong>&amp;tp=1</strong> to the end of your URL such as <strong><a href="#">http://yoursite.com/index.php?tp=1</a></strong>.</p>\r\n\r\n<p>The below diagram is of the <a href="index.php?option=com_content&amp;view=article&amp;id=2&amp;Itemid=109">Module Variations</a> page.</p>\r\n\r\n<img src="images/stories/demo/general/position-3.jpg" alt="Module Positions" class="rt-image" height="1710" width="560" />', '', 1, 0, 0, 10, '2011-12-15 14:55:23', 42, '', '2011-12-29 02:26:23', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:55:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 4, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(4, 42, 'Template Typography', 'template-typography', '', '<h2 class="title"><a name="quote" href="#quote">Quote Styles</a></h2>\r\n\r\n<blockquote><p>To replicate, use the following formatting: <strong>&lt;blockquote&gt;&lt;p&gt;....&lt;/p&gt;&lt;/blockquote&gt; (HTML)</strong> or <strong>&#91;blockquote class="default"&#93;...&#91;/blockquote&#93; (ROKCANDY)</strong>.</p></blockquote>\r\n\r\n<br /><br />\r\n\r\n<blockquote class="alignleft"><p>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis.</p></blockquote>\r\n\r\n<p>To replicate, use the following formatting: <strong>&lt;blockquote class=&quot;alignleft&quot;&gt;&lt;p&gt;....&lt;/p&gt;&lt;/blockquote&gt; (HTML)</strong> or <strong>&#91;blockquote class="alignleft"&#93;...&#91;/blockquote&#93; (ROKCANDY)</strong>.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris metus tortor, commodo sit amet tempor id, gravida eget orci. In molestie feugiat nunc ac lobortis. Ut non nisi dolor, ac ultricies lorem. Vestibulum non lectus in arcu gravida malesuada. Curabitur sed sollicitudin mi. Aenean sit amet tortor ac arcu gravida rutrum eget ac dui. Phasellus rutrum dapibus nulla, a venenatis tortor eleifend vitae. Ut tincidunt vestibulum blandit. Nulla aliquet urna non enim convallis in vehicula mi scelerisque. Aliquam blandit imperdiet lorem eu ultrices. Nulla in dolor non ipsum fringilla sodales sed ac turpis. Nam nisi arcu, tincidunt sodales.</p>\r\n\r\n<br /><br />\r\n\r\n<blockquote class="alignright"><p>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis.</p></blockquote>\r\n\r\n<p>To replicate, use the following formatting: <strong>&lt;blockquote class=&quot;alignright&quot;&gt;&lt;p&gt;....&lt;/p&gt;&lt;/blockquote&gt; (HTML)</strong> or <strong>&#91;blockquote class="alignright"&#93;...&#91;/blockquote&#93; (ROKCANDY)</strong>.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Mauris metus tortor, commodo sit amet tempor id, gravida eget orci. In molestie feugiat nunc ac lobortis. Ut non nisi dolor, ac ultricies lorem. Vestibulum non lectus in arcu gravida malesuada. Curabitur sed sollicitudin mi. Aenean sit amet tortor ac arcu gravida rutrum eget ac dui. Phasellus rutrum dapibus nulla, a venenatis tortor eleifend vitae. Ut tincidunt vestibulum blandit. Nulla aliquet urna non enim convallis in vehicula mi scelerisque. Aliquam blandit imperdiet lorem eu ultrices. Nulla in dolor non ipsum fringilla sodales sed ac turpis. Nam nisi arcu, tincidunt sodales.</p>\r\n\r\n<br />\r\n<h2 class="title"><a name="pre" href="#pre">Pre Code Styles</a></h2>\r\n\r\n<pre class="lines">This is a sample <strong>&lt;pre class=&quot;lines&quot;&gt;...&lt;/pre&gt; (HTML)</strong> or,\r\n<strong>&#91;pre2 class="{lines}"&#93; ... &#91;/pre2&#93; (ROKCANDY)</strong> tag:\r\n	\r\ndiv.modulebox-black div.bx1 {\r\n  background: url(../images/black/box_bl.png) 0 100% no-repeat;\r\n}\r\n\r\ndiv.modulebox-black div.bx2 {\r\n  background: url(../images/black/box_tr.png) 100% 0 no-repeat;\r\n}\r\n\r\ndiv.modulebox-black div.bx3 {\r\n  background: url(../images/black/box_tl.png) 0 0 no-repeat;\r\n  padding: 0;\r\n  margin: 0;\r\n}\r\n</pre>\r\n\r\n<br />\r\n\r\n<pre>This is a sample <strong>&lt;pre&gt;...&lt;/pre&gt; (HTML)</strong> or, \r\n<strong>&#91;pre class="{lines}"&#93; ... &#91;/pre&#93; (ROKCANDY)</strong> tag:\r\n	\r\ndiv.modulebox-black div.bx1 {\r\n  background: url(../images/black/box_bl.png) 0 100% no-repeat;\r\n}\r\n\r\ndiv.modulebox-black div.bx2 {\r\n  background: url(../images/black/box_tr.png) 100% 0 no-repeat;\r\n}\r\n\r\ndiv.modulebox-black div.bx3 {\r\n  background: url(../images/black/box_tl.png) 0 0 no-repeat;\r\n  padding: 0;\r\n  margin: 0;\r\n}\r\n</pre>\r\n\r\n<br />\r\n\r\n<h2 class="title"><a name="dropcap" href="#dropcap">DropCap Styles</a></h2>\r\n\r\n<p class="dropcap">Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus magnis.</p>\r\n\r\n<p>Use the following format: <strong>&lt;p class="dropcap"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap"&#93;...&#91;/dropcap&#93; (ROKCANDY)</strong>. You can use any letter, symbol or number.</p>\r\n\r\n<div class="rt-demo-grid-4">\r\n<p class="dropcap2">Praesent rutrum sapien ac felis. Use this format: <strong>&lt;p class="dropcap2"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap2"&#93; ... &#91;/dropcap&#93; (ROKCANDY)</strong></p>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n<p class="dropcap3">Praesent rutrum sapien ac felis. Use this format: <strong>&lt;p class="dropcap3"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap3"&#93; ... &#91;/dropcap&#93; (ROKCANDY)</strong></p>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n<p class="dropcap4">Praesent rutrum sapien ac felis. Use this format: <strong>&lt;p class="dropcap4"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap4"&#93; ... &#91;/dropcap&#93; (ROKCANDY)</strong></p>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n<p class="dropcap5">Praesent rutrum sapien ac felis. Use this format: <strong>&lt;p class="dropcap5"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap5"&#93; ... &#91;/dropcap&#93; (ROKCANDY)</strong></p>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n<p class="dropcap6">Praesent rutrum sapien ac felis. Use this format: <strong>&lt;p class="dropcap6"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap6"&#93; ... &#91;/dropcap&#93; (ROKCANDY)</strong></p>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n<p class="dropcap7">Praesent rutrum sapien ac felis. Use this format: <strong>&lt;p class="dropcap7"&gt;...&lt;/p&gt; (HTML)</strong> or <strong>&#91;dropcap class="dropcap7"&#93; ... &#91;/dropcap&#93; (ROKCANDY)</strong></p>\r\n</div>\r\n\r\n<div class="clear"></div>\r\n\r\n<br />\r\n\r\n<h2 class="title"><a name="headers" href="#headers">Standard Header Styles</a></h2>\r\n\r\n<div class="rt-demo-grid-4">\r\n  <div class="componentheading">This is a ComponentHeading</div>\r\n  <p>Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede.</p>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n  <div class="contentheading">This is a Contentheading</div>\r\n  <p>Proin ac nunc eu nunc condimentum accumsan. Phasellus odio justo, euismod vitae, egestas a.</p>\r\n</div>\r\n<div class="clear"></div>\r\n\r\n<div class="rt-demo-grid-4">\r\n  <h1>This is a H1 Header</h1>\r\n  <p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Proin sit amet odio quis sapien molestie ultrices.</p>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n  <h2>This is a H2 Header</h2>\r\n  <p>Proin ac nunc eu nunc condimentum accumsan. Phasellus odio justo, euismod vitae, egestas a, porttitor</p>\r\n</div>\r\n<div class="clear"></div>\r\n\r\n<div class="rt-demo-grid-4">\r\n  <h3>This is a H3 Header</h3>\r\n  <p>Mauris euismod. In ac massa vitae quam tincidunt dapibus. Ut at tortor nec mi mattis blandit.</p>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n  <h4>This is a H4 Header</h4>\r\n  <p>Vestibulum posuere, lacus aliquet pulvinar faucibus, tortor urna luctus diam, vitae ultrices ante.</p>\r\n</div>\r\n<div class="clear"></div>\r\n\r\n<h5>This is a H5 Header</h5>\r\n\r\n<p>Pellentesque vel enim urna, sit amet blandit ipsum. Maecenas quis sem sit amet nunc pretium mattis. Sed dapibus semper est, sed pretium erat sodales sed. Aenean hendrerit fringilla sem, et tincidunt libero ornare at. </p>\r\n\r\n<br />\r\n\r\n<h2 class="title"><a name="list-bullets" href="#list-bullets">List Styles - Bullets</a></h2>\r\n\r\n<div class="rt-demo-grid-4">\r\n<ul>\r\n	<li><em>This is an example of a standard list style.</em> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu.</li>\r\n	<li><em>This is an example of a standard list style.</em> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu.</li>\r\n</ul>\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n<ul>\r\n	<li><em>This is an example of a standard list style.</em> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu.</li>\r\n	<li><em>This is an example of a standard list style.</em> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu.</li>\r\n</ul>\r\n</div>\r\n\r\n<div class="clear"></div><br />\r\n\r\n<h2 class="title"><a name="icon-bullets" href="#icon-bullets">List Styles - Icons</a></h2>\r\n\r\n<div class="rt-demo-grid-4">\r\n  <ul class="list-icon email">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon email</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon email</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon phone">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon phone</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon phone</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon quote">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon quote</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon quote</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon cart">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon cart</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon cart</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon rss">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon rss</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon rss</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon tags">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon tags</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon tags</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon write">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon write</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon write</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon info">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon info</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon info</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon sound">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon sound</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon sound</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon rightarrow">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon rightarrow</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon rightarrow</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon leftarrow">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon leftarrow</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon leftarrow</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon circlearrow">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon circlearrow</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon circlearrow</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon dropbox">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon dropbox</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon dropbox</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n<ul class="list-icon vimeo">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon vimeo</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon vimeo</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n  <ul class="list-icon downarrow">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon downarrow</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon downarrow</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon uparrow">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon uparrow</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon uparrow</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon person">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon person</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon person</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon calendar">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon calendar</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon calendar</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon doc">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon doc</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon doc</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon bulb">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon bulb</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon bulb</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon twitter">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon twitter</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon twitter</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon youtube">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon youtube</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon youtube</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon skype">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon skype</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon skype</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon facebook">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon facebook</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon facebook</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon like">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon like</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon like</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n  <ul class="list-icon video">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon video</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon video</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n<ul class="list-icon paypal">\r\n    <li>To use this style create a list in the following format: <strong>&lt;ul class="</strong><em class="normal">list-icon paypal</em><strong>"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong>.</li>\r\n    <li>To use this style create a list in the following format: <strong>&#91;list class="<em class="normal">list-icon paypal</em>"&#93;&#91;li&#93;...&#91;/li&#93;&#91;li&#93;...&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>.</li>\r\n  </ul>\r\n  <br />\r\n</div>\r\n<div class="clear"></div>\r\n\r\n<p>To replicate, the following format: <strong>&lt;span class="text-icon iconname"&gt;...&lt;/span&gt; (HTML)</strong> or <strong>&#91;icon class=&quot;icon name&quot;&#93;...&#91;/icon&#93; (ROKCANDY)</strong>. The class names are listed below, such as "<strong>text-icon email</strong>".</p>\r\n\r\n<div class="rt-demo-grid-4">\r\n<span class="text-icon email">A text item with an email icon</span><br /><br />\r\n<span class="text-icon phone">A text item with a phone icon</span><br /><br />\r\n<span class="text-icon quote">A text item with a quote icon</span><br /><br />\r\n<span class="text-icon cart">A text item with a cart icon</span><br /><br />\r\n<span class="text-icon rss">A text item with a rss icon</span><br /><br />\r\n<span class="text-icon tags">A text item with a tags icon</span><br /><br />\r\n<span class="text-icon write">A text item with a write icon</span><br /><br />\r\n<span class="text-icon info">A text item with an info icon</span><br /><br />\r\n<span class="text-icon sound">A text item with a sound icon</span><br /><br />\r\n<span class="text-icon rightarrow">A text item with a rightarrow icon</span><br /><br />\r\n<span class="text-icon leftarrow">A text item with a leftarrow icon</span><br /><br />\r\n<span class="text-icon circlearrow">A text item with a circlearrow icon</span><br /><br />\r\n<span class="text-icon downarrow">A text item with a downarrow icon</span><br /><br />\r\n<span class="text-icon uparrow">A text item with an uparrow icon</span><br /><br />\r\n</div>\r\n\r\n<div class="rt-demo-grid-4">\r\n<span class="text-icon person">A text item with a person icon</span><br /><br />\r\n<span class="text-icon calendar">A text item with a calendar icon</span><br /><br />\r\n<span class="text-icon doc">A text item with a doc icon</span><br /><br />\r\n<span class="text-icon bulb">A text item with a bulb icon</span><br /><br />\r\n<span class="text-icon twitter">A text item with a twitter icon</span><br /><br />\r\n<span class="text-icon youtube">A text item with a youtube icon</span><br /><br />\r\n<span class="text-icon skype">A text item with a skype icon</span><br /><br />\r\n<span class="text-icon facebook">A text item with a facebook icon</span><br /><br />\r\n<span class="text-icon like">A text item with a like icon</span><br /><br />\r\n<span class="text-icon video">A text item with a video icon</span><br /><br />\r\n<span class="text-icon dropbox">A text item with a dropbox icon</span><br /><br />\r\n<span class="text-icon vimeo">A text item with a vimeo icon</span><br /><br />\r\n<span class="text-icon paypal">A text item with a paypal icon</span><br /><br />\r\n</div>\r\n<div class="clear"></div>\r\n\r\n<h2 class="title"><a name="list-standard" href="#list-standard">List Styles - CSS3 Advanced</a></h2>\r\n<p>These list styles are based on the latest CSS3 techniques and are designed to work in modern browsers (will not display properly in IE6-IE8).</p>\r\n\r\n<p>To replicate, use the following format: <strong>&lt;ul class="class name"&gt;&lt;li&gt;....&lt;/li&gt;&lt;li&gt;....&lt;/li&gt;...&lt;/ul&gt; (HTML)</strong> or <strong>&#91;list class=&quot;class name&quot;&#93;&#91;li&#93;....&#91;/li&#93;&#91;li....&#91;/li&#93;&#91;/list&#93; (ROKCANDY)</strong>. The class names are listed below, such as "<strong>checkmark red</strong>".</p>\r\n\r\n<div class="rt-demo-grid-3">\r\n<ul class="checkmark">\r\n<li>Checkmark</li>\r\n<li>Checkmark</li>\r\n<li>Checkmark</li>\r\n</ul>\r\n\r\n<ul class="circle-checkmark">\r\n<li>Circle-Checkmark</li>\r\n<li>Circle-Checkmark</li>\r\n<li>Circle-Checkmark</li>\r\n</ul>\r\n\r\n<ul class="square-checkmark">\r\n<li>Square-Checkmark</li>\r\n<li>Square-Checkmark</li>\r\n<li>Square-Checkmark</li>\r\n</ul>\r\n\r\n<ul class="checkmark green">\r\n<li>Checkmark Green</li>\r\n<li>Checkmark Green</li>\r\n<li>Checkmark Green</li>\r\n</ul>\r\n\r\n<ul class="checkmark yellow">\r\n<li>Checkmark Yellow</li>\r\n<li>Checkmark Yellow</li>\r\n<li>Checkmark Yellow</li>\r\n</ul>\r\n\r\n<ul class="checkmark red">\r\n<li>Checkmark Red</li>\r\n<li>Checkmark Red</li>\r\n<li>Checkmark Red</li>\r\n</ul>\r\n\r\n<ul class="checkmark blue">\r\n<li>Checkmark Blue</li>\r\n<li>Checkmark Blue</li>\r\n<li>Checkmark Blue</li>\r\n</ul>\r\n\r\n<ul class="checkmark white">\r\n<li>Checkmark White</li>\r\n<li>Checkmark White</li>\r\n<li>Checkmark White</li>\r\n</ul>\r\n</div>\r\n\r\n<div class="rt-demo-grid-3">\r\n<ul class="triangle-small">\r\n<li>Triangle-Small</li>\r\n<li>Triangle-Small</li>\r\n<li>Triangle-Small</li>\r\n</ul>\r\n\r\n<ul class="triangle">\r\n<li>Triangle</li>\r\n<li>Triangle</li>\r\n<li>Triangle</li>\r\n</ul>\r\n\r\n<ul class="triangle-large">\r\n<li>Triangle-Large</li>\r\n<li>Triangle-Large</li>\r\n<li>Triangle-Large</li>\r\n</ul>\r\n\r\n<ul class="triangle green">\r\n<li>Triangle Green</li>\r\n<li>Triangle Green</li>\r\n<li>Triangle Green</li>\r\n</ul>\r\n\r\n<ul class="triangle yellow">\r\n<li>Triangle Yellow</li>\r\n<li>Triangle Yellow</li>\r\n<li>Triangle Yellow</li>\r\n</ul>\r\n\r\n<ul class="triangle red">\r\n<li>Triangle Red</li>\r\n<li>Triangle Red</li>\r\n<li>Triangle Red</li>\r\n</ul>\r\n\r\n<ul class="triangle blue">\r\n<li>Triangle Blue</li>\r\n<li>Triangle Blue</li>\r\n<li>Triangle Blue</li>\r\n</ul>\r\n\r\n<ul class="triangle white">\r\n<li>Triangle White</li>\r\n<li>Triangle White</li>\r\n<li>Triangle White</li>\r\n</ul>\r\n</div>\r\n\r\n<div class="rt-demo-grid-3">\r\n<ul class="circle-small">\r\n<li>Circle-Small</li>\r\n<li>Circle-Small</li>\r\n<li>Circle-Small</li>\r\n</ul>\r\n\r\n<ul class="circle">\r\n<li>Circle</li>\r\n<li>Circle</li>\r\n<li>Circle</li>\r\n</ul>\r\n\r\n<ul class="circle-large">\r\n<li>Circle-Large</li>\r\n<li>Circle-Large</li>\r\n<li>Circle-Large</li>\r\n</ul>\r\n\r\n<ul class="circle green">\r\n<li>Circle Green</li>\r\n<li>Circle Green</li>\r\n<li>Circle Green</li>\r\n</ul>\r\n\r\n<ul class="circle yellow">\r\n<li>Circle Yellow</li>\r\n<li>Circle Yellow</li>\r\n<li>Circle Yellow</li>\r\n</ul>\r\n\r\n<ul class="circle red">\r\n<li>Circle Red</li>\r\n<li>Circle Red</li>\r\n<li>Circle Red</li>\r\n</ul>\r\n\r\n<ul class="circle blue">\r\n<li>Circle Blue</li>\r\n<li>Circle Blue</li>\r\n<li>Circle Blue</li>\r\n</ul>\r\n\r\n<ul class="circle white">\r\n<li>Circle White</li>\r\n<li>Circle White</li>\r\n<li>Circle White</li>\r\n</ul>\r\n</div>\r\n\r\n<div class="clear"></div>\r\n<br />\r\n\r\n<h2 class="title"><a name="emphasis" href="#emphasis">Emphasis Styles</a></h2>\r\n\r\n<p>This is a emphasis tag that allows you to <em class="italic">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;italic&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;emphasis&#93;...&#91;/emphasis&#93; (ROKCANDY)</strong></p>\r\n\r\n<p>This is a emphasis tag that allows you to <em class="bold">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;bold&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;emphasisbold&#93;...&#91;/emphasisbold&#93; (ROKCANDY)</strong></p>\r\n\r\n<p>This is a emphasis tag that allows you to <em class="bold2">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;bold2&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;emphasisbold2&#93;...&#91;/emphasisbold2&#93; (ROKCANDY)</strong></p>\r\n\r\n<p>This is a emphasis tag that allows you to <em class="highlight">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;default&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n\r\n<p>This is a emphasis tag that allows you to <em class="highlight white">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight white&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;white&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n\r\n<p>This is a emphasis tag that allows you to <em class="highlight black">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight black&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;black&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n\r\n<p>This is a emphasis tag that allows you to <em class="highlight green">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight green&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;green&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n\r\n<p>This is a emphasis tag that allows you to <em class="highlight yellow">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight yellow&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;yellow&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n\r\n<p>This is a emphasis tag that allows you to <em class="highlight blue">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight blue&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;blue&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n\r\n<p>This is a emphasis tag that allows you to <em class="highlight red">highlight words or phrases</em>. Use the following format: <strong>&lt;em class=&quot;highlight red&quot;&gt;...&lt;/em&gt; (HTML)</strong> or <strong>&#91;highlight class=&quot;red&quot;&#93;...&#91;/highlight&#93; (ROKCANDY)</strong></p>\r\n\r\n<br />\r\n\r\n<h2 class="title"><a name="insets" href="#insets">Inset Styles</a></h2>\r\n\r\n<p>\r\n  Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.\r\n  <span class="inset-right"><span class="inset-right-title">Inset Right Title</span>You will need to use the following formatting: <strong>&lt;span class=&quot;inset-right&quot;&gt; &lt;span class=&quot;inset-right-title&quot;&gt; .... &lt;/span&gt; <em class="normal"> ... some content ... </em>&lt;/strong&gt; (HTML)</strong> or <strong>&#91;inset side="right" title="Inset Right Title"&#93; ... some content ...&#91;/inset&#93; (ROKCANDY)</strong></span>\r\n  Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.\r\n</p>\r\n\r\n<p>\r\n  Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.\r\n  <span class="inset-left"><span class="inset-left-title">Inset Left Title</span>You will need to use the following formatting: <strong>&lt;span class=&quot;inset-left&quot;&gt; &lt;span class=&quot;inset-left-title&quot;&gt; .... &lt;/span&gt; <em class="normal"> ... some content ... </em>&lt;/strong&gt; (HTML)</strong> or <strong>&#91;inset side="left" title="Inset Left Title"&#93; ... some content ...&#91;/inset&#93; (ROKCANDY)</strong></span>\r\n  Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Sed euismod magna a nibh.</p>\r\n\r\n<p>Sed euismod magna a nibh. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque.</p> \r\n<p>Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.Praesent rutrum sapien ac felis. Phasellus elementum dolor quis turpis. Vestibulum nec mi vitae pede tincidunt nonummy. Vestibulum facilisis mollis neque. Sed orci. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus.\r\n</p>\r\n\r\n<div class="clear"></div>\r\n\r\n<h2 class="title"><a name="notice" href="#notice">Notice Styles</a></h2>\r\n\r\n<p class="approved">This is a <a href="javascript:void(0);">sample</a> of the <em>Approved</em> style. To replicate, use the following html: <em>&lt;p class="approved"&gt;....&lt;/p&gt;</em> (HTML) or <em>&#91;notice class="approved"&#93; <em class="normal">...</em> &#91;/notice&#93;</em> (ROKCANDY).</p>\r\n\r\n<p class="attention">This is a <a href="javascript:void(0);">sample</a> of the <em>Attention</em> style. To replicate, use the following html: <em>&lt;p class="attention"&gt;....&lt;/p&gt;</em> (HTML) or <em>&#91;notice class="attention"&#93; <em class="normal">...</em> &#91;/notice&#93;</em> (ROKCANDY).</p>\r\n\r\n<p class="notice">This is a <a href="javascript:void(0);">sample</a> of the <em>Notice</em> style. To replicate, use the following html: <em>&lt;p class="notice"&gt;....&lt;/p&gt;</em> (HTML) or <em>&#91;notice class="notice"&#93; <em class="normal">...</em> &#91;/notice&#93;</em> (ROKCANDY).</p>\r\n\r\n<p class="alert">This is a <a href="javascript:void(0);">sample</a> of the <em>Alert</em> style. To replicate, use the following html: <em>&lt;p class="alert"&gt;....&lt;/p&gt;</em> (HTML) or <em>&#91;notice class="alert"&#93; <em class="normal">...</em> &#91;/notice&#93;</em> (ROKCANDY).</p>\r\n\r\n<br />\r\n<h2 class="title"><a href="#using-typography" name="using-typography">Using Typography</a></h2>\r\n\r\n<p class="notice">If you are using the TinyMCE editor, go to <strong>Extensions &rarr; Plugin Manager &rarr; TinyMCE 2.0 &rarr; Set Code Clean-up on Save to Never</strong>.</p>\r\n\r\n<h3>Typography - RokCandy</h3>\r\n\r\n<p>In this example, we will use the Attention Span Style - Syntax: <strong>&#91;div class="attention" class2="typo-icon"&#93;...&#91;/div&#93;</strong> syntax.</p>\r\n\r\n<ul class="triangle normalfont">\r\n  <li>Go to <strong>Content &rarr; Article Manager &rarr; Select an Article</strong>.</li>\r\n  <li>Insert <strong>&#91;div class="attention" class2="typo-icon"&#93;</strong> <em>.... some content ....</em> <strong>&#91;/div&#93;</strong></li>\r\n  <li>Save</li>\r\n</ul>\r\n\r\n<h3>Typography - HTML</h3>\r\n\r\n<p>In this example, we will use the Attention Span Style - Syntax: <strong>&lt;div class=&quot;attention&quot;&gt;&lt;div class=&quot;typo-icon&quot;&gt;...&lt;/div&gt;&lt;/div&gt;</strong> syntax.</p>\r\n\r\n<p><em class="bold2">Content Editor</em></p>\r\n\r\n<ul class="triangle normalfont">\r\n  <li>Go to <strong>Content &rarr; Article Manager &rarr; Select an Article</strong>; or <strong>Extensions &rarr; Module Manager &rarr; A Module, for a custom module.</strong></li>\r\n  <li>Click the <strong>HTML mode</strong> or equivalent in your editor</li>\r\n  <li>Insert <strong>&lt;div class=&quot;attention&quot;&gt;&lt;div class=&quot;typo-icon&quot;&gt; ... some content ... &lt;/div&gt;&lt;/div&gt;</strong></li>\r\n  <li>Save</li>\r\n</ul>\r\n\r\n<p><em class="bold2">No Editor</em></p>\r\n\r\n<ul class="triangle normalfont">\r\n  <li>Go to <strong>Content &rarr; Article Manager &rarr; Select an Article</strong>; or <strong>Extensions &rarr; Module Manager &rarr; A Module, for a custom module.</strong></li>\r\n  <li>Click the <strong>HTML mode</strong> or equivalent in your editor</li>\r\n  <li>Insert <strong>&lt;div class=&quot;attention&quot;&gt;&lt;div class=&quot;typo-icon&quot;&gt; ... some content ... &lt;/div&gt;&lt;/div&gt;</strong></li>\r\n  <li>Save</li>\r\n</ul>\r\n\r\n<p class="attention">Note, with the Content Editor (WYSIWYG) enabled, you need to enter HTML mode.</p>', '', 1, 0, 0, 10, '2011-12-15 14:55:38', 42, '', '2011-12-29 02:26:23', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:55:38', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 5, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(5, 43, 'Integrated Extensions', 'integrated-extensions', '', '<p>Halcyon has styled support for the following RocketTheme extensions: <strong>RokTabs</strong>, <strong>RokNewsPager</strong>, <strong>RokFeatureTable</strong>, <strong>RokAjaxSearch</strong>, <strong>RokStories</strong> and <strong>RokNavMenu</strong></p>\r\n\r\n<p>For details on these extensions, how they are configured and styled for this template, please refer to the menu links above.</p>\r\n\r\n<h3>Further Documentation</h3>\r\n\r\n<p>All our Extensions have informative details located under the Extensions tab on the RocketTheme site. Here you will find general information on the addon, its features, screenshots, installation instructions and any relevant documentation pertaining to use, configuring or customizing the extension.</p>\r\n\r\n<a href="http://www.rockettheme.com/extensions-joomla" target="_blank" class="readon"><span>More Information</span></a>', '', 1, 0, 0, 10, '2011-12-15 14:55:53', 42, '', '2011-12-29 02:26:23', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:55:53', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 6, '', '', 1, 11, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(6, 44, 'Tutorials and Guides', 'tutorials-and-guides', '', '<p class="attention">Go to <strong>Extensions → Template Manager → <em>(J15) rt_halcyon_j15 or (J17) rt_halcyon</em></strong>. Mouseover the labels to view a description of each parameter.</p>\r\n\r\n<p><em class="bold2">General Documentation</em></p>\r\n\r\n<p>There are several sites which offer a range of useful resources for using Joomla, beyond the specifics of the template:</p>\r\n\r\n<ul class="dots">\r\n	<li><a href="http://help.joomla.org" target="_blank" class="normalfont">http://help.joomla.org</a> — Basic Joomla Documentation</li>\r\n	<li><a href="http://help.joomla.org" target="_blank" class="normalfont">http://docs.joomla.org</a> — Joomla Documentation Wiki</li>\r\n	<li><a href="http://help.joomla.org" target="_blank" class="normalfont">http://forum.joomla.org</a> — Joomla Community Forum</li>\r\n</ul>', '', 1, 0, 0, 10, '2011-12-15 14:56:08', 42, '', '2011-12-30 17:41:32', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:56:08', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 4, 0, 7, '', '', 1, 9, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(7, 45, 'Installation Instructions', 'installation-instructions', '', '<p class="notice"><strong>Note:</strong> The <strong>Bundle</strong> Template is only necessary if the Gantry Library is not installed at <strong>/components/com_gantry (J15)</strong> or <strong>/libraries/gantry (J17)</strong>.</p>\r\n\r\n<h3>Step 1 - Installation</h3>\r\n\r\n<ul class="dots">\r\n	<li><strong>(J15)</strong> Install from <strong>Admin &rarr; Extensions &rarr; Install/Uninstall &rarr; Choose File &rarr; Select file &rarr; Upload File &amp; Install</strong></li>\r\n	<li><strong>(J17)</strong> Install from <strong>Admin &rarr; Extensions &rarr; Extensions Manager &rarr; Choose File &rarr; Select file &rarr; Upload File &amp; Install</strong></li>	\r\n</ul>\r\n\r\n<p class="rt-relative">\r\n	<span class="rt-install1-j15">rt_halcyon_j15.tgz</span>\r\n	<span class="rt-install1-j17">rt_halcyon.zip</span>\r\n	<img width="275" height="160" class="rt-image floatleft" alt="Image" src="images/stories/demo/general/install1-j15.jpg" />\r\n	<img width="275" height="160" class="rt-image" alt="Image" src="images/stories/demo/general/install1-j17.jpg" />\r\n</p>\r\n\r\n<div class="clear"></div>\r\n\r\n<h3>Step 1 - Template Default</h3>\r\n\r\n<ul class="dots">\r\n	<li><strong>(J15)</strong> Make the template default at <strong>Admin &rarr; Extensions &rarr; Template Manager &rarr; rt_halcyon_j15 &rarr; Default</strong></li>\r\n	<li><strong>(J17)</strong> Make the template default at <strong>Admin &rarr; Extensions &rarr; Template Manager &rarr; rt_halcyon &rarr; Make Default</strong></li>	\r\n</ul>\r\n\r\n<p class="rt-relative">\r\n	<span class="rt-install2-j15">rt_halcyon_j15</span>\r\n	<span class="rt-install2-j17">rt_halcyon - Default <span class="rt-install2-j17a">Master</span></span>\r\n	<img width="275" height="314" class="rt-image floatleft" alt="Image" src="images/stories/demo/general/install2-j15.jpg" />\r\n	<img width="275" height="314" class="rt-image" alt="Image" src="images/stories/demo/general/install2-j17.jpg" />\r\n</p>\r\n\r\n<div class="clear"></div>\r\n\r\n<h2 class="title">RocketLauncher Instructions</h2>\r\n\r\n<p class="attention"><strong>Note</strong>: All sample content images will be replaced with blank versions in the RocketLauncher version.</p>\r\n\r\n<p><strong>RocketLauncher</strong> is a customized <strong>Joomla</strong> install, that installs a <strong>replica</strong> of the <strong>demo</strong> onto your site - inclusive of sample data, content, extensions, the template and sample images.</p>\r\n\r\n<p>We always recommend installing a RocketLauncher first to trial and understand the template more efficiently. It must be installed as <strong>new</strong>, and <strong>not</strong> over an existing Joomla install.</p>\r\n\r\n<h3>Step 1 - Upload</h3>\r\n\r\n<ul class="dots">\r\n	<li><strong>Download</strong> the RocketLauncher</li>\r\n	<li><strong>Unzip</strong></li>\r\n	<li><strong>Upload</strong> the created folder to your server</li>\r\n</ul>\r\n\r\n<p class="notice"><strong>Note:</strong> You can upload all the files via FTP, or use cPanel or SSH to upload the zip and unzip directly onto the server. Enquire with your hosting provider.</p>\r\n\r\n<h3>Step 2 - Installation</h3>\r\n\r\n<ul class="dots">\r\n	<li>Go to <a href="#">www.yoursite.com/<em>*folder name*</em></a></li>\r\n	<li>Follow the Installation instructions</li>\r\n	<li>Ensure you click <em class="bold2">Install Sample Data</em> during installation</li>\r\n	<li><strong>(J15)</strong> Delete the <strong>/installation</strong> directory on your server</li>\r\n	<li><strong>(J17)</strong> Remove the installation folder in the Installation interface</li>\r\n</ul>', '', 1, 0, 0, 10, '2011-12-15 14:56:23', 42, '', '2011-12-30 17:42:43', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:56:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 8, '', '', 1, 10, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(8, 46, 'Menu Options', 'menu-options', '', '<p class="alert">Please ensure you are using the latest version of RokNavMenu, available <a href="http://www.rockettheme.com/extensions-joomla/roknavmenu" target="_blank">here</a>.</p>\r\n\r\n<p>To find all the parameters for Fusion Menu and Splitmenu, such as transitions, duration and sublevel position, go to:</p>\r\n\r\n<ul class="dots">\r\n	<li><strong>(J15) Extensions &rarr; Template Manager &rarr; rt_halcyon_j15 &rarr; Menu &rarr; Menu Control &rarr; <em>Set Menu Type</em></strong></li>\r\n	<li><strong>(J17) Extensions &rarr; Template Manager &rarr; rt_halcyon &rarr; Menu &rarr; Menu Control &rarr; <em>Set Menu Type</em></strong></li>\r\n</ul>\r\n\r\n<p class="attention">Descriptions of each template parameter can be seen when you mouseover the label of each option.</p>\r\n\r\n<h2 class="title">Fusion with MegaMenu</h2>\r\n\r\n<p><strong>Fusion Menu</strong> is a menu theme of the <strong>RokNavMenu</strong> extension, the addon that drives all RocketTheme template menus. It is primarily a javascript enhanced CSS dropdown menu, that combines standard suckerfish type functionality with animations, transitions and other advanced effects powered by Mootools.</p>\r\n\r\n<div class="rt-demo-grid-3 nomarginleft">\r\n<ul class="triangle green normalfont">\r\n	<li>1/2/3/4 Column Modes</li>\r\n	<li>Custom Column Widths</li>\r\n	<li>Custom Menu Width</li>\r\n	<li>Menu Item Grouping</li>\r\n	<li>Item Distribution Controls</li>\r\n</ul>\r\n</div>\r\n<div class="rt-demo-grid-3">\r\n<ul class="triangle green normalfont">\r\n	<li>Animation Controls</li>\r\n	<li>Transition Controls</li>\r\n	<li>Duration/Delay Controls</li>\r\n	<li>Opacity Controls</li>\r\n	<li>Per Item Styling</li>\r\n</ul>\r\n</div>\r\n<div class="rt-demo-grid-3 nomarginright">\r\n<ul class="triangle green normalfont">\r\n	<li>Inline Modules</li>\r\n	<li>Inline Positions</li>\r\n	<li>Menu Item Subtext</li>\r\n	<li>Menu Item Icons</li>\r\n</ul>\r\n</div>\r\n<div class="clear"></div>\r\n\r\n<p class="notice">All Menu Items can be edited from <strong>Admin &rarr; Menu &rarr; <em>Menu Name</em> &rarr; <em>Menu Item</em></strong>.</p>\r\n\r\n<h3>Basic Fusion Parameters</h3>\r\n\r\n<ul class="dots">\r\n	<li><em class="bold">Subtext</em> is the option that allows you to insert additional text to the <strong>Menu Item Title</strong>. There is separate styling for this, making it useful for adding brief descriptions to menu items.</li>\r\n	<li><em class="bold">Menu Icon</em> is the option that allows you to insert an inline icon / image to the <strong>Menu Item</strong>.</li>\r\n</ul>\r\n\r\n<h3>Advanced Fusion Parameters: Columns</h3>\r\n\r\n<p><em class="bold2">Menu Columns</em></p>\r\n\r\n<p><strong>Columns of Child Items</strong> allows you to determine how many columns the <strong>Fusion</strong> dropdowns are presented in. You can have anywhere between a <strong>single dropdown</strong> to a <strong>four column</strong> dropdown.</p>\r\n\r\n<p><em class="bold2">Item Distribution</em></p>\r\n\r\n<p><strong>Item Distribution</strong> allows you to control how the menu items are ordered in the dropdowns:</p>\r\n\r\n<ul class="dots">\r\n	<li><strong>Evenly:</strong> If there are <strong>7</strong> menu items in <strong>3</strong> columns, Fusion will allocate a <em class="bold">3,2,2</em> distribution - trying to equalize each dropdown.</li>\r\n	<li><strong>Order:</strong> If there are <strong>7</strong> menu items in <strong>3</strong> columns, Fusion will allocate a <em class="bold">3,3,1</em> distribution - maintaining the item ordering.</li>\r\n	<li><strong>Manually:</strong> Determine the exact distribution of items across all columns in the <strong>Manual Item Distribution</strong> field. For example, if there are <strong>7</strong> menu items in <strong>3</strong> columns, you can specify a <em class="bold">4,2,1</em> distribution.</li>\r\n</ul>\r\n\r\n<p class="notice"><strong>NOTE:</strong> If your <strong>Columns of Child Items</strong> setting is configured to be 2 or more columns, you will need to manually set the column widths and distribution, as outlined below. The default is 180px which is too small for multiple columns.</p>\r\n\r\n<p><em class="bold2">Drop-Down Width (px)</em></p>\r\n\r\n<p><strong>Drop-Down Width (px)</strong> determines the total width of the dropdown, regardless of how many columns are shown. This option is to be used in conjunction with <strong>Column Widths (px)</strong></p>\r\n\r\n<p><em class="bold2">Column Widths (px)</em></p>\r\n\r\n<p><strong>Column Widths (px)</strong> determines the width of each Column. Separate each width by a comma. The final column''s width is determined automatically. This option is to be used in conjunction with <strong>Drop-Down Width (px)</strong></p>\r\n\r\n<p>Below are some example configurations:</p>\r\n\r\n<ul class="dots">\r\n	<li><strong>Drop-Down Width: 480px:</strong> <em>160,160</em>. Fusion automatically calculates the final width as <strong>160</strong>, so in practise, <em>160,160,160</em> is the actual distribution.</li>\r\n	<li><strong>Drop-Down Width: 600px:</strong> <em>160,160</em>. Fusion automatically calculates the final width as <strong>280</strong>, so in practise, <em>160,160,280</em> is the actual distribution.</li>\r\n</ul>\r\n\r\n<h3>Advanced Fusion Parameters: Groupings</h3>\r\n\r\n<p><em class="bold2">What is Grouping?</em></p>\r\n\r\n<p><strong>Group Child Items</strong> changes the behaviour of child items in the dropdown menus, instead of creating a dropdown for the immediate sublevel, this option places them inline. See below for an illustrated example of the differences:</p>\r\n\r\n<p><em class="bold2">Configuration</em></p>\r\n\r\n<p class="attention"><strong>NOTE:</strong> Grouping cannot be applied to <strong>root</strong> items, only <strong>child</strong> items.</p>\r\n\r\n<p>Set <strong>Group Child Items</strong> to Yes to activate the mode. The sublevels well then appear below the parent menu item in a categorical type structure.</p>\r\n\r\n<h3>Advanced Fusion Parameters: Modules</h3>\r\n\r\n<p><strong>Fusion</strong> is now capable of loading individual modules or entire module positions inside its dropdowns.</p>\r\n\r\n<ul class="dots">\r\n	<li><em class="bold">Inline Modules:</em> Set <strong>Child Item Type</strong> to <strong>Modules</strong> to load all modules setup on your Joomla site in a list. Select the module you wish to display in the dropdown.</li>\r\n	<li><em class="bold">Inline Positions:</em> Set <strong>Child Item Type</strong> to <strong>Modules Positions</strong> to load all module positions on your Joomla site in a list. Select the position you wish to display in the dropdown.</li>\r\n</ul>\r\n\r\n<h2 class="title">Splitmenu</h2>\r\n\r\n<p>A static menu system that displays 1st and 2nd level items in the main horizontal menu and further children in the Sidebar.</p>\r\n\r\n<ul class="dots">\r\n	<li><em class="bold">Subtext</em> is the option that allows you to insert additional text to the <strong>Menu Item Title</strong>. There is separate styling for this, making it useful for adding brief descriptions to menu items.</li>\r\n</ul>\r\n\r\n<p><em class="bold2">Code Modification: Remove the <em class="normal">Menu</em> in the Title</em></p>\r\n\r\n<p><strong>(J15)</strong> Open <strong>/templates/rt_halcyon_j15/html/modules.php</strong>:</p>\r\n<p><strong>(J17)</strong> Open <strong>/templates/rt_halcyon/html/modules.php</strong>:</p>\r\n\r\n<p>Change</p>\r\n\r\n<pre class="lines">\r\n&lt;?php echo $menu_title_item-&gt;name.&#x27; &#x27;.JText::_(&#x27;Menu&#x27;); ?&gt;\r\n</pre>\r\n\r\n<p>To</p>\r\n\r\n<pre class="lines">\r\n&lt;?php echo $menu_title_item-&gt;name; ?&gt;\r\n</pre>\r\n\r\n<p>Or delete the entire line.</p>\r\n\r\n<h2 class="title">Creating Child / Sublevel menu items</h2>\r\n\r\n<p>Go to <strong>Admin &rarr; Menu &rarr; <em>A Menu</em> &rarr; <em>A Menu Item</em> &rarr; Select a <em>Parent Item</em></strong>, and it will appear as a child of it.</p>\r\n\r\n<p>\r\n	<img src="images/stories/demo/menu/tut-menu-29.jpg" alt="Image" width="270" height="212" class="rt-image floatleft" />\r\n	<img src="images/stories/demo/menu/tut-menu-30.jpg" alt="Image" width="270" height="212" class="rt-image" />	\r\n</p>\r\n\r\n<p>\r\n	<img src="images/stories/demo/menu/tut-menu-29-j17.jpg" alt="Image" width="270" height="212" class="rt-image floatleft" />\r\n	<img src="images/stories/demo/menu/tut-menu-30-j17.jpg" alt="Image" width="270" height="212" class="rt-image" />	\r\n</p>', '', 1, 0, 0, 10, '2011-12-15 14:56:35', 42, '', '2011-12-30 17:43:57', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:56:35', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 9, '', '', 1, 20, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(9, 47, 'Logo Editing', 'logo-editing', '', '<p class="notice">Gantry sets the dimensions of the logo, so CSS modification is unnecessary.</p>\r\n\r\n<h3>Step 1 - Open the File</h3>\r\n\r\n<img src="images/stories/demo/logo/logo1.jpg" alt="Logo" width="215" height="73" class="rt-image floatleft" />\r\n\r\n<p style="margin-left: 210px;">Open the <strong>logo-source.png</strong> file in Adobe&reg; Fireworks.</p>\r\n\r\n<ul class="list-icon rightarrow" style="margin-left: 210px;">\r\n	<li>In the right column, find <strong>Layers</strong>. Select the <strong>Web layers</strong> directory and click the eye icon to the left of the logo slice (the green object). This will make the slice invisible so you can edit the file.</li>\r\n</ul>\r\n\r\n<div class="clear"></div><br />\r\n\r\n<h3 class="nomargintop">Step 2 - Text/Slogan/Icon Editing</h3>\r\n\r\n<p>Double click on the logo text. Now you can edit the text of logo to your choosing. Edit the icon as desired.</p>\r\n<img src="images/stories/demo/logo/logo2.jpg" alt="Logo" width="215" height="73" class="rt-image floatleft" />\r\n<img src="images/stories/demo/logo/logo3.jpg" alt="Logo" width="215" height="73" class="rt-image floatleft" />\r\n<div class="clear"></div>\r\n<br />\r\n<img src="images/stories/demo/logo/logo4.jpg" alt="Logo" width="215" height="73" class="rt-image floatleft" />\r\n<img src="images/stories/demo/logo/logo5.jpg" alt="Logo" width="215" height="73" class="rt-image floatleft" />	\r\n\r\n<div class="clear"></div><br />\r\n\r\n<img src="images/stories/demo/logo/logo6.jpg" alt="Logo" width="215" height="73" class="rt-image floatleft largemarginbottom" />\r\n\r\n<h3 class="nomargintop">Step 3 - Slice Modification</h3>\r\n\r\n<ul class="list-icon rightarrow" style="margin-left: 210px;">\r\n	<li>Reactivate the Slice in the Web Layers column, this will place a green rectangle over the logo image. Change the size of the slice (or move it) to match the new size if applicable.</li>\r\n</ul>\r\n<div class="clear"></div>\r\n\r\n<div class="clear"></div><br />\r\n\r\n<img src="images/stories/demo/logo/logo7.jpg" alt="Logo" width="215" height="73"  class="rt-image floatleft largemarginbottom" />\r\n\r\n<h3 class="nomargintop">Step 4 - Export</h3>\r\n\r\n<ul class="list-icon rightarrow" style="margin-left: 210px;">\r\n	<li>Now you will want to export the logo. Right click on the image slice and select <strong>Exported Selected Slices...</strong> from the contextual menu. Proceed to export it to your computer for uploading.</li>\r\n</ul>\r\n<div class="clear"></div>\r\n\r\n<h3>Step 5 - Multiple Frames/States</h3>\r\n<p>If there are multiple logos for a template, they are located in <strong>Frames</strong> or <strong>States</strong> within Fireworks.</p>\r\n<p class="nomarginbottom">\r\n	<img src="images/stories/demo/logo/logo-frame1.jpg" alt="Logo" width="258" height="152" class="rt-image floatleft nomarginbottom" />\r\n	<img src="images/stories/demo/logo/logo-frame2.jpg" alt="Logo" width="258" height="152" class="rt-image floatnone nomarginbottom" /></p>\r\n<div class="clear"></div>', '', 1, 0, 0, 10, '2011-12-15 14:56:50', 42, '', '2011-12-30 18:07:31', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:56:50', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 10, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(10, 48, 'Preset Styles', 'preset-styles', '', '<p class="attention">Access the Style Control settings from: <strong>Admin → Extensions → Template Manager → <em>(J15) rt_halcyon_j15</em> or <em>(J17) rt_halcyon</em> → Settings</strong></p>\r\n\r\n<p>Simple configure the options, then save and Gantry will automatically load the modified preset to your site.</p>\r\n\r\n<h3>Color Chooser Settings</h3>\r\n\r\n<p>A Color Chooser template uses CSS color values, combined with transparent overlay images, to determine its color and style. Therefore, you can change the entire color scheme via the Gantry Administrator. The available options are outlined below:</p>\r\n\r\n<ul class="dots">\r\n	<li><strong>Top Colors:</strong> Color <em>HEX value</em>; Overlay <em>Light/Dark</em>; Link <em>HEX value</em></li>\r\n	<li><strong>Main Colors:</strong> Body Style <em>Light/Dark</em>; Color Style <em>Light Blue, Blue, Red, Green, Pink, Orange &amp; Purple</em></li>\r\n	<li><strong>Bottom Colors:</strong> Color <em>HEX value</em>; Overlay <em>Light/Dark</em>; Link <em>HEX value</em></li>\r\n</ul>\r\n\r\n<h3>Style Settings</h3>\r\n\r\n<ul class="dots">\r\n	<li><strong>Read More Style:</strong> <em>Button and Link</em>; Set the read more link styling for the template</li>\r\n	<li><strong>Load Transition:</strong> On - Off; Enable or disable the page loading transition animation effects</li>\r\n	<li><strong>Web Fonts:</strong> <em>On - Off, Google Font Directory</em>; WebFonts allow you to use 3rd party WebFonts from providers such as Google. You must SAVE then APPLY before the new fonts will show up in the Font Family dropdown.</li>\r\n	<li><strong>Font Settings</strong>: Select a font family from the available options and also choose a default font size\r\n		<ul>\r\n			<li><strong>Font Family:</strong> Halcyon, Geneva, Optima, Helvetica, Trebuchet, Lucida, Georgia, Palatino, or <strong>Various Google Fonts</strong> <em>(dropdown)</em></li>\r\n			<li><strong>Font Size:</strong> Default, Extra Large, Large, Small, Extra Small <em>(dropdown)</em></li>\r\n		</ul>\r\n	</li>\r\n</ul>\r\n\r\n<div class="module-title"><h2 class="title">Assigning a Style to a Specific Page</h2><div class="clear"></div></div>\r\n\r\n<p>With Gantry, the ability to assign a certain style to an individual page has never been easier and/or more efficient. Just follow these simple steps:</p>\r\n\r\n<ul class="dots">\r\n	<li><strong>(J15)</strong> Go to <strong>Extensions → Template Manager → rt_halcyon_j15 &rarr; Menu Items &rarr; <em>*Menu Item*</em></strong></li>\r\n	<li><strong>(J17)</strong> Go to <strong>Extensions → Template Manager → rt_halcyon &rarr; Assignments &rarr; <em>*Menu Item*</em></strong><br /><br /></li>	\r\n\r\n	<li><strong>(J15)</strong> Select your preset from <strong>Presets → Style Presets</strong>, configure and save.</li>\r\n	<li><strong>(J17)</strong> Select your preset from <strong>Show Presets</strong>, configure and save.</li>\r\n</ul>\r\n\r\n<a href="http://gantry-framework.org/documentation/joomla/configure/per-menu-item-configuration" class="readon"><span>Gantry Framework: Per Menu Item Controls</span></a>', '', 1, 0, 0, 10, '2011-12-15 14:57:02', 42, '', '2011-12-30 17:44:21', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:57:02', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 11, '', '', 1, 11, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(11, 49, 'Sample Content', 'sample-content', '', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede. Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus. Sed venenatis. Donec nec dolor vitae mauris dapibus ullamcorper. Etiam iaculis mollis tortor.</p>\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi. Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consectetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>\r\n\r\n<p>Mauris lobortis. Aliquam lacinia purus. Pellentesque magna. Mauris euismod metus nec tortor. Phasellus elementum, quam a euismod imperdiet, ligula felis faucibus enim, eu malesuada nunc felis sed turpis. Morbi convallis luctus tortor. Integer bibendum lacinia velit. Suspendisse mi lorem, porttitor ut, interdum et, lobortis a, lectus. Phasellus vitae est at massa luctus iaculis. In tincidunt.</p>\r\n\r\n<p>Nullam eget neque. Nullam imperdiet venenatis ligula. Integer a leo. Nunc consectetur. Maecenas sem. Proin vulputate, massa vel volutpat laoreet, purus erat pretium ligula, eget varius arcu nibh sed libero. Fusce ante. Nullam interdum aliquet metus. Ut ultrices vestibulum tellus. Praesent quis erat. Nam id turpis sit amet neque cursus luctus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Quisque id tortor. In vitae sapien. Nunc quis tellus.</p>', '', 1, 0, 0, 10, '2011-12-15 14:57:15', 42, '', '2011-12-29 02:26:23', 42, 0, '0000-00-00 00:00:00', '2011-12-15 14:57:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 12, '', '', 1, 17, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(12, 51, 'Sample Content 01', 'sample-content-01', '', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede. Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus. Sed venenatis. Donec nec dolor vitae mauris dapibus ullamcorper. Etiam iaculis mollis tortor.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi. Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consectetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>\r\n\r\n<p>Mauris lobortis. Aliquam lacinia purus. Pellentesque magna. Mauris euismod metus nec tortor. Phasellus elementum, quam a euismod imperdiet, ligula felis faucibus enim, eu malesuada nunc felis sed turpis. Morbi convallis luctus tortor. Integer bibendum lacinia velit. Suspendisse mi lorem, porttitor ut, interdum et, lobortis a, lectus. Phasellus vitae est at massa luctus iaculis. In tincidunt.</p>\r\n\r\n<p>Nullam eget neque. Nullam imperdiet venenatis ligula. Integer a leo. Nunc consectetur. Maecenas sem. Proin vulputate, massa vel volutpat laoreet, purus erat pretium ligula, eget varius arcu nibh sed libero. Fusce ante. Nullam interdum aliquet metus. Ut ultrices vestibulum tellus. Praesent quis erat. Nam id turpis sit amet neque cursus luctus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Quisque id tortor. In vitae sapien. Nunc quis tellus.</p>', 1, 0, 0, 11, '2011-12-15 15:34:58', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2011-12-15 15:34:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(13, 52, 'Sample Content 02', 'sample-content-02', '', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede. Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus. Sed venenatis. Donec nec dolor vitae mauris dapibus ullamcorper. Etiam iaculis mollis tortor.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi. Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consectetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>\r\n\r\n<p>Mauris lobortis. Aliquam lacinia purus. Pellentesque magna. Mauris euismod metus nec tortor. Phasellus elementum, quam a euismod imperdiet, ligula felis faucibus enim, eu malesuada nunc felis sed turpis. Morbi convallis luctus tortor. Integer bibendum lacinia velit. Suspendisse mi lorem, porttitor ut, interdum et, lobortis a, lectus. Phasellus vitae est at massa luctus iaculis. In tincidunt.</p>\r\n\r\n<p>Nullam eget neque. Nullam imperdiet venenatis ligula. Integer a leo. Nunc consectetur. Maecenas sem. Proin vulputate, massa vel volutpat laoreet, purus erat pretium ligula, eget varius arcu nibh sed libero. Fusce ante. Nullam interdum aliquet metus. Ut ultrices vestibulum tellus. Praesent quis erat. Nam id turpis sit amet neque cursus luctus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Quisque id tortor. In vitae sapien. Nunc quis tellus.</p>', 1, 0, 0, 11, '2011-12-15 15:34:58', 42, '', '2011-12-15 15:35:36', 42, 0, '0000-00-00 00:00:00', '2011-12-15 15:34:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(14, 53, 'Sample Content 03', 'sample-content-03', '', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede. Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus. Sed venenatis. Donec nec dolor vitae mauris dapibus ullamcorper. Etiam iaculis mollis tortor.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi. Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consectetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>\r\n\r\n<p>Mauris lobortis. Aliquam lacinia purus. Pellentesque magna. Mauris euismod metus nec tortor. Phasellus elementum, quam a euismod imperdiet, ligula felis faucibus enim, eu malesuada nunc felis sed turpis. Morbi convallis luctus tortor. Integer bibendum lacinia velit. Suspendisse mi lorem, porttitor ut, interdum et, lobortis a, lectus. Phasellus vitae est at massa luctus iaculis. In tincidunt.</p>\r\n\r\n<p>Nullam eget neque. Nullam imperdiet venenatis ligula. Integer a leo. Nunc consectetur. Maecenas sem. Proin vulputate, massa vel volutpat laoreet, purus erat pretium ligula, eget varius arcu nibh sed libero. Fusce ante. Nullam interdum aliquet metus. Ut ultrices vestibulum tellus. Praesent quis erat. Nam id turpis sit amet neque cursus luctus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Quisque id tortor. In vitae sapien. Nunc quis tellus.</p>', 1, 0, 0, 11, '2011-12-15 15:34:58', 42, '', '2011-12-15 15:35:46', 42, 0, '0000-00-00 00:00:00', '2011-12-15 15:34:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(15, 54, 'Sample Content 04', 'sample-content-04', '', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede. Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus. Sed venenatis. Donec nec dolor vitae mauris dapibus ullamcorper. Etiam iaculis mollis tortor.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi. Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consectetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>\r\n\r\n<p>Mauris lobortis. Aliquam lacinia purus. Pellentesque magna. Mauris euismod metus nec tortor. Phasellus elementum, quam a euismod imperdiet, ligula felis faucibus enim, eu malesuada nunc felis sed turpis. Morbi convallis luctus tortor. Integer bibendum lacinia velit. Suspendisse mi lorem, porttitor ut, interdum et, lobortis a, lectus. Phasellus vitae est at massa luctus iaculis. In tincidunt.</p>\r\n\r\n<p>Nullam eget neque. Nullam imperdiet venenatis ligula. Integer a leo. Nunc consectetur. Maecenas sem. Proin vulputate, massa vel volutpat laoreet, purus erat pretium ligula, eget varius arcu nibh sed libero. Fusce ante. Nullam interdum aliquet metus. Ut ultrices vestibulum tellus. Praesent quis erat. Nam id turpis sit amet neque cursus luctus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Quisque id tortor. In vitae sapien. Nunc quis tellus.</p>', 1, 0, 0, 11, '2011-12-15 15:34:58', 42, '', '2011-12-15 15:35:54', 42, 0, '0000-00-00 00:00:00', '2011-12-15 15:34:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(16, 55, 'Sample Content 05', 'sample-content-05', '', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede. Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus. Sed venenatis. Donec nec dolor vitae mauris dapibus ullamcorper. Etiam iaculis mollis tortor.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi. Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consectetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>\r\n\r\n<p>Mauris lobortis. Aliquam lacinia purus. Pellentesque magna. Mauris euismod metus nec tortor. Phasellus elementum, quam a euismod imperdiet, ligula felis faucibus enim, eu malesuada nunc felis sed turpis. Morbi convallis luctus tortor. Integer bibendum lacinia velit. Suspendisse mi lorem, porttitor ut, interdum et, lobortis a, lectus. Phasellus vitae est at massa luctus iaculis. In tincidunt.</p>\r\n\r\n<p>Nullam eget neque. Nullam imperdiet venenatis ligula. Integer a leo. Nunc consectetur. Maecenas sem. Proin vulputate, massa vel volutpat laoreet, purus erat pretium ligula, eget varius arcu nibh sed libero. Fusce ante. Nullam interdum aliquet metus. Ut ultrices vestibulum tellus. Praesent quis erat. Nam id turpis sit amet neque cursus luctus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Quisque id tortor. In vitae sapien. Nunc quis tellus.</p>', 1, 0, 0, 11, '2011-12-15 15:34:58', 42, '', '2011-12-15 15:36:04', 42, 0, '0000-00-00 00:00:00', '2011-12-15 15:34:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(17, 56, 'Sample Content 06', 'sample-content-06', '', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede. Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus. Sed venenatis. Donec nec dolor vitae mauris dapibus ullamcorper. Etiam iaculis mollis tortor.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi. Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consectetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>\r\n\r\n<p>Mauris lobortis. Aliquam lacinia purus. Pellentesque magna. Mauris euismod metus nec tortor. Phasellus elementum, quam a euismod imperdiet, ligula felis faucibus enim, eu malesuada nunc felis sed turpis. Morbi convallis luctus tortor. Integer bibendum lacinia velit. Suspendisse mi lorem, porttitor ut, interdum et, lobortis a, lectus. Phasellus vitae est at massa luctus iaculis. In tincidunt.</p>\r\n\r\n<p>Nullam eget neque. Nullam imperdiet venenatis ligula. Integer a leo. Nunc consectetur. Maecenas sem. Proin vulputate, massa vel volutpat laoreet, purus erat pretium ligula, eget varius arcu nibh sed libero. Fusce ante. Nullam interdum aliquet metus. Ut ultrices vestibulum tellus. Praesent quis erat. Nam id turpis sit amet neque cursus luctus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Quisque id tortor. In vitae sapien. Nunc quis tellus.</p>', 1, 0, 0, 11, '2011-12-15 15:34:58', 42, '', '2011-12-15 15:36:11', 42, 0, '0000-00-00 00:00:00', '2011-12-15 15:34:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(18, 57, 'Sample Content 07', 'sample-content-07', '', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede. Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus. Sed venenatis. Donec nec dolor vitae mauris dapibus ullamcorper. Etiam iaculis mollis tortor.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi. Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consectetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>\r\n\r\n<p>Mauris lobortis. Aliquam lacinia purus. Pellentesque magna. Mauris euismod metus nec tortor. Phasellus elementum, quam a euismod imperdiet, ligula felis faucibus enim, eu malesuada nunc felis sed turpis. Morbi convallis luctus tortor. Integer bibendum lacinia velit. Suspendisse mi lorem, porttitor ut, interdum et, lobortis a, lectus. Phasellus vitae est at massa luctus iaculis. In tincidunt.</p>\r\n\r\n<p>Nullam eget neque. Nullam imperdiet venenatis ligula. Integer a leo. Nunc consectetur. Maecenas sem. Proin vulputate, massa vel volutpat laoreet, purus erat pretium ligula, eget varius arcu nibh sed libero. Fusce ante. Nullam interdum aliquet metus. Ut ultrices vestibulum tellus. Praesent quis erat. Nam id turpis sit amet neque cursus luctus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Quisque id tortor. In vitae sapien. Nunc quis tellus.</p>', 1, 0, 0, 11, '2011-12-15 15:34:58', 42, '', '2011-12-15 15:36:18', 42, 0, '0000-00-00 00:00:00', '2011-12-15 15:34:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(19, 58, 'Sample Content 08', 'sample-content-08', '', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Donec sit amet nibh. Vivamus non arcu. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Etiam dapibus, tellus ac ornare aliquam, massa diam tristique urna, id faucibus lectus erat ut pede. Maecenas varius neque nec libero laoreet faucibus. Phasellus sodales, lectus sed vulputate rutrum, ipsum nulla lacinia magna, sed imperdiet ligula nisi eu ipsum. Donec nunc magna, posuere eget, aliquam in, vulputate in, lacus. Sed venenatis. Donec nec dolor vitae mauris dapibus ullamcorper. Etiam iaculis mollis tortor.</p>\r\n\r\n', '\r\n\r\n<p>In erat. Pellentesque erat. Mauris vehicula vestibulum justo. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nulla pulvinar est. Integer urna. Pellentesque pulvinar dui a magna. Nulla facilisi. Proin imperdiet. Aliquam ornare, metus vitae gravida dignissim, nisi nisl ultricies felis, ac tristique enim pede eget elit. Integer non erat nec turpis sollicitudin malesuada. Vestibulum dapibus. Nulla facilisi. Nulla iaculis, leo sit amet mollis luctus, sapien eros consectetur dolor, eu faucibus elit nibh eu nibh. Maecenas lacus pede, lobortis non, rhoncus id, tristique a, mi. Cras auctor libero vitae sem vestibulum euismod. Nunc fermentum.</p>\r\n\r\n<p>Mauris lobortis. Aliquam lacinia purus. Pellentesque magna. Mauris euismod metus nec tortor. Phasellus elementum, quam a euismod imperdiet, ligula felis faucibus enim, eu malesuada nunc felis sed turpis. Morbi convallis luctus tortor. Integer bibendum lacinia velit. Suspendisse mi lorem, porttitor ut, interdum et, lobortis a, lectus. Phasellus vitae est at massa luctus iaculis. In tincidunt.</p>\r\n\r\n<p>Nullam eget neque. Nullam imperdiet venenatis ligula. Integer a leo. Nunc consectetur. Maecenas sem. Proin vulputate, massa vel volutpat laoreet, purus erat pretium ligula, eget varius arcu nibh sed libero. Fusce ante. Nullam interdum aliquet metus. Ut ultrices vestibulum tellus. Praesent quis erat. Nam id turpis sit amet neque cursus luctus. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Quisque id tortor. In vitae sapien. Nunc quis tellus.</p>', 1, 0, 0, 11, '2011-12-15 15:34:58', 42, '', '2011-12-15 15:36:26', 42, 0, '0000-00-00 00:00:00', '2011-12-15 15:34:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(20, 61, 'RokStories Module (J1.5/1.7)', 'rokstories-module-j1517', '', '<img src="images/stories/demo/general/ext/rokstories.png" class="floatleft" alt="rokstories" width="80" height="80"/>\r\n<p><strong>RokStories</strong> is a great module to display your articles and accompanying images as a featured item. The module itself is facilitated by Mootools to transition between images and articles seamlessly. Perfect for showcasing featured articles or image on your site.</p>\r\n\r\n<div class="clear"></div>\r\n<h3 class="medmargintop">Module Features</h3>\r\n\r\n<ul class="checkmark green normalfont">\r\n    <li><strong>Content Transition:</strong> The module transitions through content items, whether they are full text, a single image or combination of both.</li>\r\n    <li><strong>Article Controls:</strong> Advanced selectors for content, choose from categories, sections and authors and control the order.</li>\r\n    <li><strong>Customisable Opacity:</strong> Thumbnails can be set from transparent to opaque</li>\r\n    <li><strong>Navigation Interactions:</strong> Parameters to set whether to change news by clicking or hovering over the thumbnails</li>\r\n    <li><strong>K2 Support:</strong> Fully compatible with the powerful content constructive component K2.</li>\r\n    <li><strong>Standalone Styling:</strong> Inbuilt theme allows the module to be used on any site.</li>\r\n</ul>\r\n\r\n<p>\r\n	<a href="http://www.rockettheme.com/extensions-joomla/rokstories" class="readon smallmarginright" target="_blank"><span>Details</span></a>\r\n	<a href="http://www.rockettheme.com/extensions-downloads/club/1001-rokstories" class="readon smallmarginright" target="_blank"><span>Download</span></a>\r\n	<a href="http://www.rockettheme.com/forum/index.php?f=206&amp;rb_v=viewforum" class="readon" target="_blank"><span>Support</span></a>\r\n</p>\r\n\r\n<h3>Module Configuration</h3>\r\n\r\n<p>Options available at <strong>Admin &rarr; Extensions &rarr; Module Manager &rarr; <em>RokStories Module</em></strong>:</p>\r\n\r\n<h4>Other</h4>\r\n<ul class="dots">\r\n	<li><strong>Module Class Suffix:</strong> Add a custom class for individual styling</li>	\r\n	<li><strong>Load built-in StyleSheet:</strong> The module has inbuilt module styling so set this to Yes if you wish for it to work standalone. As we override this file from the template, you still need to set this to Yes for the styling to work.</li>	\r\n	<li><strong>Layout Type:</strong> RokStories is built with 8 layout type: Default, Showcase, Compat Showcase, Compat Showcase with Numbers, Masked Showcase, Scroller, Scroller Showcase &amp; Showcase Tabs.</li>\r\n	<li><strong>Content Type:</strong> <em>Joomla Core Content</em> or <em>K2 Content (Requires K2 to be installed).</em></li>\r\n</ul>\r\n\r\n<h4>Joomla Core Content</h4>\r\n\r\n<ul class="dots">\r\n	<li><strong>Joomla Section:</strong> Section to load tabbed content from.</li>\r\n	<li><strong>Joomla Category:</strong> Category to load tabbed content from.</li>	\r\n	<li><strong>Joomla Frontpage Items:</strong> Determine whether frontpage content is loaded.</li>\r\n</ul>\r\n\r\n<h4>K2 Content</h4>\r\n\r\n<ul class="dots">\r\n	<li><strong>K2 Category Filter:</strong> If you selected K2 Content as your content type, then this option allows you control whether to load your content from all K2 Categories or make a selection from a list.</li>\r\n	<li><strong>K2 Filter Items by Category:</strong> If you chose <strong>Select</strong> as your K2 Category Filter option, then this setting will become active in which you can select the categories you wish to load the module content from.</li>\r\n	<li><strong>K2 Featured Items:</strong> Select between Show or Hide depending on whether you wish for the Feature Items in K2 to appear in RokStories.</li>\r\n	<li><strong>Item Image Size:</strong> Specific the image size you wish to use from the K2 component. Either, XSmall, Small, Medium, Large or XLarge.</li>\r\n</ul>\r\n\r\n<h4>Content Parameters</h4>\r\n\r\n<ul class="dots">\r\n	<li><strong>Max Number of Articles:</strong> Set a limiting value for the number of articles to publish in.</li>\r\n	<li><strong>Item Ordering:</strong> Control tab ordering — <em>Default, Oldest First, Most Recent First, Title Alphabetical, Title Reverse-Alphabetical &amp; Order</em>.</li>\r\n	<li><strong>Allowed HTML Tags:</strong> The module automatically strips out all HTML tags and leaves just the content and the first image. This is to prevent the module from being distorted by incompatible HTML code. However, this option allows you to specify specific HTML tabs that will not be stripped, ideal if you still wish to add some diversity to your content. Simply insert the text of the tag, minus the <em>&lt; &gt;</em> elements, separated by commas such as <strong>a,i,br</strong> which will not strip all links, all italic text and line breaks.</li>	\r\n	<li><strong>Content Position:</strong> Either <strong>Left</strong> or <strong>Right</strong> for the position of the text, the images will be placed on the opposite side. Also, there is an option for <strong>None</strong> if you wish to use RokStories as a slideshow, best with the <strong>Showcase</strong> layout type enabled.</li>\r\n	<li><strong>Show Title:</strong> Show or Hide the title being displayed from the content item.</li>\r\n	<li><strong>Show Date:</strong> Control whether the creation date of the content item appears in RokStories.</li>\r\n	<li><strong>Show Article:</strong> Set to Hide if you wish to display just the image and no text.</li>\r\n	<li><strong>Show Link:</strong> Select whether to show the Read More button or to hide it.</li>\r\n	<li><strong>Readon Style:</strong> Choose between <strong>Legacy</strong> and <strong>Standard</strong>. Use standard for newer templates.</li>\r\n	<li><strong>Width of thumbnail (px):</strong> Set, in pixels, the width of the thumbnails, only applicable to the <strong>Default</strong> layout type.</li>\r\n	<li><strong>Width of thumbnail display (px):</strong> Set, in pixels, the width of the large image, only applicable to the <strong>Default</strong> layout type.</li>\r\n	<li><strong>Author:</strong> This option allows you to select articles from a particular author.</li>\r\n	<li><strong>First Article:</strong> Control which content item appears first in RokStories, set the number of the article (its order number from the article manager).</li>\r\n	<li><strong>Thumb Opacity:</strong> Set the opacity of thumbnails, between 0 and 1. Only applicable to the <strong>Default</strong> layout type.</li>\r\n	<li><strong>Fixed Height:</strong> Sets Rokstories in a fixed height to avoid loading jumps if not wanted.</li>\r\n	<li><strong>Navigation Interaction:</strong> Choose between Click or Mouseover as the trigger to transition the content items.</li>\r\n	<li><strong>Autoplay:</strong> Enable this option for RokStories to automatically rotate through its articles.</li>\r\n	<li><strong>Autoplay Delay (ms):</strong> Set the number of milliseconds (1000 milliseconds = 1 second) for each article to appear before it rotates to the next article.</li>\r\n</ul>\r\n\r\n<h4>Additional Showcase Layout Content Parameters</h4>\r\n<ul class="dots">\r\n	<li><strong>Show Label Title:</strong> Show or Hide the caption on top of the main image display.</li>\r\n	<li><strong>Show Arrows:</strong> Show Arrows on RokStories Image when in Layout2 mode.</li>\r\n	<li><strong>Show Circles:</strong> Show Circles on RokStories when in Layout6 mode.</li>\r\n	<li><strong>Arrows Placement:</strong> Whether to show the arrows ''inside'' or ''outside'' the image-container.</li>\r\n	<li><strong>Show Previews on Arrows:</strong> Select whether to show preview of the next image when hovering over the arrows..</li>\r\n	<li><strong>Fixed Previews:</strong> Choose whether to have the previews in a fixed position or not.</li>\r\n	<li><strong>Linked Titles:</strong> Whether to link the titles to the article.</li>\r\n	<li><strong>Linked Labels:</strong> Control whether the label / captions link to the full content item.</li>\r\n	<li><strong>Linked Images:</strong> Whether to link the images to the article.</li>\r\n	<li><strong>Show Image Mask:</strong> Whether to show the Image Mask for Layout ''Masked Layout''.</li>\r\n	<li><strong>Description Animation:</strong> Type of animation for the descriptions. Works only on Masked Showcase.</li>\r\n	<li><strong>Images Animation:</strong> Type of animation for the images. Works only on Masked Showcase.</li>\r\n	<li><strong>Scroller Duration (ms):</strong> Duration of the scroller animation.</li>\r\n	<li><strong>Transition Effect:</strong> The effect to be used for the transition.</li>\r\n	<li><strong>Show Controls:</strong> Show Controls of layout 6.</li>\r\n</ul>', '', 1, 0, 0, 10, '2011-12-16 16:25:58', 42, '', '2011-12-30 17:36:31', 42, 0, '0000-00-00 00:00:00', '2011-12-16 16:25:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 0, 13, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(21, 62, 'RokNewsPager Module (J1.5/1.7)', 'roknewspager-module-j1517', '', '<img src="images/stories/demo/general/ext/roknewspager.png" class="floatleft" alt="roknewspager" width="80" height="80"/>\r\n<p><strong>RokNewsPager</strong> is an article previewer and rotator. It displays content articles, in a summarised form and, using mootools based javascript transition, rotates through a series of pages displaying articles in a contracted list format.</p>\r\n\r\n<p>RokNewsPager allows you to display a large number of news items and links in a small compact area via its paging functionality and includes a multitude of configuration options and parameters to customize how your news is displayed.</p>\r\n\r\n<p class="notice">RokModule needs to be installed if you are using this module within Joomla 1.5.x</p>\r\n\r\n<h3>Module Features</h3>\r\n\r\n<ul class="checkmark green normalfont">\r\n    <li><strong>Javascript Transitions:</strong> using the power of mootools, the module fades between lists of your content articles</li>\r\n    <li><strong>Previews:</strong> set the number of characters you wish to display from your articles</li>\r\n    <li><strong>Section Control:</strong> choose all articles, or those from particular sections or categories</li>\r\n    <li><strong>Auto Update:</strong> select whether the module auto-updates using AJAX</li>\r\n    <li><strong>K2 Support:</strong> Fully compatible with the powerful content constructive component K2.</li>\r\n</ul>\r\n\r\n<p>\r\n	<a href="http://www.rockettheme.com/extensions-joomla/roknewspager" class="readon smallmarginright" target="_blank"><span>Details</span></a>\r\n	<a href="http://www.rockettheme.com/extensions-downloads/club/999-roknewspager" class="readon smallmarginright" target="_blank"><span>Download</span></a>\r\n	<a href="http://www.rockettheme.com/forum/index.php?f=214&amp;rb_v=viewforum" class="readon" target="_blank"><span>Support</span></a>\r\n</p>\r\n\r\n<h3>Module Configuration</h3>\r\n\r\n<p>Options available at <strong>Admin &rarr; Extensions &rarr; Module Manager &rarr; <em>RokNewsPager Module</em></strong>:</p>\r\n\r\n<h4>Other</h4>\r\n<ul class="dots">\r\n	<li><strong>Load built-in StyleSheet:</strong> Disable if you wish to override the standalone style by custom template styling.</li>\r\n	<li><strong>Theme Style:</strong> <em>Light</em> and <em>Dark</em>.</li>\r\n	<li><strong>Content Type:</strong> <em>Joomla Core Content</em> or <em>K2 Content (Requires K2 to be installed).</em></li>\r\n	<li><strong>Module Class Suffix:</strong> Add a custom class for individual styling</li>\r\n</ul>\r\n\r\n<h4>Joomla Core Content</h4>\r\n\r\n<ul class="dots">\r\n	<li><strong>Joomla Section:</strong> Section to load tabbed content from.</li>\r\n	<li><strong>Joomla Category:</strong> Category to load tabbed content from.</li>	\r\n	<li><strong>Joomla Frontpage Items:</strong> Determine whether frontpage content is loaded.</li>\r\n</ul>\r\n\r\n<h4>Content Parameters</h4>\r\n\r\n<ul class="dots">\r\n	<li><strong>Count:</strong> Insert a numerical value of the number of articles you wish to appear.</li>\r\n	<li><strong>Enable Accordion Effect:</strong> Enable the accordion module, versus standard list style.</li>\r\n	<li><strong>Enable Paging:</strong> Display several pages if articles exceed count value.</li>\r\n	<li><strong>Max Pages:</strong> Determine the maximum number of pages</li>\r\n	<li><strong>Show Title:</strong> Control whether to show the article title inside the previewed content.</li>\r\n	<li><strong>Show Thumbnails:</strong> Control whether to show the article image inside the preview content.</li>\r\n	<li><strong>Width of thumbnail (px):</strong> Set the pixel width of any thumbnails.</li>\r\n	<li><strong>Use Thumbnail as link:</strong> Determine whether the image becomes a link to the full article.</li>\r\n	<li><strong>Show Thumbnail Overlay:</strong> Control whether the thumb overlay appears.</li>\r\n	<li><strong>Overlay File:</strong> Load which file appears as the overlay over the thumbnails.</li>\r\n	<li><strong>Show Item Ratings:</strong> Control whether to display article rating.</li>\r\n	<li><strong>Show Readmore Link:</strong> Determine whether to show a Read More inside the preview content.</li>\r\n	<li><strong>Read More Text:</strong> Insert the text that you wish to appear on the Read More.</li>\r\n	<li><strong>Item Ordering:</strong> Control tab ordering — <em>Default, Oldest First, Most Recent First, Title Alphabetical, Title Reverse-Alphabetical &amp; Order</em>.</li>\r\n	<li><strong>Show Preview Text:</strong> Control whether the preview text is shown.</li>\r\n	<li><strong>Allowed HTML tags:</strong> Insert all HTML tags, separate by a comma, which you wish to remain intact in the snippet.</li>\r\n	<li><strong>Preview Length:</strong> Input a numerical value which equates to how many characters you wish for the module to show.</li>\r\n	<li><strong>Show Comment Count:</strong> Determine whether to show the number of comments for the article.</li>\r\n	<li><strong>Show Author:</strong> Control whether to show the article author.</li>\r\n	<li><strong>Show Published Date:</strong> Control whether to show the article publishing date.</li>\r\n	<li><strong>Auto Update:</strong> Determine whether articles load automatically.</li>\r\n	<li><strong>Auto Update Delay (ms):</strong> Set delay for automatic loading in milliseconds.</li>\r\n</ul>', '', 1, 0, 0, 10, '2011-12-16 16:26:17', 42, '', '2011-12-30 17:37:05', 42, 0, '0000-00-00 00:00:00', '2011-12-16 16:26:17', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 14, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(22, 63, 'RokTabs Module (J1.5/1.7)', 'roktabs-module-j1517', '', '<img src="images/stories/demo/general/ext/roktabs.png" class="floatleft" alt="RokTabs" width="80" height="80"/>\r\n<p><strong>RokTabs</strong> is a tabbed content module, standalone and themed. Content is transitioned, either by fade or scroll, powered by Mootools, which can be automatic or manual. Plugin support is also featured, whether loading module positions, read more content, or the K2 CCK component.</p>\r\n<div class="clear"></div>\r\n<h3 class="medmargintop">Module Features</h3>\r\n\r\n<ul class="checkmark green normalfont">\r\n    <li>Tabbed Content: Display multiple content items in a tabbed enclosure.</li>\r\n    <li>Module Position Support: You can insert module positions inside the tabs.</li>\r\n    <li>Inbuilt Styling: Both light and dark styling for standalone support</li>\r\n    <li>Configurability: Highly configurable from options dealing with transition, to content type and layout.</li>\r\n    <li>K2 Support: Fully compatible with the powerful content constructive component K2.</li>\r\n</ul>\r\n\r\n<p>\r\n	<a href="http://www.rockettheme.com/extensions-joomla/roktabs" class="readon smallmarginright" target="_blank"><span>Details</span></a>\r\n	<a href="http://www.rockettheme.com/extensions-downloads/club/1011-roktabs" class="readon smallmarginright" target="_blank"><span>Download</span></a>\r\n	<a href="http://www.rockettheme.com/forum/index.php?f=207&amp;rb_v=viewforum" class="readon" target="_blank"><span>Support</span></a>\r\n</p>\r\n\r\n<h3>Module Configuration</h3>\r\n\r\n<p>Options available at <strong>Admin &rarr; Extensions &rarr; Module Manager &rarr; <em>Roktabs Module</em></strong>. Important demo settings are highlighted accordingly:</p>\r\n\r\n<h4>Other</h4>\r\n<ul class="dots">\r\n	<li><strong>Theme Style:</strong> <em>Light</em> and <em>Dark</em>. Or <em>Custom</em>, if the template has styling for the modules.</li>\r\n	<li><strong>Content Type:</strong> <em>Joomla Core Content</em> or <em>K2 Content (Requires K2 to be installed).</em></li>\r\n	<li><strong>Module Class Suffix:</strong> Add a custom class for individual styling</li>\r\n</ul>\r\n\r\n<h4>Joomla Core Content</h4>\r\n\r\n<ul class="dots">\r\n	<li><strong>Joomla Section:</strong> Section to load tabbed content from.</li>\r\n	<li><strong>Joomla Category:</strong> Category to load tabbed content from.</li>	\r\n	<li><strong>Joomla Frontpage Items:</strong> Determine whether frontpage content is loaded.</li>\r\n</ul>\r\n\r\n<h4>Content Parameters</h4>\r\n\r\n<ul class="dots">\r\n	<li><strong>Item Ordering:</strong> Control tab ordering — <em>Default, Oldest First, Most Recent First, Title Alphabetical, Title Reverse-Alphabetical &amp; Order</em>.</li>\r\n	<li><strong>Default Readmore:</strong> Determine whether the system Read More is active.</li>\r\n	<li><strong>Custom Readmore Text:</strong> Control the label of the Read More.</li>\r\n</ul>\r\n\r\n<h4>Animation and Styling</h4>\r\n\r\n<ul class="dots">\r\n	<li><strong>Width:</strong> Set to the width of the container element, or a custom value.</li>\r\n	<li><strong>Max # of Tabs (0 = All):</strong> Control the maximum number of tabs.</li>\r\n	<li><strong>Transition Duration:</strong> Time, milliseconds, for tabs to transition between one another.</li>\r\n	<li><strong>Type of Transition:</strong> Choose between <em>Fading</em> or <em>Scrolling</em> for transition</li>\r\n	<li><strong>Transition Effect:</strong> Determine the effect for tab transition.</li>\r\n	<li><strong>Subtract roktab-links margins:</strong> Control calculation of margins for scrolling tabs.</li>\r\n	<li><strong>Scrollable Tabs:</strong> Determine whether tabs are scrollable when they exceed the specified width.</li>\r\n</ul>\r\n\r\n<p class="notice">Subtract roktabs-links margins needs to be enabled for best visual effect with scrollable tabs.</p>\r\n\r\n<h4>Tab Details</h4>\r\n\r\n<ul class="dots">\r\n	<li><strong>Tabs Position:</strong> Position of tab row, either <em>Top</em>, <em>Bottom</em> or <em>Hidden</em>.</li>\r\n	<li><strong>Tabs Interaction:</strong> Control transition trigger of tabs, <em>Click</em> or <em>Hover</em>.</li>\r\n	<li><strong>Tabs Title:</strong> Determine how tabs are named, <em>By Incremental</em>, <em>By Content Title</em>, or <em>By first Content h6 tag</em>.</li>\r\n	<li><strong>Incremental prepend text:</strong> If <em>By Incremental</em> is selected, specify the prepended text for each tab.</li>\r\n	<li><strong>Hide h6 tags:</strong> Disables H6 content in the tabs.</li>\r\n	<li><strong>Prefix tabs with numbers:</strong> Inject incremental numbers before tab titles.</li>\r\n	<li><strong>Show Tab Icons:</strong> Display tabs adjacent to the tab titles.</li>\r\n	<li><strong>Tab Icon Side:</strong> Position of tab title icons.</li>\r\n	<li><strong>Tab Icon Path:</strong> Set the path of icon images.</li>\r\n	<li><strong>Tab Icons:</strong> Control which icons appear with each tab title.</li>\r\n</ul>\r\n\r\n<h4>Autoplay Settings</h4>\r\n\r\n<ul class="dots">\r\n	<li><strong>Autoplay:</strong> Determine whether tabs transition automatically or manually.</li>\r\n	<li><strong>Autoplay Delay (ms):</strong> Set delay for automatic transition in milliseconds.</li>\r\n</ul>', '', 1, 0, 0, 10, '2011-12-16 16:26:44', 42, '', '2011-12-30 17:36:42', 42, 0, '0000-00-00 00:00:00', '2011-12-16 16:26:44', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 15, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(23, 64, 'RokFeatureTable (J1.5/1.7)', 'rokfeaturetable-module-j1517', '', '<img src="images/stories/demo/general/ext/rokfeaturetable.png" class="floatleft" alt="rokfeaturetable" width="80" height="80"/>\r\n<p><strong>RokFeatureTable</strong> offers a stylistic and user friendly solution for displaying tabular based data. It is perfect for price or product comparisons, or essentially, any type of data display that suits a matrix format.</p>\r\n\r\n<p>A simple, yet dynamic, interface provides you with the tools to quickly edit the contents of the module. There are a series of parameters allowing for unlimited row, with options for text, link, class and much more, which allows for extensive control.</p>\r\n\r\n<h3>Module Features</h3>\r\n\r\n<ul class="checkmark green normalfont">\r\n    <li><strong>Up to 20 Rows:</strong> Display extensive amounts of data.</li>\r\n    <li><strong>Extensive data control:</strong> Control over text, links, classes and other.</li>\r\n    <li><strong>Highlight Column Control:</strong> Set which column is defaulted as the highlight.</li>\r\n    <li><strong>Assign Custom Classes:</strong> Per classes control over tabular data.</li>\r\n    <li><strong>Custom CSS styles:</strong> Add per item inline styling.</li>\r\n    <li><strong>Template specific layouts:</strong> Create a series of layouts.</li>\r\n</ul>\r\n\r\n<p>\r\n	<a href="http://www.rockettheme.com/extensions-joomla/rokfeaturetable" class="readon smallmarginright" target="_blank"><span>Details</span></a>\r\n	<a href="http://www.rockettheme.com/extensions-downloads/club/1656-rokfeaturetable" class="readon smallmarginright" target="_blank"><span>Download</span></a>\r\n	<a href="http://www.rockettheme.com/forum/index.php?f=410&amp;rb_v=viewforum" class="readon" target="_blank"><span>Support</span></a>\r\n</p>\r\n\r\n<h3>Module Configuration</h3>\r\n\r\n<p>Options available at <strong>Admin &rarr; Extensions &rarr; Module Manager &rarr; <em>RokFeatureTable Module</em></strong>:</p>\r\n\r\n<ul class="dots">\r\n	<li><strong>Module Class Suffix</strong>: you can type any classname and it will be added to the wrapper of the RokFeatureTable on front-end</li>\r\n	<li><strong>Built-in CSS</strong>: RokFeatureTable comes with a default style that integrates with the default template of Joomla! If you want to use your own or if the template you are using supports a custom style, you might want to set this param to No.</li>\r\n	<li><strong>Highlight Column</strong>: listed are the columns from 1 to 6 or none. It allows to highlight the selected column, so that on front-end it "pops out".</li>\r\n	<li><strong>Preset Templates</strong>: RokFeatureTables has the ability to import predefined templates from both the module folder or even from your template. RokFeatureTable comes with 2 predefined templates as examples: <em>Browsers</em> and <em>Price Table</em>\r\n	<br /><br />\r\n	To import a template, select it from the dropdown and click <strong>import</strong>\r\n	<br /><br />\r\n	If you want to add your own, you can create a file (let''s say my-table.txt) in your template at the location <strong>/templates/rt_yourtemplate_j15/admin/rft-templates/</strong> (note, if <strong>admin/rft-templates/</strong> folders do not exist, please create them).\r\n	<br /><br />\r\n	Once you have create the file, you''ll notice that it''s going to be listed in <em>Preset Templates</em></li>\r\n	<li><strong>Layout Setup</strong>: this is the ''core'' of the whole RokFeatureTable functionality. To open or close the table so that you can manage it, just click the <strong>gear</strong> button.\r\n	<br /><br />\r\n	This parameter also shows you how it is structured at the moment your table. In the screenshot you can see "1 x 1", which means "1 ROW x 1 COLUMN".</li>\r\n</ul>', '', 1, 0, 0, 10, '2011-12-16 16:27:01', 42, '', '2011-12-30 17:37:56', 42, 0, '0000-00-00 00:00:00', '2011-12-16 16:27:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 0, 16, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(24, 67, 'Featured Products', 'featured-products', '', '<div class="demo-tabs">\r\n<div class="floatleft rt-center medmargintop">\r\n	<img src="images/stories/demo/frontpage/fp1.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iPhone 4S</strong></span><br />\r\n	<span>SKU 00001</span><br />\r\n	<a href="#"><em class="bold">&#36;499.99</em></a>\r\n</div>\r\n<div class="floatleft rt-center medmargintop">\r\n	<img src="images/stories/demo/frontpage/fp2.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iPod Classic</strong></span><br />\r\n	<span>SKU 00002</span><br />\r\n	<a href="#"><em class="bold">&#36;199.99</em></a>\r\n</div>\r\n<div class="floatleft nomarginright rt-center medmargintop">\r\n	<img src="images/stories/demo/frontpage/fp3.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iPad</strong></span><br />\r\n	<span>SKU 00003</span><br />\r\n	<a href="#"><em class="bold">&#36;699.99</em></a>\r\n</div>\r\n<div class="clear"></div><br />\r\n\r\n<div class="floatleft rt-center">\r\n	<img src="images/stories/demo/frontpage/fp4.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iPod Nano</strong></span><br />\r\n	<span>SKU 00004</span><br />\r\n	<a href="#"><em class="bold">&#36;79.99</em></a>\r\n</div>\r\n<div class="floatleft rt-center">\r\n	<img src="images/stories/demo/frontpage/fp5.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iPod Touch</strong></span><br />\r\n	<span>SKU 00005</span><br />\r\n	<a href="#"><em class="bold">&#36;399.99</em></a>\r\n</div>\r\n<div class="floatleft nomarginright rt-center">\r\n	<img src="images/stories/demo/frontpage/fp6.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>Macbook Pro</strong></span><br />\r\n	<span>SKU 00006</span><br />\r\n	<a href="#"><em class="bold">&#36;1899.99</em></a>\r\n</div>\r\n<div class="clear"></div>\r\n</div>', '', 1, 0, 0, 14, '2011-12-27 22:37:10', 42, '', '2011-12-30 17:10:40', 42, 0, '0000-00-00 00:00:00', '2011-12-27 22:37:10', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 6, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(25, 68, 'Most Popular', 'most-popular', '', '<div class="demo-tabs">\r\n<div class="floatleft rt-center medmargintop">\r\n	<img src="images/stories/demo/frontpage/fp8.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>Macbook Air</strong></span><br />\r\n	<span>SKU 00008</span><br />\r\n	<a href="#"><em class="bold">&#36;1399.99</em></a>\r\n</div>\r\n<div class="floatleft rt-center medmargintop">\r\n	<img src="images/stories/demo/frontpage/fp9.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>Mac Mini</strong></span><br />\r\n	<span>SKU 00009</span><br />\r\n	<a href="#"><em class="bold">&#36;899.99</em></a>	\r\n</div>\r\n<div class="floatleft nomarginright rt-center medmargintop">\r\n	<img src="images/stories/demo/frontpage/fp7.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iMac</strong></span><br />\r\n	<span>SKU 00007</span><br />\r\n	<a href="#"><em class="bold">&#36;2499.99</em></a>\r\n</div>\r\n<div class="clear"></div><br />\r\n\r\n<div class="floatleft rt-center">\r\n	<img src="images/stories/demo/frontpage/fp10.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>Mac Pro</strong></span><br />\r\n	<span>SKU 00010</span><br />\r\n	<a href="#"><em class="bold">&#36;3799.99</em></a>\r\n</div>\r\n<div class="floatleft rt-center">\r\n	<img src="images/stories/demo/frontpage/fp11.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>Apple TV</strong></span><br />\r\n	<span>SKU 00011</span><br />\r\n	<a href="#"><em class="bold">&#36;299.99</em></a>\r\n</div>\r\n<div class="floatleft nomarginright rt-center">\r\n	<img src="images/stories/demo/frontpage/fp12.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iPod Shuffle</strong></span><br />\r\n	<span>SKU 00012</span><br />\r\n	<a href="#"><em class="bold">&#36;69.99</em></a>\r\n</div>\r\n<div class="clear"></div>\r\n</div>', '', 1, 0, 0, 14, '2011-12-27 22:37:10', 42, '', '2011-12-30 17:11:09', 42, 0, '0000-00-00 00:00:00', '2011-12-27 22:37:10', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 6, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(26, 69, 'Latest Arrivals', 'latest-arrivals', '', '<div class="demo-tabs">\r\n<div class="floatleft rt-center medmargintop">\r\n	<img src="images/stories/demo/frontpage/fp6.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>Macbook Pro</strong></span><br />\r\n	<span>SKU 00006</span><br />\r\n	<a href="#"><em class="bold">&#36;1899.99</em></a>\r\n</div>\r\n<div class="floatleft rt-center medmargintop">\r\n	<img src="images/stories/demo/frontpage/fp2.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iPod Classic</strong></span><br />\r\n	<span>SKU 00002</span><br />\r\n	<a href="#"><em class="bold">&#36;199.99</em></a>\r\n</div>\r\n<div class="floatleft nomarginright rt-center medmargintop">\r\n	<img src="images/stories/demo/frontpage/fp11.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>Apple TV</strong></span><br />\r\n	<span>SKU 00011</span><br />\r\n	<a href="#"><em class="bold">&#36;299.99</em></a>\r\n</div>\r\n<div class="clear"></div><br />\r\n\r\n<div class="floatleft rt-center">\r\n	<img src="images/stories/demo/frontpage/fp3.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iPad</strong></span><br />\r\n	<span>SKU 00003</span><br />\r\n	<a href="#"><em class="bold">&#36;699.99</em></a>	\r\n</div>\r\n<div class="floatleft rt-center">\r\n	<img src="images/stories/demo/frontpage/fp1.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iPhone 4S</strong></span><br />\r\n	<span>SKU 00001</span><br />\r\n	<a href="#"><em class="bold">&#36;499.99</em></a>\r\n</div>\r\n<div class="floatleft nomarginright rt-center">\r\n	<img src="images/stories/demo/frontpage/fp7.jpg" width="206" height="160" alt="image" class="rt-image medmarginbottom" /><br />\r\n	<span><strong>iMac</strong></span><br />\r\n	<span>SKU 00007</span><br />\r\n	<a href="#"><em class="bold">&#36;2499.99</em></a>\r\n</div>\r\n<div class="clear"></div>\r\n</div>', '', 1, 0, 0, 14, '2011-12-27 22:37:10', 42, '', '2011-12-30 17:20:26', 42, 0, '0000-00-00 00:00:00', '2011-12-27 22:37:10', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 6, 0, 0, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(27, 70, 'Frontpage Article', 'frontpage-article', '', '{loadposition fproktabs}', '', 1, 0, 0, 10, '2011-12-27 22:51:01', 42, '', '2011-12-29 02:26:29', 42, 0, '0000-00-00 00:00:00', '2011-12-27 22:51:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 1, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(28, 72, 'Macbook Pro — From $1299.99', 'macbook-pro-from-129999', '', '<img src="images/stories/demo/frontpage/fp-rokstories1-blank.png" alt="image" />\r\n\r\n<p>Phasellus sit amet odio eros. Ut sagittis metus volutpat eros bibendum accumsan. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. In scelerisque aliquam tincidunt. Duis quis dui ac augue hendrerit elementum. Phasellus risus mauris, volutpat eget molestie vel, rhoncus eu lorem. Morbi a nisi quam.</p>', '', 1, 0, 0, 15, '2011-12-27 23:08:01', 42, '', '2011-12-30 20:46:34', 42, 0, '0000-00-00 00:00:00', '2011-12-27 23:08:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(29, 73, 'Macbook Air — From $1199.99', 'macbook-air-from-119999', '', '<img src="images/stories/demo/frontpage/fp-rokstories1-blank.png" alt="image" />\r\n\r\n<p>Phasellus sit amet odio eros. Ut sagittis metus volutpat eros bibendum accumsan. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. In scelerisque aliquam tincidunt. Duis quis dui ac augue hendrerit elementum. Phasellus risus mauris, volutpat eget molestie vel, rhoncus eu lorem. Morbi a nisi quam.</p>', '', 1, 0, 0, 15, '2011-12-27 23:08:08', 42, '', '2011-12-30 20:46:41', 42, 0, '0000-00-00 00:00:00', '2011-12-27 23:08:08', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(30, 74, 'iPhone 4S — From $499.99', 'iphone-4s-from-49999', '', '<img src="images/stories/demo/frontpage/fp-rokstories1-blank.png" alt="image" />\r\n\r\n<p>Phasellus sit amet odio eros. Ut sagittis metus volutpat eros bibendum accumsan. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. In scelerisque aliquam tincidunt. Duis quis dui ac augue hendrerit elementum. Phasellus risus mauris, volutpat eget molestie vel, rhoncus eu lorem. Morbi a nisi quam.</p>', '', 1, 0, 0, 15, '2011-12-27 23:08:18', 42, '', '2011-12-30 20:46:37', 42, 0, '0000-00-00 00:00:00', '2011-12-27 23:08:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 0, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(31, 75, 'RokAjaxSearch Module (J1.5/1.7)', 'rokajaxsearch-module-j1517', '', '<img src="images/stories/demo/general/ext/rokajaxsearch.png" class="floatleft" alt="RokTabs" width="80" height="80"/>\r\n<p><strong>RokAjaxSearch</strong> is a Joomla search module, utilising AJAX, to provide a combined search solution for both internal searches, and for external searches with Google: Web, Images, Blog and Videos.</p>\r\n\r\n<p>\r\n	<a href="http://www.rockettheme.com/extensions-joomla/rokajaxsearch" class="readon smallmarginright" target="_blank"><span>Details</span></a>\r\n	<a href="http://www.rockettheme.com/extensions-downloads/club/1004-rokajaxsearch" class="readon smallmarginright" target="_blank"><span>Download</span></a>\r\n	<a href="http://www.rockettheme.com/forum/index.php?f=204&amp;rb_v=viewforum" class="readon" target="_blank"><span>Support</span></a>\r\n</p>\r\n\r\n<h3>Module Configuration</h3>\r\n\r\n<p>Options available at <strong>Admin &rarr; Extensions &rarr; Module Manager &rarr; <em>RokAjaxSearch Module</em></strong>:</p>\r\n\r\n<ul class="dots">\r\n	<li><strong>Search page URL:</strong> Insert the relative path to your search page such as <em>index.php?option=com_search&amp;view=search&amp;tmpl=component</em></li>\r\n	<li><strong>Advanced Search page URL:</strong> Insert the relative path to your advanced search page such as <em>index.php?option=com_search&amp;view=search&amp;tmpl=component</em></li>\r\n	<li><strong>Include RokAjaxSearch default CSS:</strong> The module has inbuilt module styling so set this to Yes if you wish for it to work standalone. As we override this file from the template, you still need to set this to Yes for the styling to work.</li>\r\n	<li><strong>Theme Style:</strong> Only applicable if using a non-formatted template, but you can select between a Blue, Light or Dark theme for the search module.</li>\r\n	<li><strong>Searchphrase:</strong> Control the format of the search functions. Choose between Any Words, All Words or Exact Phrase to control your search strings.</li>\r\n	<li><strong>Order:</strong> Set the order of the search results. For example, if you set to Oldest First then the oldest item will be loaded in the search result. There are a variety of options to chose from.</li>\r\n	<li><strong>Limit:</strong> Set the limit for the number of search results per page, whether: 3, 5, 10, 15, 20, 25, 30 or 50</li>\r\n	<li><strong>Results per page:</strong> Set the limit for the number of search result pages, whether: 3, 5, 10, 15, 20, 25, 30 or 50</li>  \r\n	<li><strong>Google Web Search:</strong> When enabled, an option will appear in the module to search Google Web Search. The API key needs to be correctly completed for this to work.</li>\r\n	<li><strong>Google Blog Search:</strong> When enabled, an option will appear in the module to search Google Blog Search. The API key needs to be correctly completed for this to work.</li>\r\n	<li><strong>Google Images Search:</strong> When enabled, an option will appear in the module to search Google Images Search. The API key needs to be correctly completed for this to work.</li>  \r\n	<li><strong>Google Videos Search:</strong> When enabled, an option will appear in the module to search Google Videos Search. The API key needs to be correctly completed for this to work.</li>  \r\n	<li><strong>Google AJAX Search API Key:</strong> This field needs to be completed in order for the various Google search options to work. Please see <a href="http://code.google.com/apis/ajaxsearch/signup.html">http://code.google.com/apis/ajaxsearch/signup.html</a> to retrieve an API Key.</li>\r\n	<li><strong>Show Pagination:</strong> Set to Yes to show pagination for search results.</li>\r\n	<li><strong>Google SafeSearch:</strong> Choose between the different Google preferences, either Strict, Moderate or Off.</li>\r\n	<li><strong>Image Size to Search:</strong> Select the image search size preference for Google Search, either Small, Medium, Large or Extra Large.</li>\r\n	<li><strong>Show Estimated:</strong> Show the estimated result for Google searches.</li>\r\n	<li><strong>Hide div ID(s):</strong> This option allows you to set which elements of your site you wish to be excluded from searching. Enter the ID names separated by a comma such as <em>logo-module, side-column, maincontent</em></li>\r\n	<li><strong>Link to all results:</strong> Set to yes to show a link to all search results.</li>\r\n	<li><strong>Show Description:</strong> Set to yes to show a description with each search result.</li>\r\n	<li><strong>Include (Category/Section):</strong> Control whether to show the content category or section in the result.</li>\r\n	<li><strong>Show Read More Link:</strong> Set whether the Read More link should be display.</li>\r\n</ul>', '', 1, 0, 0, 10, '2011-12-29 02:28:25', 42, '', '2011-12-30 17:38:58', 42, 0, '0000-00-00 00:00:00', '2011-12-29 02:28:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 0, 17, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');

-- --------------------------------------------------------

--
-- Table structure for table `#__content_frontpage`
--

DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE IF NOT EXISTS `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
);

--
-- Dumping data for table `#__content_frontpage`
--

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES
(27, 1);

-- --------------------------------------------------------

--
-- Table structure for table `#__content_rating`
--

DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE IF NOT EXISTS `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
);

--
-- Dumping data for table `#__content_rating`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__core_log_searches`
--

DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE IF NOT EXISTS `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
);

--
-- Dumping data for table `#__core_log_searches`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__extensions`
--

DROP TABLE IF EXISTS `#__extensions`;
CREATE TABLE IF NOT EXISTS `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned NOT NULL DEFAULT '1',
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
);

--
-- Dumping data for table `#__extensions`
--

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(1, 'com_mailto', 'component', 'com_mailto', '', 0, 1, 1, 1, '{"legacy":false,"name":"com_mailto","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_MAILTO_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(2, 'com_wrapper', 'component', 'com_wrapper', '', 0, 1, 1, 1, '{"legacy":false,"name":"com_wrapper","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(3, 'com_admin', 'component', 'com_admin', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_admin","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_ADMIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(4, 'com_banners', 'component', 'com_banners', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_banners","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_BANNERS_XML_DESCRIPTION","group":""}', '{"purchase_type":"3","track_impressions":"0","track_clicks":"0","metakey_prefix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(5, 'com_cache', 'component', 'com_cache', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_cache","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_CACHE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(6, 'com_categories', 'component', 'com_categories', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_categories","type":"component","creationDate":"December 2007","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(7, 'com_checkin', 'component', 'com_checkin', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_checkin","type":"component","creationDate":"Unknown","author":"Joomla! Project","copyright":"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_CHECKIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(8, 'com_contact', 'component', 'com_contact', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_contact","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_CONTACT_XML_DESCRIPTION","group":""}', '{"contact_layout":"_:default","show_contact_category":"hide","show_contact_list":"0","presentation_style":"plain","show_name":"1","show_position":"1","show_email":"0","show_street_address":"1","show_suburb":"1","show_state":"1","show_postcode":"1","show_country":"1","show_telephone":"1","show_mobile":"1","show_fax":"1","show_webpage":"1","show_misc":"1","show_image":"1","image":"","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"0","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","contact_icons":"0","icon_address":"","icon_email":"","icon_telephone":"","icon_mobile":"","icon_fax":"","icon_misc":"","category_layout":"_:default","show_category_title":"1","show_description":"1","show_description_image":"0","maxLevel":"-1","show_empty_categories":"0","show_subcat_desc":"1","show_cat_items":"1","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_items_cat":"1","show_pagination_limit":"1","show_headings":"1","show_position_headings":"1","show_email_headings":"0","show_telephone_headings":"1","show_mobile_headings":"0","show_fax_headings":"0","show_suburb_headings":"1","show_state_headings":"1","show_country_headings":"1","show_pagination":"2","show_pagination_results":"1","initial_sort":"ordering","show_email_form":"0","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"0","redirect":"","show_feed_link":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(9, 'com_cpanel', 'component', 'com_cpanel', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_cpanel","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_CPANEL_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10, 'com_installer', 'component', 'com_installer', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_installer","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_INSTALLER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(11, 'com_languages', 'component', 'com_languages', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_languages","type":"component","creationDate":"2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_LANGUAGES_XML_DESCRIPTION","group":""}', '{"administrator":"en-GB","site":"en-GB"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(12, 'com_login', 'component', 'com_login', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_login","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(13, 'com_media', 'component', 'com_media', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_media","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_MEDIA_XML_DESCRIPTION","group":""}', '{"upload_extensions":"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS","upload_maxsize":"10","file_path":"images","image_path":"images","restrict_uploads":"1","allowed_media_usergroup":"3","check_mime":"1","image_extensions":"bmp,gif,jpg,png","ignore_extensions":"","upload_mime":"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip","upload_mime_illegal":"text\\/html","enable_flash":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(14, 'com_menus', 'component', 'com_menus', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_menus","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_MENUS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(15, 'com_messages', 'component', 'com_messages', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_messages","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_MESSAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(16, 'com_modules', 'component', 'com_modules', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_modules","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_MODULES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(17, 'com_newsfeeds', 'component', 'com_newsfeeds', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_newsfeeds","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"show_feed_image":"1","show_feed_description":"1","show_item_description":"1","feed_word_count":"0","show_headings":"1","show_name":"1","show_articles":"0","show_link":"1","show_description":"1","show_description_image":"1","display_num":"","show_pagination_limit":"1","show_pagination":"1","show_pagination_results":"1","show_cat_items":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(18, 'com_plugins', 'component', 'com_plugins', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_plugins","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_PLUGINS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(19, 'com_search', 'component', 'com_search', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_search","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_SEARCH_XML_DESCRIPTION","group":""}', '{"enabled":"0","show_date":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(20, 'com_templates', 'component', 'com_templates', '', 1, 1, 1, 1, '{"legacy":false,"name":"com_templates","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_TEMPLATES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(21, 'com_weblinks', 'component', 'com_weblinks', '', 1, 1, 1, 0, '{"legacy":false,"name":"com_weblinks","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_WEBLINKS_XML_DESCRIPTION","group":""}', '{"target":"0","count_clicks":"1","icons":2,"link_icons":"","category_layout":"_:default","show_category_title":"1","show_description":"1","show_description_image":"1","maxLevel":"-1","show_empty_categories":"0","show_subcat_desc":"1","show_cat_num_links":"1","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_links_cat":"1","show_pagination_limit":"1","show_headings":"0","show_link_description":"1","show_link_hits":"1","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(22, 'com_content', 'component', 'com_content', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_content","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_CONTENT_XML_DESCRIPTION","group":""}', '{"article_layout":"_:default","show_title":"1","link_titles":"0","show_intro":"1","show_category":"0","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"0","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"1","readmore_limit":"100","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"0","category_layout":"_:blog","show_category_title":"0","show_description":"0","show_description_image":"0","maxLevel":"1","show_empty_categories":"0","show_no_articles":"1","show_subcat_desc":"1","show_cat_num_articles":"0","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"1","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"0","show_subcategory_content":"0","show_pagination_limit":"1","filter_field":"hide","show_headings":"1","list_show_date":"0","date_format":"","list_show_hits":"1","list_show_author":"1","orderby_pri":"order","orderby_sec":"rdate","order_date":"published","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1","feed_summary":"0","filters":{"1":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"6":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"7":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"2":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"3":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"4":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"5":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"8":{"filter_type":"NONE","filter_tags":"","filter_attributes":""}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(23, 'com_config', 'component', 'com_config', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_config","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_CONFIG_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(24, 'com_redirect', 'component', 'com_redirect', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_redirect","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(25, 'com_users', 'component', 'com_users', '', 1, 1, 0, 1, '{"legacy":false,"name":"com_users","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"COM_USERS_XML_DESCRIPTION","group":""}', '{"allowUserRegistration":"1","new_usertype":"2","useractivation":"1","frontend_userparams":"1","mailSubjectPrefix":"","mailBodySuffix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(100, 'PHPMailer', 'library', 'phpmailer', '', 0, 1, 1, 1, '{"legacy":false,"name":"PHPMailer","type":"library","creationDate":"2008","author":"PHPMailer","copyright":"Copyright (C) PHPMailer.","authorEmail":"","authorUrl":"http:\\/\\/phpmailer.codeworxtech.com\\/","version":"1.7.0","description":"LIB_PHPMAILER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(101, 'SimplePie', 'library', 'simplepie', '', 0, 1, 1, 1, '{"legacy":false,"name":"SimplePie","type":"library","creationDate":"2008","author":"SimplePie","copyright":"Copyright (C) 2008 SimplePie","authorEmail":"","authorUrl":"http:\\/\\/simplepie.org\\/","version":"1.0.1","description":"LIB_SIMPLEPIE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(102, 'phputf8', 'library', 'phputf8', '', 0, 1, 1, 1, '{"legacy":false,"name":"phputf8","type":"library","creationDate":"2008","author":"Harry Fuecks","copyright":"Copyright various authors","authorEmail":"","authorUrl":"http:\\/\\/sourceforge.net\\/projects\\/phputf8","version":"1.7.0","description":"LIB_PHPUTF8_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(103, 'Joomla! Web Application Framework', 'library', 'joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"Joomla! Web Application Framework","type":"library","creationDate":"2008","author":"Joomla","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"1.7.0","description":"LIB_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(200, 'mod_articles_archive', 'module', 'mod_articles_archive', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_archive","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters.\\n\\t\\tAll rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(201, 'mod_articles_latest', 'module', 'mod_articles_latest', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_LATEST_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(202, 'mod_articles_popular', 'module', 'mod_articles_popular', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_articles_popular","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(203, 'mod_banners', 'module', 'mod_banners', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_banners","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_BANNERS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(204, 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_breadcrumbs","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_BREADCRUMBS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(205, 'mod_custom', 'module', 'mod_custom', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(206, 'mod_feed', 'module', 'mod_feed', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(207, 'mod_footer', 'module', 'mod_footer', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_footer","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_FOOTER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(208, 'mod_login', 'module', 'mod_login', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_login","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(209, 'mod_menu', 'module', 'mod_menu', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_menu","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(210, 'mod_articles_news', 'module', 'mod_articles_news', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_articles_news","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_ARTICLES_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(211, 'mod_random_image', 'module', 'mod_random_image', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_random_image","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_RANDOM_IMAGE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(212, 'mod_related_items', 'module', 'mod_related_items', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_related_items","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_RELATED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(213, 'mod_search', 'module', 'mod_search', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_search","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_SEARCH_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(214, 'mod_stats', 'module', 'mod_stats', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_stats","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_STATS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(215, 'mod_syndicate', 'module', 'mod_syndicate', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_syndicate","type":"module","creationDate":"May 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_SYNDICATE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(216, 'mod_users_latest', 'module', 'mod_users_latest', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_users_latest","type":"module","creationDate":"December 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_USERS_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(217, 'mod_weblinks', 'module', 'mod_weblinks', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_weblinks","type":"module","creationDate":"July 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_WEBLINKS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(218, 'mod_whosonline', 'module', 'mod_whosonline', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_whosonline","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_WHOSONLINE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(219, 'mod_wrapper', 'module', 'mod_wrapper', '', 0, 1, 1, 0, '{"legacy":false,"name":"mod_wrapper","type":"module","creationDate":"October 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(220, 'mod_articles_category', 'module', 'mod_articles_category', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_category","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(221, 'mod_articles_categories', 'module', 'mod_articles_categories', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_articles_categories","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(222, 'mod_languages', 'module', 'mod_languages', '', 0, 1, 1, 1, '{"legacy":false,"name":"mod_languages","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_LANGUAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(300, 'mod_custom', 'module', 'mod_custom', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(301, 'mod_feed', 'module', 'mod_feed', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(302, 'mod_latest', 'module', 'mod_latest', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(303, 'mod_logged', 'module', 'mod_logged', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_logged","type":"module","creationDate":"January 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_LOGGED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(304, 'mod_login', 'module', 'mod_login', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_login","type":"module","creationDate":"March 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(305, 'mod_menu', 'module', 'mod_menu', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_menu","type":"module","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(307, 'mod_popular', 'module', 'mod_popular', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_popular","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(308, 'mod_quickicon', 'module', 'mod_quickicon', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_quickicon","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_QUICKICON_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(309, 'mod_status', 'module', 'mod_status', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_status","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_STATUS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(310, 'mod_submenu', 'module', 'mod_submenu', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_submenu","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_SUBMENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(311, 'mod_title', 'module', 'mod_title', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_title","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_TITLE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(312, 'mod_toolbar', 'module', 'mod_toolbar', '', 1, 1, 1, 1, '{"legacy":false,"name":"mod_toolbar","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"MOD_TOOLBAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(313, 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', 1, 1, 1, 0, '{"legacy":false,"name":"mod_multilangstatus","type":"module","creationDate":"September 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.1","description":"MOD_MULTILANGSTATUS_XML_DESCRIPTION","group":""}', '{"cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(400, 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', 0, 0, 1, 0, '{"legacy":false,"name":"plg_authentication_gmail","type":"plugin","creationDate":"February 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_GMAIL_XML_DESCRIPTION","group":""}', '{"applysuffix":"0","suffix":"","verifypeer":"1","user_blacklist":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(401, 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', 0, 1, 1, 1, '{"legacy":false,"name":"plg_authentication_joomla","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_AUTH_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(402, 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', 0, 0, 1, 0, '{"legacy":false,"name":"plg_authentication_ldap","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_LDAP_XML_DESCRIPTION","group":""}', '{"host":"","port":"389","use_ldapV3":"0","negotiate_tls":"0","no_referrals":"0","auth_method":"bind","base_dn":"","search_string":"","users_dn":"","username":"admin","password":"bobby7","ldap_fullname":"fullName","ldap_email":"mail","ldap_uid":"uid"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(404, 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_emailcloak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION","group":""}', '{"mode":"1"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(405, 'plg_content_geshi', 'plugin', 'geshi', 'content', 0, 0, 1, 0, '{"legacy":false,"name":"plg_content_geshi","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"","authorUrl":"qbnz.com\\/highlighter","version":"1.7.0","description":"PLG_CONTENT_GESHI_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(406, 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_loadmodule","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_LOADMODULE_XML_DESCRIPTION","group":""}', '{"style":"xhtml"}', '', '', 0, '2011-09-18 15:22:50', 0, 0),
(407, 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_pagebreak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION","group":""}', '{"title":"1","multipage_toc":"1","showall":"1"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(408, 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_pagenavigation","type":"plugin","creationDate":"January 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_PAGENAVIGATION_XML_DESCRIPTION","group":""}', '{"position":"1"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(409, 'plg_content_vote', 'plugin', 'vote', 'content', 0, 1, 1, 1, '{"legacy":false,"name":"plg_content_vote","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_VOTE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(410, 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_codemirror","type":"plugin","creationDate":"28 March 2011","author":"Marijn Haverbeke","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"1.0","description":"PLG_CODEMIRROR_XML_DESCRIPTION","group":""}', '{"linenumbers":"0","tabmode":"indent"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(411, 'plg_editors_none', 'plugin', 'none', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_none","type":"plugin","creationDate":"August 2004","author":"Unknown","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"1.7.0","description":"PLG_NONE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(412, 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors_tinymce","type":"plugin","creationDate":"2005-2011","author":"Moxiecode Systems AB","copyright":"Moxiecode Systems AB","authorEmail":"N\\/A","authorUrl":"tinymce.moxiecode.com\\/","version":"3.4.4","description":"PLG_TINY_XML_DESCRIPTION","group":""}', '{"mode":"1","skin":"0","compressed":"0","cleanup_startup":"0","cleanup_save":"2","entity_encoding":"raw","lang_mode":"0","lang_code":"en","text_direction":"ltr","content_css":"1","content_css_custom":"","relative_urls":"1","newlines":"0","invalid_elements":"script,applet,iframe","extended_elements":"","toolbar":"top","toolbar_align":"left","html_height":"550","html_width":"750","element_path":"1","fonts":"1","paste":"1","searchreplace":"1","insertdate":"1","format_date":"%Y-%m-%d","inserttime":"1","format_time":"%H:%M:%S","colors":"1","table":"1","smilies":"1","media":"1","hr":"1","directionality":"1","fullscreen":"1","style":"1","layer":"1","xhtmlxtras":"1","visualchars":"1","nonbreaking":"1","template":"1","blockquote":"1","wordcount":"1","advimage":"1","advlink":"1","autosave":"1","contextmenu":"1","inlinepopups":"1","safari":"0","custom_plugin":"","custom_button":""}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(413, 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', 0, 1, 1, 1, '{"legacy":false,"name":"plg_editors-xtd_article","type":"plugin","creationDate":"October 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_ARTICLE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(414, 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_image","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_IMAGE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(415, 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_pagebreak","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(416, 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"plg_editors-xtd_readmore","type":"plugin","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_READMORE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(417, 'plg_search_categories', 'plugin', 'categories', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_categories","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(418, 'plg_search_contacts', 'plugin', 'contacts', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_contacts","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_SEARCH_CONTACTS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(419, 'plg_search_content', 'plugin', 'content', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_content","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_SEARCH_CONTENT_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(420, 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_newsfeeds","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(421, 'plg_search_weblinks', 'plugin', 'weblinks', 'search', 0, 1, 1, 0, '{"legacy":false,"name":"plg_search_weblinks","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(422, 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', 0, 0, 1, 1, '{"legacy":false,"name":"plg_system_languagefilter","type":"plugin","creationDate":"July 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(423, 'plg_system_p3p', 'plugin', 'p3p', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_p3p","type":"plugin","creationDate":"September 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_P3P_XML_DESCRIPTION","group":""}', '{"headers":"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(424, 'plg_system_cache', 'plugin', 'cache', 'system', 0, 0, 1, 1, '{"legacy":false,"name":"plg_system_cache","type":"plugin","creationDate":"February 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_CACHE_XML_DESCRIPTION","group":""}', '{"browsercache":"0","cachetime":"15"}', '', '', 0, '0000-00-00 00:00:00', 9, 0),
(425, 'plg_system_debug', 'plugin', 'debug', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_debug","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_DEBUG_XML_DESCRIPTION","group":""}', '{"profile":"1","queries":"1","memory":"1","language_files":"1","language_strings":"1","strip-first":"1","strip-prefix":"","strip-suffix":""}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(426, 'plg_system_log', 'plugin', 'log', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_log","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_LOG_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(427, 'plg_system_redirect', 'plugin', 'redirect', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_redirect","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(428, 'plg_system_remember', 'plugin', 'remember', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_remember","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_REMEMBER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(429, 'plg_system_sef', 'plugin', 'sef', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"plg_system_sef","type":"plugin","creationDate":"December 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_SEF_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 8, 0),
(430, 'plg_system_logout', 'plugin', 'logout', 'system', 0, 1, 1, 1, '{"legacy":false,"name":"plg_system_logout","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(431, 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', 0, 0, 1, 1, '{"legacy":false,"name":"plg_user_contactcreator","type":"plugin","creationDate":"August 2009","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_CONTACTCREATOR_XML_DESCRIPTION","group":""}', '{"autowebpage":"","category":"34","autopublish":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(432, 'plg_user_joomla', 'plugin', 'joomla', 'user', 0, 1, 1, 0, '{"legacy":false,"name":"plg_user_joomla","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2009 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_USER_JOOMLA_XML_DESCRIPTION","group":""}', '{"autoregister":"1"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(433, 'plg_user_profile', 'plugin', 'profile', 'user', 0, 0, 1, 1, '{"legacy":false,"name":"plg_user_profile","type":"plugin","creationDate":"January 2008","author":"Joomla! Project","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_USER_PROFILE_XML_DESCRIPTION","group":""}', '{"register-require_address1":"1","register-require_address2":"1","register-require_city":"1","register-require_region":"1","register-require_country":"1","register-require_postal_code":"1","register-require_phone":"1","register-require_website":"1","register-require_favoritebook":"1","register-require_aboutme":"1","register-require_tos":"1","register-require_dob":"1","profile-require_address1":"1","profile-require_address2":"1","profile-require_city":"1","profile-require_region":"1","profile-require_country":"1","profile-require_postal_code":"1","profile-require_phone":"1","profile-require_website":"1","profile-require_favoritebook":"1","profile-require_aboutme":"1","profile-require_tos":"1","profile-require_dob":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(434, 'plg_extension_joomla', 'plugin', 'joomla', 'extension', 0, 1, 1, 1, '{"legacy":false,"name":"plg_extension_joomla","type":"plugin","creationDate":"May 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(435, 'plg_content_joomla', 'plugin', 'joomla', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"plg_content_joomla","type":"plugin","creationDate":"November 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"PLG_CONTENT_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(500, 'atomic', 'template', 'atomic', '', 0, 1, 1, 0, '{"legacy":false,"name":"atomic","type":"template","creationDate":"10\\/10\\/09","author":"Ron Severdia","copyright":"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.","authorEmail":"contact@kontentdesign.com","authorUrl":"http:\\/\\/www.kontentdesign.com","version":"1.7.0","description":"TPL_ATOMIC_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(502, 'bluestork', 'template', 'bluestork', '', 1, 1, 1, 0, '{"legacy":false,"name":"bluestork","type":"template","creationDate":"07\\/02\\/09","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.0","description":"TPL_BLUESTORK_XML_DESCRIPTION","group":""}', '{"useRoundedCorners":"1","showSiteName":"0","textBig":"0","highContrast":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(503, 'beez_20', 'template', 'beez_20', '', 0, 1, 1, 0, '{"legacy":false,"name":"beez_20","type":"template","creationDate":"25 November 2009","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"1.7.0","description":"TPL_BEEZ2_XML_DESCRIPTION","group":""}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(504, 'hathor', 'template', 'hathor', '', 1, 1, 1, 0, '{"legacy":false,"name":"hathor","type":"template","creationDate":"May 2010","author":"Andrea Tarr","copyright":"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.","authorEmail":"hathor@tarrconsulting.com","authorUrl":"http:\\/\\/www.tarrconsulting.com","version":"1.7.0","description":"TPL_HATHOR_XML_DESCRIPTION","group":""}', '{"showSiteName":"0","colourChoice":"0","boldText":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(505, 'beez5', 'template', 'beez5', '', 0, 1, 1, 0, '{"legacy":false,"name":"beez5","type":"template","creationDate":"21 May 2010","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"1.7.0","description":"TPL_BEEZ5_XML_DESCRIPTION","group":""}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","html5":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(600, 'English (United Kingdom)', 'language', 'en-GB', '', 0, 1, 1, 1, '{"legacy":false,"name":"English (United Kingdom)","type":"language","creationDate":"2008-03-15","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.1","description":"en-GB site language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(601, 'English (United Kingdom)', 'language', 'en-GB', '', 1, 1, 1, 1, '{"legacy":false,"name":"English (United Kingdom)","type":"language","creationDate":"2008-03-15","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.1","description":"en-GB administrator language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(700, 'files_joomla', 'file', 'joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"files_joomla","type":"file","creationDate":"November 2011","author":"Joomla!","copyright":"(C) 2005 - 2011 Open Source Matters. All rights reserved","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"1.7.3","description":"FILES_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(800, 'PKG_JOOMLA', 'package', 'pkg_joomla', '', 0, 1, 1, 1, '{"legacy":false,"name":"PKG_JOOMLA","type":"package","creationDate":"2006","author":"Joomla!","copyright":"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"1.7.0","description":"PKG_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10001, 'Gantry', 'library', 'lib_gantry', '', 0, 1, 1, 0, '{"legacy":false,"name":"Gantry","type":"library","creationDate":"December 1, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"3.2.13","description":"${project.description}","group":""}', '{}', '{"last_update":1325264486}', '', 0, '0000-00-00 00:00:00', 0, 0),
(10002, 'gantry', 'component', 'com_gantry', '', 0, 1, 0, 0, '{"legacy":false,"name":"Gantry","type":"component","creationDate":"December 1, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"3.2.13","description":"${project.description}","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10003, 'System - Gantry', 'plugin', 'gantry', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - Gantry","type":"plugin","creationDate":"December 1, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"3.2.13","description":"Gantry System Plugin for Joomla","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10005, 'RokAjaxSearch', 'module', 'mod_rokajaxsearch', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokAjaxSearch","type":"module","creationDate":"March 2, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.0","description":"RokAjaxSearch is an ajaxian searcher that displays the results immediately and allows to choose the proper one.","group":""}', '{"moduleclass_sfx":"","search_page":"index.php?option=com_search&view=search&tmpl=component","adv_search_page":"index.php?option=com_search&view=search","spacer_style_options":"","include_css":"1","theme":"blue","spacer_advanced_search":"","searchphrase":"any","ordering":"newest","limit":"10","perpage":"3","websearch":"0","blogsearch":"0","imagesearch":"0","videosearch":"0","websearch_api":"","show_pagination":"1","safesearch":"MODERATE","image_size":"MEDIUM","show_estimated":"1","spacer_advanced_settings":"","hide_divs":"","include_link":"1","show_description":"1","include_category":"1","show_readmore":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10007, 'System - RokExtender', 'plugin', 'rokextender', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - RokExtender","type":"plugin","creationDate":"February 24, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.0","description":"System - Gantry","group":""}', '{"registered":"\\/modules\\/mod_roknavmenu\\/lib\\/RokNavMenuEvents.php"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10008, 'RokNavMenu', 'module', 'mod_roknavmenu', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokNavMenu","type":"module","creationDate":"October 12, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.7","description":"RocketTheme Customizable Navigation Menu","group":""}', '{"limit_levels":"0","startLevel":"0","endLevel":"0","showAllChildren":"0","window_open":"","filteringspacer2":"","theme":"default","custom_layout":"default.php","custom_formatter":"default.php","cache":"1","cache_time":"900","cachemode":"itemid"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10010, 'RokNewsPager', 'module', 'mod_roknewspager', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokNewsPager","type":"module","creationDate":"November 11, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.5","description":"RokNewsPager is a horizontal paging latest news module","group":""}', '{"":"","load_css":"1","theme":"light","content_type":"joomla","spacer_joomla_core":"","catid":"","show_front":"1","spacer_content_parameters":"","article_count":"5","show_accordion":"0","show_paging":"1","maxpages":"8","show_title":"1","show_thumbnails":"1","thumb_width":"90","thumbnail_link":"1","show_overlay":"1","overlay":"","show_ratings":"1","show_readmore":"1","readmore_text":"Read More...","itemsOrdering":"","show_preview_text":"1","strip_tags":"a,br","preview_count":"200","show_comment_count":"0","show_author":"0","show_published_date":"0","autoupdate":"0","autoupdate_delay":"5000","moduleclass_sfx":"","cache":"0","module_ident":"id","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10011, 'rokmodule', 'component', 'com_rokmodule', '', 1, 1, 0, 0, '{"legacy":false,"name":"RokModule","type":"component","creationDate":"November 11, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.3","description":"Displays a module as a component - useful for ajax (v1.1 adds support for modules by moduleid as well as module)","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10013, 'RokTabs', 'module', 'mod_roktabs', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokTabs","type":"module","creationDate":"August 1, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.5","description":"RokTabs is a news module designed to show section articles in a pleasing format.  Brought to you by RocketTheme","group":""}', '{"style":"light","content_type":"joomla","catid":"","show_front":"1","spacer_content_parameters":"","itemsOrdering":"","strip_tags":"a,i,br,img","show_readmore":"1","readmore":"Read more...","spacer_animation":"","width":"500","tabs_count":"3","duration":"600","transition_type":"scrolling","transition_fx":"Quad.easeInOut","linksMargins":"0","navscrolling":"1","spacer_tabs_details":"","tabs_position":"top","tabs_event":"click","tabs_title":"content","tabs_incremental":"Tab ","tabs_hideh6":"1","tabs_prefixed":"0","tabs_showicons":"0","tabs_iconside":"left","tabs_iconpath":"__module__\\/images","tabs_icon":"icon_home.gif, icon_security.gif, icon_comment.gif, icon_world.gif, icon_note.gif","spacer_autoplay":"","autoplay":"0","autoplay_delay":"2000","spacer_spacer":"","moduleclass_sfx":"","cache":"0","module_cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10015, 'RokTwittie', 'module', 'mod_roktwittie', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokTwittie","type":"module","creationDate":"October 6, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.5","description":"RokTwittie is a Twitter module that lets you display up to 140 tweets, display tweets through oAuth authentication and display Twitter search results. RokTwittie supports many settings like multiple users to display, merged tweets and comes with a light and dark built-in styles.","group":""}', '{"@status":"","use_oauth":"0","consumer_key":"","consumer_secret":"","@signin":"","moduleclass_sfx":"","load_css":"1","enable_cache":"1","timeout_connect":"3","timeout_response":"6","enable_cache_time":"5","usernames":"rockettheme","inactive_opacity":"0.5","show_default_avatar":"1","header_style":"dark","include_rts":"1","enable_statuses":"1","status_external":"1","show_feed":"1","show_follow_updates":"1","show_bio":"1","show_web":"1","show_location":"1","show_updates":"1","show_followers":"1","show_following":"1","show_following_icons":"1","following_icons_count":"10","show_viewall":"1","enable_usernames":"1","enable_usernames_avatar":"1","usernames_avatar_size":"48","usernames_count_size":"4","usernames_count_merged":"1","enable_usernames_externals":"1","enable_usernames_source":"1","enable_usernames_user":"1","enable_search":"1","search":"@rockettheme","enable_search_avatar":"1","search_avatar_size":"48","search_count_size":"4","enable_search_externals":"1","enable_search_source":"1","enable_search_user":"1","oauth_token":"","oauth_token_secret":"","cache":"0","module_cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10017, 'Editor - RokPad', 'plugin', 'rokpad', 'editors', 0, 1, 1, 0, '{"legacy":false,"name":"Editor - RokPad","type":"plugin","creationDate":"March 2, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.0","description":"This loads an advanced text editor for developers with highlight, search & replace, lines counter, auto indent, multi-language and much more","group":""}', '{"spacer_parser_type":"","rokpad-parser":"xhtmlmixed","rokpad-tidylevel":"XHTML 1.0 Transitional","rokpad-show-formatter":"1","spacer_editor_parameters":"","rokpad-height":"350","rokpad-passdelay":"200","rokpad-passtime":"50","rokpad-linenumberdelay":"200","rokpad-linenumbertime":"50","rokpad-continuous":"500","rokpad-matchparens":"1","rokpad-history":"50","rokpad-history-delay":"800","rokpad-lineHandler":"1","rokpad-textwrapperHandler":"1","rokpad-indentunit":"2","rokpad-tabmode":"indent","rokpad-loadindent":"1"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10019, 'System - RokBox', 'plugin', 'rokbox', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - RokBox","type":"plugin","creationDate":"September 1, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.2","description":"RokBox System Plugin","group":""}', '{"theme":"light","custom-theme":"sample","custom-legacy":"0","width":"640","height":"460","transition":"Quad.easeOut","duration":"200","chase":"40","effect":"quicksilver","frame-border":"20","content-padding":"0","arrows-height":"35","captions":"1","captionsDelay":"800","scrolling":"0","keyEvents":"1","overlay_background":"#000000","overlay_opacity":"0.85","overlay_duration":"200","overlay_transition":"Quad.easeInOut","autoplay":"true","ytautoplay":"0","ythighquality":"0","controller":"false","bgcolor":"#f3f3f3","vimeoColor":"00adef","vimeoPortrait":"0","vimeoTitle":"0","vimeoFullScreen":"1","vimeoByline":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10020, 'Content - RokBox', 'plugin', 'rokbox', 'content', 0, 1, 1, 0, '{"legacy":false,"name":"Content - RokBox","type":"plugin","creationDate":"September 1, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.2","description":"To be used with a RokBox enabled RocketTheme Joomla! template.  Syntax is {rokbox}link{\\/rokbox}.  If you want the image to be part of an ''album'', you can use the syntax {rokbox album=|albumname|}link{\\/rokbox}.  To provide text descriptions, please use the syntax {rokbox title=|your description|}link{\\/rokbox}. To specify a thumbnail, use the syntax {rokbox thumb=|thumbnail_link.jpg|}link{\\/rokbox}. If you want to use a text link, you can specify the text using syntax: {rokbox text=|your link text here|}link{\\/rokbox}. You can also use album, title, thumb and text in the same tag.","group":""}', '{"remote_sizes":"0","thumb_ext":"_thumb","thumb_class":"album","thumb_custom":"0","thumb_dir":"cache","thumb_width":"150","thumb_height":"100","thumb_quality":"90"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10022, 'rokcandy', 'component', 'com_rokcandy', '', 1, 1, 0, 0, '{"legacy":false,"name":"RokCandy","type":"component","creationDate":"September 7, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.1","description":"\\n\\t\\tRokCandy is a simple yet powerful macro system for Joomla 1.6.  It provides the ability to create and categorize macros that can be used throughout your site.\\n\\t","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10023, 'Button - RokCandy', 'plugin', 'rokcandy', 'editors-xtd', 0, 1, 1, 0, '{"legacy":false,"name":"Button - RokCandy","type":"plugin","creationDate":"September 7, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.1","description":"This is an Editor Button to allow selection of RokCandy macros","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(10024, 'System - RokCandy', 'plugin', 'rokcandy', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - RokCandy","type":"plugin","creationDate":"September 7, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.1","description":"This is the RokCandy system plugin that performs the macro replacement","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 50, 0),
(10026, 'System - RokGZipper', 'plugin', 'rokgzipper', 'system', 0, 0, 1, 0, '{"legacy":false,"name":"System - RokGZipper","type":"plugin","creationDate":"March 2, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.0","description":"Plugin to gzip-bundle js and css files","group":""}', '{"cache_time":"900","expires_header_time":"1440","show_contains_comments":"0","ignored_files":"\\/jan12\\/libraries\\/gantry\\/js\\/imenu.js\\r\\n\\/jan12\\/media\\/system\\/js\\/modal.js","strip_css":"1"}', '', '', 0, '0000-00-00 00:00:00', 100, 0),
(10028, 'RokFeatureTable', 'module', 'mod_rokfeaturetable', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokFeatureTable","type":"module","creationDate":"March 17, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.0","description":"\\n\\tRokFeatureTable is a very simple yet powerful module for providing tabular data. It comes with pre-populated templates and allows to create your own directly from your own template.\\n\\tRokFeatureTable reads custom templates that are found under \\"templates\\/your_active_template\\/admin\\/rft-templates\\/\\". They must be .txt files. You can see a couple of examples from \\"modules\\/mod_rokfeaturetable\\/templates\\/\\".\\n\\t","group":""}', '{"moduleclass_sfx":"","builtin_css":"1","highlight-col":"1","cache":"0","module_cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10030, 'rokecwid', 'component', 'com_rokecwid', '', 1, 1, 0, 0, '{"legacy":false,"name":"RokEcwid","type":"component","creationDate":"September 7, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.3","description":"","group":""}', '{"storeID":"879302","enableInlineSeoCatalog":"1","categoriesPerRow":"3","defaultCategory":"","categoryView":"grid","enableHTMLMode":"0","searchView":"list","grid":"3,3","list":"10","table":"20"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10031, 'System - RokEcwid', 'plugin', 'rokecwid', 'system', 0, 1, 1, 0, '{"legacy":false,"name":"System - RokEcwid","type":"plugin","creationDate":"September 7, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.3","description":"Support Plugin for RokECWID","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10032, 'RokEcwid Categories Module', 'module', 'mod_rokecwid_categories', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokEcwid Categories Module","type":"module","creationDate":"September 7, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.3","description":"Module to show the ECWID store categories","group":""}', '{"moduleclass_sfx":"","categoryLayout":"xVCategories"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10033, 'RokEcwid Mini-cart Module', 'module', 'mod_rokecwid_minicart', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokEcwid Mini-cart Module","type":"module","creationDate":"September 7, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.3","description":"Module to show the ECWID mini-cart","group":""}', '{"moduleclass_sfx":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10034, 'RokEcwid Search Module', 'module', 'mod_rokecwid_search', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokEcwid Search Module","type":"module","creationDate":"September 7, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.3","description":"Module to show the ECWID Search module","group":""}', '{"moduleclass_sfx":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10035, 'com_gantry', 'component', 'com_gantry', '', 1, 1, 1, 0, '{"legacy":false,"name":"Gantry","type":"component","creationDate":"December 1, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"3.2.13","description":"${project.description}","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, -1),
(10036, 'rt_halcyon', 'template', 'rt_halcyon', '', 0, 1, 1, 0, '{"legacy":false,"name":"rt_halcyon","type":"template","creationDate":" ${build_date}","author":"${author}","copyright":"Copyright 2005-${copyright_year} - RocketTheme.com","authorEmail":"${authorEmail}","authorUrl":"${authorUrl}","version":"${project.version}","description":"halcyon","group":""}', '{"master":"true"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10037, 'RokStories', 'module', 'mod_rokstories', '', 0, 1, 1, 0, '{"legacy":false,"name":"RokStories","type":"module","creationDate":"July 15, 2011","author":"RocketTheme, LLC","copyright":"(C) 2005 - 2011 RocketTheme, LLC. All rights reserved.","authorEmail":"support@rockettheme.com","authorUrl":"http:\\/\\/www.rockettheme.com","version":"1.4","description":"RokStories","group":""}', '{"moduleclass_sfx":"","load_css":"1","layout_type":"layout1","@spacer":"<div id=\\"additional-label\\"   style=\\"font-weight:normal;font-size:12px;color:#fff;padding:4px;margin:0;background:#666;\\">Additional Showcase Layout Type Content Parameters<\\/div>","catid":"","show_front":"1","article_count":"4","itemsOrdering":"","strip_tags":"a,i,br","content_position":"right","show_article_title":"1","show_created_date":"0","show_article":"1","show_article_link":"1","legacy_readmore":"0","thumb_width":"90","start_width":"auto","user_id":"0","start_element":"0","thumbs_opacity":"0.3","fixed_height":"0","mouse_type":"click","autoplay":"0","autoplay_delay":"5000","show_label_article_title":"1","show_arrows":"1","show_circles":"1","arrows_placement":"inside","show_thumbs":"0","fixed_thumb":"1","link_titles":"0","link_labels":"0","link_images":"0","show_mask":"1","mask_desc_dir":"topdown","mask_imgs_dir":"bottomup","scrollerDuration":"1000","scrollerTransition":"Expo.easeInOut","show_controls":"1","spacer":"","left_offset_x":"-40","left_offset_y":"-100","right_offset_x":"-30","right_offset_y":"-100","left_f_offset_x":"-40","left_f_offset_y":"-100","right_f_offset_x":"-30","right_f_offset_y":"-100","cache":"0","module_cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__languages`
--

DROP TABLE IF EXISTS `#__languages`;
CREATE TABLE IF NOT EXISTS `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  KEY `idx_ordering` (`ordering`)
);

--
-- Dumping data for table `#__languages`
--

INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `ordering`) VALUES
(1, 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', 1, 1);

-- --------------------------------------------------------

--
-- Table structure for table `#__menu`
--

DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE IF NOT EXISTS `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The access level required to view the menu item.',
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias` (`client_id`,`parent_id`,`alias`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(255)),
  KEY `idx_language` (`language`)
);

--
-- Dumping data for table `#__menu`
--

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(1, '', 'Menu_Item_Root', 'root', '', '', '', '', 1, 0, 0, 0, 0, 0, '0000-00-00 00:00:00', 0, 0, '', 0, '', 0, 161, 0, '*', 0),
(2, 'menu', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', 0, 1, 1, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 1, 10, 0, '*', 1),
(3, 'menu', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 2, 3, 0, '*', 1),
(4, 'menu', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', 0, 2, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-cat', 0, '', 4, 5, 0, '*', 1),
(5, 'menu', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-clients', 0, '', 6, 7, 0, '*', 1),
(6, 'menu', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', 0, 2, 2, 4, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-tracks', 0, '', 8, 9, 0, '*', 1),
(7, 'menu', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', 0, 1, 1, 8, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 119, 124, 0, '*', 1),
(8, 'menu', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', 0, 7, 2, 8, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 120, 121, 0, '*', 1),
(9, 'menu', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', 0, 7, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact-cat', 0, '', 122, 123, 0, '*', 1),
(10, 'menu', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', 0, 1, 1, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages', 0, '', 125, 130, 0, '*', 1),
(11, 'menu', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', 0, 10, 2, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-add', 0, '', 126, 127, 0, '*', 1),
(12, 'menu', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', 0, 10, 2, 15, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-read', 0, '', 128, 129, 0, '*', 1),
(13, 'menu', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 1, 1, 17, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 131, 136, 0, '*', 1),
(14, 'menu', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 13, 2, 17, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 132, 133, 0, '*', 1),
(15, 'menu', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', 0, 13, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds-cat', 0, '', 134, 135, 0, '*', 1),
(16, 'menu', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', 0, 1, 1, 24, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:redirect', 0, '', 145, 146, 0, '*', 1),
(17, 'menu', 'com_search', 'Search', '', 'Search', 'index.php?option=com_search', 'component', 0, 1, 1, 19, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:search', 0, '', 137, 138, 0, '*', 1),
(18, 'menu', 'com_weblinks', 'Weblinks', '', 'Weblinks', 'index.php?option=com_weblinks', 'component', 0, 1, 1, 21, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 139, 144, 0, '*', 1),
(19, 'menu', 'com_weblinks_links', 'Links', '', 'Weblinks/Links', 'index.php?option=com_weblinks', 'component', 0, 18, 2, 21, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 140, 141, 0, '*', 1),
(20, 'menu', 'com_weblinks_categories', 'Categories', '', 'Weblinks/Categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', 0, 18, 2, 6, 0, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks-cat', 0, '', 142, 143, 0, '*', 1),
(101, 'mainmenu', 'Home', 'home', '', 'home', 'index.php?option=com_content&view=featured', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 8, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"0","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_hits":"","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"Halcyon - January 2012 Template Demo","show_page_heading":0,"page_heading":"","pageclass_sfx":"jan12-home","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 11, 24, 1, '*', 0),
(104, 'main', 'RokCandy', 'rokcandy', '', 'rokcandy', 'index.php?option=com_rokcandy', 'component', 0, 1, 1, 10022, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_rokcandy/assets/rokcandy-icon-16.png', 0, '', 147, 152, 0, '', 1),
(105, 'main', 'Macros', 'macros', '', 'rokcandy/macros', 'index.php?option=com_rokcandy', 'component', 0, 104, 2, 10022, 0, 0, '0000-00-00 00:00:00', 0, 1, 'images/blank.png', 0, '', 148, 149, 0, '', 1),
(106, 'main', 'Categories', 'categories', '', 'rokcandy/categories', 'index.php?option=com_categories&extension=com_rokcandy', 'component', 0, 104, 2, 10022, 0, 0, '0000-00-00 00:00:00', 0, 1, 'images/blank.png', 0, '', 150, 151, 0, '', 1),
(107, 'mainmenu', 'Features', 'features', '', 'features', 'index.php?option=com_content&view=article&id=1', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 25, 44, 0, '*', 0),
(108, 'mainmenu', 'Module Variations', 'module-variations', '', 'features/module-variations', 'index.php?option=com_content&view=article&id=2', 'component', 1, 107, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 26, 27, 0, '*', 0),
(109, 'mainmenu', 'Module Positions', 'module-positions', '', 'features/module-positions', 'index.php?option=com_content&view=article&id=3', 'component', 1, 107, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 28, 29, 0, '*', 0),
(110, 'mainmenu', 'Typography', 'typography', '', 'features/typography', 'index.php?option=com_content&view=article&id=4', 'component', 1, 107, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 30, 31, 0, '*', 0),
(111, 'mainmenu', 'Extensions', 'extensions', '', 'extensions', 'index.php?option=com_content&view=article&id=5', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 45, 60, 0, '*', 0),
(112, 'mainmenu', 'Tutorials', 'tutorials', '', 'tutorials', 'index.php?option=com_content&view=article&id=6', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 9, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 61, 74, 0, '*', 0),
(113, 'mainmenu', 'Installation', 'installation', '', 'tutorials/installation', 'index.php?option=com_content&view=article&id=7', 'component', 1, 112, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 62, 63, 0, '*', 0),
(114, 'mainmenu', 'Menu Options', 'menu-options', '', 'tutorials/menu-options', 'index.php?option=com_content&view=article&id=8', 'component', 1, 112, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 64, 65, 0, '*', 0),
(115, 'mainmenu', 'Logo Editing', 'logo-editing', '', 'tutorials/logo-editing', 'index.php?option=com_content&view=article&id=9', 'component', 1, 112, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 10, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 66, 67, 0, '*', 0),
(116, 'mainmenu', 'Styles', 'styles', '', 'styles', 'index.php?option=com_content&view=article&id=10', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 75, 100, 0, '*', 0),
(117, 'mainmenu', 'Sample Content', 'sample-content', '', 'features/sample-content', 'index.php?option=com_content&view=article&id=11', 'component', 1, 107, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 32, 41, 0, '*', 0),
(118, 'mainmenu', 'Child Item', 'child-item-01', '', 'features/sample-content/child-item-01', 'index.php?option=com_content&view=article&id=11', 'component', 1, 117, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 33, 34, 0, '*', 0),
(119, 'mainmenu', 'Child Item', 'child-item-02', '', 'features/sample-content/child-item-02', 'index.php?option=com_content&view=article&id=11', 'component', 1, 117, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 35, 36, 0, '*', 0),
(120, 'mainmenu', 'Child Item', 'child-item-03', '', 'features/sample-content/child-item-03', 'index.php?option=com_content&view=article&id=11', 'component', 1, 117, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 37, 38, 0, '*', 0),
(121, 'mainmenu', 'Child Item', 'child-item-04', '', 'features/sample-content/child-item-04', 'index.php?option=com_content&view=article&id=11', 'component', 1, 117, 3, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 39, 40, 0, '*', 0),
(122, 'mainmenu', 'Gantry Framework', '2011-12-15-16-11-18', '', 'features/2011-12-15-16-11-18', 'http://www.gantry-framework.org/', 'url', 1, 107, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 42, 43, 0, '*', 0),
(123, 'mainmenu', 'RocketLauncher', '2011-12-15-16-12-00', '', 'tutorials/2011-12-15-16-12-00', 'index.php?Itemid=', 'alias', 1, 112, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"113","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 68, 69, 0, '*', 0),
(124, 'mainmenu', 'Forum Guides', '2011-12-15-16-12-49', '', 'tutorials/2011-12-15-16-12-49', 'http://www.rockettheme.com/forum/index.php?f=577&rb_v=viewforum', 'url', 1, 112, 2, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 70, 71, 0, '*', 0),
(125, 'mainmenu', 'Gantry Documentation', '2011-12-15-16-13-17', '', 'tutorials/2011-12-15-16-13-17', 'http://www.gantry-framework.org/documentation', 'url', 1, 112, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1}', 72, 73, 0, '*', 0),
(126, 'mainmenu', 'J! Stuff', 'j-stuff', '', 'j-stuff', 'index.php?option=com_content&view=article&id=11', 'component', 1, 1, 1, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 101, 110, 0, '*', 0),
(127, 'mainmenu', 'Category Blog', 'category-blog', '', 'j-stuff/category-blog', 'index.php?option=com_content&view=category&layout=blog&id=11', 'component', 1, 126, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"1","num_links":"","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 102, 103, 0, '*', 0),
(128, 'mainmenu', 'Member Access', 'member-access', '', 'j-stuff/member-access', 'index.php?option=com_users&view=login', 'component', 1, 126, 2, 25, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"login_redirect_url":"","logindescription_show":"1","login_description":"","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 104, 105, 0, '*', 0),
(129, 'mainmenu', 'Contact Us', 'contact-us', '', 'j-stuff/contact-us', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 126, 2, 8, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 106, 107, 0, '*', 0),
(130, 'mainmenu', 'Web Links', 'web-links', '', 'j-stuff/web-links', 'index.php?option=com_weblinks&view=category&id=12', 'component', 1, 126, 2, 21, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_num_links":"","show_pagination_limit":"","show_headings":"","show_link_description":"","show_link_hits":"","show_pagination":"","show_pagination_results":"","show_feed_link":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"259","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 108, 109, 0, '*', 0),
(131, 'mainmenu', 'RokStories', 'rokstories', '', 'extensions/rokstories', 'index.php?option=com_content&view=article&id=20', 'component', 1, 111, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"259","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 50, 51, 0, '*', 0),
(132, 'mainmenu', 'RokNewsPager', 'roknewspager', '', 'extensions/roknewspager', 'index.php?option=com_content&view=article&id=21', 'component', 1, 111, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"259","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 52, 53, 0, '*', 0),
(133, 'mainmenu', 'RokTabs', 'roktabs', '', 'extensions/roktabs', 'index.php?option=com_content&view=article&id=22', 'component', 1, 111, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 48, 49, 0, '*', 0),
(134, 'mainmenu', 'RokFeatureTable', 'rokfeaturetable', '', 'extensions/rokfeaturetable', 'index.php?option=com_content&view=article&id=23', 'component', 1, 111, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 54, 55, 0, '*', 0),
(135, 'main', 'RokEcwid', 'rokecwid', '', 'rokecwid', 'index.php?option=com_rokecwid', 'component', 0, 1, 1, 10030, 0, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_rokecwid/assets/images/ecwid_16.png', 0, '', 153, 154, 0, '', 1),
(136, 'topmenu', 'RocketTheme', '2011-12-27-23-38-02', '', '2011-12-27-23-38-02', 'http://www.rockettheme.com/', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 155, 156, 0, '*', 0),
(137, 'topmenu', 'Forum', '2011-12-27-23-38-3', '', '2011-12-27-23-38-3', 'http://www.rockettheme.com/forum/', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 157, 158, 0, '*', 0),
(138, 'topmenu', 'Download', '2011-12-27-23-38-4', '', '2011-12-27-23-38-4', 'http://www.rockettheme.com/joomla-templates/halcyon', 'url', 1, 1, 1, 0, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 159, 160, 0, '*', 0),
(139, 'mainmenu', 'Ecwid Styled Support', '2011-12-28-15-20-39', '', 'home/2011-12-28-15-20-39', 'index.php?Itemid=', 'alias', 1, 101, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"145","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 12, 13, 0, '*', 0),
(140, 'mainmenu', 'SpliceMenu Available', '2011-12-28-15-20-59', '', 'home/2011-12-28-15-20-59', 'index.php?Itemid=', 'alias', 1, 101, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"114","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 14, 15, 0, '*', 0),
(141, 'mainmenu', 'Gantry Framework', '2011-12-28-15-21-18', '', 'home/2011-12-28-15-21-18', 'index.php?Itemid=', 'alias', 1, 101, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"107","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 16, 17, 0, '*', 0),
(142, 'mainmenu', 'Fusion with MegaMenu', '2011-12-28-15-21-57', '', 'home/2011-12-28-15-21-57', 'index.php?Itemid=', 'alias', 1, 101, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"114","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 18, 19, 0, '*', 0),
(143, 'mainmenu', 'Triple Level SplitMenu', '2011-12-28-15-22-24', '', 'home/2011-12-28-15-22-24', 'index.php?Itemid=', 'alias', 1, 101, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"114","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 20, 21, 0, '*', 0),
(144, 'mainmenu', 'Light/Dark Styles', '2011-12-28-15-22-39', '', 'home/2011-12-28-15-22-39', 'index.php?Itemid=', 'alias', 1, 101, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"116","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"241","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 22, 23, 0, '*', 0),
(145, 'mainmenu', 'Ecwid', 'ecwid', '', 'ecwid', 'index.php?option=com_rokecwid&view=ecwid', 'component', 1, 1, 1, 10030, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"storeID":"879302","enableInlineSeoCatalog":"","categoriesPerRow":"","defaultCategory":"","categoryView":"","enableHTMLMode":"","searchView":"","grid":"3,3","list":"","table":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"259","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 111, 118, 0, '*', 0),
(146, 'mainmenu', 'RokEcwid Information', '2011-12-28-20-34-18', '', 'ecwid/2011-12-28-20-34-18', 'index.php?Itemid=', 'alias', 1, 145, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"145","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"259","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 112, 113, 0, '*', 0),
(147, 'mainmenu', 'Ecwid Sign Up', '2011-12-28-20-35-21', '', 'ecwid/2011-12-28-20-35-21', 'http://www.ecwid.com/', 'url', 1, 145, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"259","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 114, 115, 0, '*', 0),
(148, 'mainmenu', 'Ecwid Support', '2011-12-28-20-35-49', '', 'ecwid/2011-12-28-20-35-49', 'http://www.ecwid.com/help.html', 'url', 1, 145, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"259","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 116, 117, 0, '*', 0),
(149, 'mainmenu', 'Preset 1', '2011-12-28-23-55-20', '', 'styles/2011-12-28-23-55-20', '?presets=preset1', 'url', 1, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 76, 77, 0, '*', 0),
(150, 'mainmenu', 'Preset 2', '2011-12-28-23-55-21', '', 'styles/2011-12-28-23-55-21', '?presets=preset2', 'url', 1, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 78, 79, 0, '*', 0),
(151, 'mainmenu', 'Preset 3', '2011-12-28-23-55-22', '', 'styles/2011-12-28-23-55-22', '?presets=preset3', 'url', 1, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 80, 81, 0, '*', 0),
(152, 'mainmenu', 'Preset 4', '2011-12-28-23-55-23', '', 'styles/2011-12-28-23-55-23', '?presets=preset4', 'url', 1, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 82, 83, 0, '*', 0),
(153, 'mainmenu', 'Preset 5', '2011-12-28-23-55-24', '', 'styles/2011-12-28-23-55-24', '?presets=preset5', 'url', 1, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 84, 85, 0, '*', 0),
(154, 'mainmenu', 'Preset 6', '2011-12-28-23-55-25', '', 'styles/2011-12-28-23-55-25', '?presets=preset6', 'url', 1, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 86, 87, 0, '*', 0),
(155, 'mainmenu', 'Preset 7', '2011-12-28-23-55-26', '', 'styles/2011-12-28-23-55-26', '?presets=preset7', 'url', 1, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 88, 89, 0, '*', 0),
(156, 'mainmenu', 'Preset 8', '2011-12-28-23-55-27', '', 'styles/2011-12-28-23-55-27', '?presets=preset8', 'url', 1, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 90, 91, 0, '*', 0),
(157, 'mainmenu', 'Preset 9', '2011-12-28-23-55-28', '', 'styles/2011-12-28-23-55-28', '?presets=preset9', 'url', 1, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 92, 93, 0, '*', 0),
(158, 'mainmenu', 'Preset 10', '2011-12-28-23-55-29', '', 'styles/2011-12-28-23-55-29', '?presets=preset10', 'url', 1, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 94, 95, 0, '*', 0),
(159, 'mainmenu', 'Preset 11', '2011-12-28-23-55-30', '', 'styles/2011-12-28-23-55-30', '?presets=preset11', 'url', -2, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 96, 97, 0, '*', 0),
(160, 'mainmenu', 'Preset 12', '2011-12-28-23-55-31', '', 'styles/2011-12-28-23-55-31', '?presets=preset12', 'url', -2, 116, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"142","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 98, 99, 0, '*', 0),
(161, 'mainmenu', 'RokAjaxSearch', 'rokajaxsearch', '', 'extensions/rokajaxsearch', 'index.php?option=com_content&view=article&id=31', 'component', 1, 111, 2, 22, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"259","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 56, 57, 0, '*', 0),
(162, 'mainmenu', 'Ecwid', '2011-12-29-02-30-33', '', 'extensions/2011-12-29-02-30-33', 'index.php?Itemid=', 'alias', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"145","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"259","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 46, 47, 0, '*', 0),
(163, 'mainmenu', 'RokNavMenu', '2011-12-29-02-30-57', '', 'extensions/2011-12-29-02-30-57', 'index.php?Itemid=', 'alias', 1, 111, 2, 0, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"114","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"fusion_item_subtext":"","fusion_customimage":"","fusion_customclass":"","fusion_columns":"1","fusion_distribution":"even","fusion_manual_distribution":"","fusion_dropdown_width":"","fusion_column_widths":"","fusion_children_group":"0","fusion_children_type":"menuitems","fusion_modules":"259","fusion_module_positions":"","splitmenu_item_subtext":"","splicemenu_item_subtext":""}', 58, 59, 0, '*', 0);

-- --------------------------------------------------------

--
-- Table structure for table `#__menu_types`
--

DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE IF NOT EXISTS `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
);

--
-- Dumping data for table `#__menu_types`
--

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES
(1, 'mainmenu', 'Main Menu', 'The main menu for the site'),
(2, 'topmenu', 'Top Menu', '');

-- --------------------------------------------------------

--
-- Table structure for table `#__messages`
--

DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE IF NOT EXISTS `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
);

--
-- Dumping data for table `#__messages`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__messages_cfg`
--

DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE IF NOT EXISTS `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
);

--
-- Dumping data for table `#__messages_cfg`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__modules`
--

DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE IF NOT EXISTS `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
);

--
-- Dumping data for table `#__modules`
--

INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(2, 'Login', '', '', 1, 'login', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '', 1, '*'),
(3, 'Popular Articles', '', '', 3, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_popular', 3, 1, '{"count":"5","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(4, 'Recently Added Articles', '', '', 4, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_latest', 3, 1, '{"count":"5","ordering":"c_dsc","catid":"","user_id":"0","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(8, 'Toolbar', '', '', 1, 'toolbar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_toolbar', 3, 1, '', 1, '*'),
(9, 'Quick Icons', '', '', 1, 'icon', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_quickicon', 3, 1, '', 1, '*'),
(10, 'Logged-in Users', '', '', 2, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_logged', 3, 1, '{"count":"5","name":"1","layout":"_:default","moduleclass_sfx":"","cache":"0","automatic_title":"1"}', 1, '*'),
(12, 'Admin Menu', '', '', 1, 'menu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 3, 1, '{"layout":"","moduleclass_sfx":"","shownew":"1","showhelp":"1","cache":"0"}', 1, '*'),
(13, 'Admin Submenu', '', '', 1, 'submenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_submenu', 3, 1, '', 1, '*'),
(14, 'User Status', '', '', 2, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_status', 3, 1, '', 1, '*'),
(15, 'Title', '', '', 1, 'title', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_title', 3, 1, '', 1, '*'),
(79, 'Multilanguage status', '', '', 1, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_multilangstatus', 3, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(85, 'Top A', '', '<p><a class="rt-upper" href="javascript:void(0);">top-a</a> <em>with</em> its <strong>default</strong> styling.</p>', 0, 'top-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(86, 'Top B', '', '<p><a class="rt-upper" href="javascript:void(0);">top-b</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'top-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(87, 'Top C', '', '<p><a class="rt-upper" href="javascript:void(0);">top-c</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'top-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(88, 'Top D', '', '<p><a class="rt-upper" href="javascript:void(0);">top-d</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'top-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(89, 'Top E', '', '<p><a class="rt-upper" href="javascript:void(0);">top-e</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'top-e', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(90, 'Top F', '', '<p><a class="rt-upper" href="javascript:void(0);">top-f</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'top-f', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(91, 'Header A', '', '<p><a class="rt-upper" href="javascript:void(0);">header-a</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'header-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(92, 'Header B', '', '<p><a class="rt-upper" href="javascript:void(0);">header-b</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'header-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(93, 'Header C', '', '<p><a class="rt-upper" href="javascript:void(0);">header-c</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'header-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(94, 'Header D', '', '<p><a class="rt-upper" href="javascript:void(0);">header-d</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'header-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(95, 'Header E', '', '<p><a class="rt-upper" href="javascript:void(0);">header-e</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'header-e', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(96, 'Header F', '', '<p><a class="rt-upper" href="javascript:void(0);">header-f</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'header-f', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(97, 'Showcase A', '', '<p><a class="rt-upper" href="javascript:void(0);">showcase-a</a> <em>using</em> the <strong>icon1</strong> module class suffix.</p>', 1, 'showcase-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(98, 'Showcase B', '', '<p><a class="rt-upper" href="javascript:void(0);">showcase-b</a> <em>using</em> the <strong>icon2</strong> module class suffix.</p>', 1, 'showcase-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon2","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(99, 'Showcase C', '', '<p><a class="rt-upper" href="javascript:void(0);">showcase-c</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'showcase-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(100, 'Showcase D', '', '<p><a class="rt-upper" href="javascript:void(0);">showcase-d</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'showcase-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(101, 'Showcase E', '', '<p><a class="rt-upper" href="javascript:void(0);">showcase-\r\ne</a> <em>using</em> the <strong>icon3</strong> module class suffix.</p>', 1, 'showcase-e', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon3","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(102, 'Showcase F', '', '<p><a class="rt-upper" href="javascript:void(0);">showcase-f</a> <em>using</em> the <strong>icon4</strong> module class suffix.</p>', 1, 'showcase-f', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon4","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(103, 'Feature A', '', '<p><a class="rt-upper" href="javascript:void(0);">feature-a</a> <em>using</em> the <strong>icon5</strong> module class suffix.</p>', 1, 'feature-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon5","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(104, 'Feature B', '', '<p><a class="rt-upper" href="javascript:void(0);">feature-b</a> <em>using</em> the <strong>icon6</strong> module class suffix.</p>', 1, 'feature-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon6","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(105, 'Feature C', '', '<p><a class="rt-upper" href="javascript:void(0);">feature-c</a> <em>using</em> the <strong>icon7</strong> module class suffix.</p>', 1, 'feature-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon7","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(106, 'Feature D', '', '<p><a class="rt-upper" href="javascript:void(0);">feature-d</a> <em>using</em> the <strong>icon8</strong> module class suffix.</p>', 1, 'feature-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon8","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(107, 'Feature E', '', '<p><a class="rt-upper" href="javascript:void(0);">feature-e</a> <em>using</em> the <strong>icon9</strong> module class suffix.</p>', 1, 'feature-e', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon9","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(108, 'Feature F', '', '<p><a class="rt-upper" href="javascript:void(0);">feature-f</a> <em>using</em> the <strong>icon10</strong> module class suffix.</p>', 1, 'feature-f', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon10","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(109, 'Utility A', '', '<p><a class="rt-upper" href="javascript:void(0);">utility-a</a> <em>using</em> the <strong>icon11</strong> module class suffix.</p>', 1, 'utility-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon11","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(110, 'Utility B', '', '<p><a class="rt-upper" href="javascript:void(0);">utility-b</a> <em>using</em> the <strong>icon12</strong> module class suffix.</p>', 1, 'utility-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon12","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(111, 'Utility C', '', '<p><a class="rt-upper" href="javascript:void(0);">utility-c</a> <em>using</em> the <strong>icon13</strong> module class suffix.</p>', 1, 'utility-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon13","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(112, 'Utility D', '', '<p><a class="rt-upper" href="javascript:void(0);">utility-d</a> <em>using</em> the <strong>icon14</strong> module class suffix.</p>', 1, 'utility-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon14","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(113, 'Utility E', '', '<p><a class="rt-upper" href="javascript:void(0);">utility-e</a> <em>using</em> the <strong>icon15</strong> module class suffix.</p>', 1, 'utility-e', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon15","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(114, 'Utility F', '', '<p><a class="rt-upper" href="javascript:void(0);">utility-f</a> <em>using</em> the <strong>icon16</strong> module class suffix.</p>', 1, 'utility-f', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon16","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(115, 'MainTop A', '', '<p><a class="rt-upper" href="javascript:void(0);">maintop-a</a> <em>using</em> the <strong>icon17</strong> module class suffix.</p>', 1, 'maintop-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon17","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(116, 'MainTop B', '', '<p><a class="rt-upper" href="javascript:void(0);">maintop-b</a> <em>using</em> the <strong>icon18</strong> module class suffix.</p>', 1, 'maintop-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon18","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(117, 'MainTop C', '', '<p><a class="rt-upper" href="javascript:void(0);">maintop-c</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'maintop-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(118, 'MainTop D', '', '<p><a class="rt-upper" href="javascript:void(0);">maintop-d</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'maintop-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(119, 'MainTop E', '', '<p><a class="rt-upper" href="javascript:void(0);">maintop-e</a> <em>using</em> the <strong>icon19</strong> module class suffix.</p>', 1, 'maintop-e', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon19","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(120, 'MainTop F', '', '<p><a class="rt-upper" href="javascript:void(0);">maintop-f</a> <em>using</em> the <strong>icon20</strong> module class suffix.</p>', 1, 'maintop-f', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon20","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(121, 'Content Top A', '', '<p><a class="rt-upper" href="javascript:void(0);">content-top-a</a> <em>using</em> the <strong>icon21</strong> module class suffix.</p>', 1, 'content-top-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon21","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(122, 'Content Top B', '', '<p><a class="rt-upper" href="javascript:void(0);">content-top-b</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'content-top-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(123, 'Content Top C', '', '<p><a class="rt-upper" href="javascript:void(0);">content-top-c</a> <em>using</em> the <strong>icon22</strong> module class suffix.</p>', 1, 'content-top-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon22","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(124, 'Content Bottom A', '', '<p><a class="rt-upper" href="javascript:void(0);">content-bottom-a</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(125, 'Content Bottom B', '', '<p><a class="rt-upper" href="javascript:void(0);">content-bottom-b</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'content-bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(126, 'Content Bottom C', '', '<p><a class="rt-upper" href="javascript:void(0);">content-bottom-c</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'content-bottom-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(127, 'Sidebar A', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-a</a> <em>using</em> the <strong>icon23</strong> suffix</p>\r\n<p>Cras auctor libero vitae sem vestibul.</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 13, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon23","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(128, 'Sidebar A', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-a</a> <em>using</em> the <strong>box1</strong> suffix</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 9, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(129, 'Sidebar A', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-a</a> <em>using</em> the <strong>title1</strong> suffix</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 10, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(130, 'Sidebar B', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-b</a> <em>using</em> the <strong>icon24</strong> suffix</p>\r\n<p>Cras auctor libero vitae sem vestibul.</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 5, 'sidebar-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon24","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(131, 'Sidebar B', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-b</a> <em>using</em> the <strong>box2</strong> suffix</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 3, 'sidebar-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box2","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(132, 'Sidebar B', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-b</a> <em>using</em> the <strong>title2</strong> suffix</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 4, 'sidebar-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title2","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(133, 'Sidebar C', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-c</a> <em>using</em> the <strong>box3</strong> suffix</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 1, 'sidebar-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"box3","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(134, 'Sidebar C', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-c</a> <em>using</em> the <strong>title3</strong> suffix</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 2, 'sidebar-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title3","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(135, 'Sidebar C', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-c</a> <em>using</em> the <strong>icon25</strong> suffix</p>\r\n<p>Cras auctor libero vitae sem vestibul.</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 3, 'sidebar-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon25","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(136, 'MainBottom A', '', '<p><a class="rt-upper" href="javascript:void(0);">mainbottom-a</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'mainbottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(137, 'MainBottom B', '', '<p><a class="rt-upper" href="javascript:void(0);">mainbottom-b</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'mainbottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(138, 'MainBottom C', '', '<p><a class="rt-upper" href="javascript:void(0);">mainbottom-c</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'mainbottom-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(139, 'MainBottom D', '', '<p><a class="rt-upper" href="javascript:void(0);">mainbottom-d</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'mainbottom-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(140, 'MainBottom E', '', '<p><a class="rt-upper" href="javascript:void(0);">mainbottom-e</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'mainbottom-e', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(141, 'MainBottom F', '', '<p><a class="rt-upper" href="javascript:void(0);">mainbottom-f</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'mainbottom-f', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(142, 'Bottom A', '', '<p><a class="rt-upper" href="javascript:void(0);">bottom-a</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(143, 'Bottom B', '', '<p><a class="rt-upper" href="javascript:void(0);">bottom-b</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(144, 'Bottom C', '', '<p><a class="rt-upper" href="javascript:void(0);">bottom-c</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'bottom-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(145, 'Bottom D', '', '<p><a class="rt-upper" href="javascript:void(0);">bottom-d</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'bottom-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(146, 'Bottom E', '', '<p><a class="rt-upper" href="javascript:void(0);">bottom-e</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'bottom-e', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(147, 'Bottom F', '', '<p><a class="rt-upper" href="javascript:void(0);">bottom-f</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'bottom-f', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(148, 'Footer A', '', '<p><a class="rt-upper" href="javascript:void(0);">footer-a</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(149, 'Footer B', '', '<p><a class="rt-upper" href="javascript:void(0);">footer-b</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(150, 'Footer C', '', '<p><a class="rt-upper" href="javascript:void(0);">footer-c</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'footer-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(151, 'Footer D', '', '<p><a class="rt-upper" href="javascript:void(0);">footer-d</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'footer-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(152, 'Footer E', '', '<p><a class="rt-upper" href="javascript:void(0);">footer-e</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'footer-e', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(153, 'Footer F', '', '<p><a class="rt-upper" href="javascript:void(0);">footer-f</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'footer-f', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(154, 'Demo Information', '', '<p>All demo content is for sample purposes only, intended to represent a live site. Download a launcher pack to copy the demo.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=7&amp;Itemid=114" class="readon"><span>Read More</span></a>', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(155, 'Joomla! Documentation', '', '<p>Joomla.org is an invaluable resource for general instructions and information on how to use, configure and modify Joomla.</p>\r\n<a href="http://docs.joomla.org" class="readon" target="_blank"><span>Read More</span></a>', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(156, 'Gantry Support', '', '<p>More extensive details of the Gantry Framework, inclusive of both written and video tutorials, available on the Gantry site.</p>\r\n<a href="http://gantry-framework.org/" target="_blank" class="readon"><span>Read More</span></a>', 1, 'footer-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(157, 'RocketTheme Addons', '', '<p>This demo includes a series of RocketTheme Extensions, with template specific styling.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=5&amp;Itemid=112" class="readon"><span>Included Extensions</span></a>', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(158, 'Tutorial Information', '', '<p>This site has a range of guides to introduce you to the basics of the template.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=6&amp;Itemid=113" class="readon"><span>Available Guides</span></a>', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(159, 'Valid Code', '', '<p>The template has valid code, based on the XHTML 1.0 Transitional standards.</p>\r\n<a href="http://validator.w3.org/check?uri=http%3A%2F%2Fdemo.rockettheme.com%2Fjoomla15/halcyon&amp;charset=%28detect+automatically%29&amp;doctype=Inline&amp;group=0" class="readon" target="_blank"><span>Validate Now</span></a>', 1, 'footer-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(160, 'Installation Process', '', '<p>Download and install the <strong>Bundle</strong> file if Gantry is not installed, use the Standard Template file if <a href="index.php?option=com_content&amp;view=article&amp;id=7&amp;Itemid=114">Gantry</a> is already present.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=7&amp;Itemid=114" class="readon"><span>More Information</span></a>', 1, 'mainbottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(161, 'RocketLauncher - Demo Replica', '', '<p>Deploy a <a href="index.php?option=com_content&amp;view=article&amp;id=7&amp;Itemid=114">replica</a> of the this month''s demo with ease, using the readily available <strong>RocketLauncher</strong> package.</p><a href="index.php?option=com_content&amp;view=article&amp;id=7&amp;Itemid=114" class="readon"><span>More Information</span></a>', 1, 'mainbottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(162, 'Menu Options', '', '<p>The template supports <strong>two</strong> menu systems, the Mootools enhanced CSS dropdown menu <strong>Fusion Menu</strong>, and the venerable <strong>Splitmenu</strong>.</p>\r\n\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=115" class="readon"><span>Read More</span></a>', 1, 'mainbottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(163, 'Logo Customization', '', '<p>The template supports <strong>two</strong> menu systems, the Mootools enhanced CSS dropdown menu <strong>Fusion Menu</strong>, and the venerable <strong>Splitmenu</strong>.</p>\r\n\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=116" class="readon"><span>Read More</span></a>', 1, 'mainbottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(225, 'Login Form', '', '', 11, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(226, 'Newsflash Item', '', '', 5, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_news', 1, 1, '{"catid":["11"],"image":"0","item_title":"0","link_titles":"","item_heading":"h4","showLastSeparator":"1","readmore":"0","count":"5","ordering":"a.publish_up","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(227, 'Video Tutorials', '', '<ul class="dots">\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/video/joomla15/installing-rocketlauncher-joomla15.mov" title="Video Tutorial :: Joomla RocketLauncher Installation Video Tutorial" rel="rokbox[503 356]">RocketLauncher</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/video/joomla15/template-installation-joomla15.mov" title="Video Tutorial :: Joomla Template Installation Video Tutorial" rel="rokbox[800 620]">Template Installation</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/video/joomla15/menu-configuration-joomla15.mov" title="Video Tutorial :: Joomla Menu Setup Video Tutorial" rel="rokbox[504 336]">Menu Setup</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/video/joomla15/using-typography-joomla15.mov" title="Video Tutorial :: Joomla Using Typography Video Tutorial" rel="rokbox[540 380]">Using Typography</a></li>	\r\n	<li><a class="normalfont" rel="rokbox[504 360]" title="Video Tutorial :: Joomla 1.5 Template Management" href="http://www.rockettheme.com/video/joomla15/template-manager-joomla15.mov">Template Management</a></li>\r\n	<li><a class="normalfont" rel="rokbox[504 336]" title="Video Tutorial :: Joomla 1.5 Using Custom Modules" href="http://www.rockettheme.com/video/joomla15/custom-modules-joomla15.mov">Custom Modules</a></li>\r\n	<li><a class="normalfont" rel="rokbox[504 336]" title="Video Tutorial :: Joomla 1.5 Using the Extensions Manager" href="http://www.rockettheme.com/video/joomla15/extensions-manager-joomla15.mov">Extensions Manager</a></li>\r\n	<li><a class="normalfont" rel="rokbox[504 336](joomla15basic)" title="Video Tutorial :: Joomla 1.5 Menu Access Levels" href="http://www.rockettheme.com/video/joomla15/menu-access-levels-joomla15.mov">Menu Access</a></li>\r\n</ul>\r\n<a href="http://www.rockettheme.com/joomla-tutorials/video-tutorials" target="_blank" class="readon"><span>View All</span></a>', 6, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(228, 'Forum Guides', '', '<ul class="dots">\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152329&amp;rb_v=viewtopic" target="_blank">Template FAQs</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152327&amp;rb_v=viewtopic" target="_blank">User Guide &amp; Support</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152323&amp;rb_v=viewtopic" target="_blank">Mobile Theme Settings</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152324&amp;rb_v=viewtopic" target="_blank">Demo Content Info</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152307&amp;rb_v=viewtopic" target="_blank">Editing the Logo</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152316&amp;rb_v=viewtopic" target="_blank">Editing Template Text</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152320&amp;rb_v=viewtopic" target="_blank">Popup Module</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152318&amp;rb_v=viewtopic" target="_blank">RokBox Member Login</a></li>\r\n</ul>\r\n<a class="readon" target="_blank" href="http://www.rockettheme.com/forum/index.php?f=577&amp;rb_v=viewforum"><span>View All</span></a>', 7, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(229, 'Download', '', '<p>There are two places to download the Halcyon Extensions from:</p>\r\n\r\n<ul class="circle-checkmark largemarginbottom normalfont">\r\n	<li><strong>Halcyon:</strong> the <strong>(J15) rt_halcyon_j15-extensions.zip</strong> or <strong>(J17) rt_halcyon-extensions.zip</strong> (unzip first) contains all the extensions used for Halcyon.</li>\r\n	<li><strong>Extensions:</strong> the individual extensions are available from the Extensions section of RokDownloads.</li>\r\n</ul>\r\n\r\n<a href="http://www.rockettheme.com/extensions-downloads/" target="_blank" class="readon"><span>Download Now</span></a>', 8, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(230, 'Ecwid Integration', '', '<img src="images/stories/demo/general/ext-ecwid.png" alt="images" width="78" height="70" class="floatleft" />\r\n<p>Integrated component, and style support for the <strong>FREE</strong> eCommerce platform, <strong>Ecwid</strong> by <a href="http://www.ecwid.com/" target="_blank">Ecwid.com</a></p>\r\n<a href="index.php?option=com_rokecwid&amp;view=ecwid&amp;Itemid=145"  class="readon"><span>More Information</span></a>', 3, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(231, 'Support', '', '<p>If you are a Joomla/Extensions Club Member, you can access the boards of our <strong>Community Forum</strong>, specifically for our Extensions. Browse through previously <strong>answered questions</strong>, or post your questions for resolution.</p>\r\n\r\n<a href="http://www.rockettheme.com/forum/index.php?f=212&amp;rb_v=viewforum" target="_blank" class="readon"><span>View Forum</span></a>', 12, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(232, 'Essential Files', '', '<p>Files required for the template to function:</p>\r\n\r\n<ul class="list-icon checkmark green normalfont nomarginbottom">\r\n	<li><strong>Template (Standalone)</strong> <em><strong>(J15)</strong> rt_halcyon_j15.tgz</em> or <em><strong>(J17)</strong> rt_halcyon.zip</em> - Standalone template file without the Gantry Framework.</li>\r\n	<li><strong>Template (Bundle)</strong> <em><strong>(J15)</strong> rt_halcyon_j15-bundle.zip</em> or <em><strong>(J17)</strong> rt_halcyon-bundle.zip</em> - Template plus the Gantry Framework.</li>\r\n	<li><strong>RokNavMenu</strong> <em><strong>(J15)</strong> rt_halcyon_j15-extensions.zip(<strong>unzip first</strong>) or mod_roknavmenu.zip</em>; or <em><strong>(J17)</strong> rt_halcyon-extensions.zip(<strong>unzip first</strong>) or mod_roknavmenu_j16.zip</em> - Required for the menu to work.</li>\r\n</ul>', 1, 'feature-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(233, 'Additional Files', '', '<p>Ancillary files for the template:</p>\r\n\r\n<ul class="list-icon checkmark green normalfont nomarginbottom">\r\n	<li><strong>Source PNG(s)</strong> <em>rt_halcyon_j15-sources.zip</em> - Adobe® Fireworks PNG source file(s) and any applicable fonts.</li>\r\n	<li><strong>Source BG PNG(s)</strong> <em>rt_halcyon_j15-sources-bg.zip</em> - Adobe® Fireworks PNG BG source file(s) — <em>Only distributed if the template has complex BGs.</em></li>\r\n	<li><strong>Extensions</strong> <em><strong>(J15)</strong> rt_halcyon_j15-extensions.zip</em> or <em><strong>(J17)</strong> rt_halcyon-extensions.zip</em> - All extensions for the template.</li>\r\n	<li><strong>RocketLauncher</strong> <em><strong>(J15)</strong> rt_halcyon_j15-rocketlauncher.zip</em> or <em><strong>(J17)</strong> rt_halcyon-rocketlauncher.zip</em> - Demo replica installer.</li>\r\n</ul>', 2, 'feature-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(234, 'Fusion Menu', '', '<p>A Mootools enhanced CSS dropdown menu, with multi-columns, icons and more.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=114&amp;menu-type=fusionmenu" class="readon"><span>Fusion Menu</span></a>', 3, 'feature-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(235, 'Splice Menu', '', '<p>A Mootools enhanced CSS dropdown menu, with multi-columns, icons and more.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=114&amp;menu-type=splicemenu" class="readon"><span>SpliceMenu</span></a>', 4, 'feature-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(236, 'Split Menu', '', '<p>A static two level menu with 1st level items in the header area, and all others in the sidebar.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=114&amp;menu-type=splitmenu" class="readon"><span>SplitMenu</span></a>', 5, 'feature-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(237, 'No Menu', '', '<p>An option to disable the menu, allowing for normal module use of the navigation position.</p>', 6, 'feature-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(238, 'Editing Requirements', '', '<ul class="triangle normalfont">\r\n	<li><strong>Adobe® Fireworks:</strong> CS5 is preferred, but CS3/4 will be sufficient.</li>\r\n	<li><strong>Logo Font:</strong> Download and install before proceeding to edit in Fireworks.</li>\r\n	<li><strong>Source File:</strong> Download the <strong>logo-source.png</strong> file from the rt_halcyon_j15-sources.zip package.</li>\r\n</ul>', 1, 'feature-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*');
INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(239, 'Uploading the Logo', '', '<ul class="triangle normalfont">\r\n	<li>Upload <strong>logo<em>#</em>.png</strong> to the <strong style="word-break: break-all">(J15) /templates/rt_halcyon_15/images/logo/*style*/</strong> or <strong style="word-break: break-all">(J17) /templates/rt_halcyon/images/logo/*style*/</strong> directory</li>\r\n  <li>Clear your browser cache and refresh your site.</li>\r\n</ul>\r\n\r\n<p>If you cannot see your new logo, ensure you have uploaded it to the right directory and that the directory permissions are writeable. Enquire with your hosting provider.</p>\r\n\r\n<a class="readon" href="http://www.rockettheme.com/joomla-templates/halcyon" target="_blank"><span>Download Sources Here</span></a>', 8, 'feature-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(240, '# Preset Styles - Preview Live', '', '<p class="notice">View all styles live by appending <strong>?presets=preset#</strong> or <strong>&amp;presets=preset#</strong> to the end of your URL such as <strong><a href="#">http://yoursite.com/index.php?presets=preset4</a></strong>.</p>\r\n\r\n<p>In sequential order, <strong>Preset 1 - Preset 10</strong>. Please click on the image to load a live example of each style variation.</p>\r\n\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=117&amp;presets=preset1">\r\n	<img alt="Preset 1" src="images/stories/demo/styles/ss1.jpg" class="rt-image floatleft medmarginright" width="160" height="408" />\r\n</a>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=117&amp;presets=preset2">\r\n	<img alt="Preset 2" src="images/stories/demo/styles/ss2.jpg" class="rt-image floatleft medmarginright" width="160" height="408" />\r\n</a>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=117&amp;presets=preset3">\r\n	<img alt="Preset 3" src="images/stories/demo/styles/ss3.jpg" class="rt-image floatleft medmarginright" width="160" height="408" />\r\n</a>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=117&amp;presets=preset4">\r\n	<img alt="Preset 4" src="images/stories/demo/styles/ss4.jpg" class="rt-image floatleft medmarginright" width="160" height="408" />\r\n</a>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=117&amp;presets=preset5">\r\n	<img alt="Preset 5" src="images/stories/demo/styles/ss5.jpg" class="rt-image floatleft nomarginright" width="160" height="408" />\r\n</a>\r\n<div class="clear"></div><br />\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=117&amp;presets=preset6">\r\n	<img alt="Preset 6" src="images/stories/demo/styles/ss6.jpg" class="rt-image floatleft medmarginright" width="160" height="408" />\r\n</a>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=117&amp;presets=preset7">\r\n	<img alt="Preset 7" src="images/stories/demo/styles/ss7.jpg" class="rt-image floatleft medmarginright" width="160" height="408" />\r\n</a>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=117&amp;presets=preset8">\r\n	<img alt="Preset 8" src="images/stories/demo/styles/ss8.jpg" class="rt-image floatleft medmarginright" width="160" height="408" />\r\n</a>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=117&amp;presets=preset9">\r\n	<img alt="Preset 9" src="images/stories/demo/styles/ss9.jpg" class="rt-image floatleft medmarginright" width="160" height="408" />\r\n</a>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=10&amp;Itemid=117&amp;presets=preset10">\r\n	<img alt="Preset 10" src="images/stories/demo/styles/ss10.jpg" class="rt-image floatleft nomarginright" width="160" height="408" />\r\n</a>\r\n<div class="clear"></div>', 1, 'feature-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(241, 'Creating your own Preset Style(s)', '', '<ul class="triangle normalfont">\r\n	<li>Go to <strong>Extensions → Template Manager → (J15) rt_halcyon_j15 → Settings; or (J17) rt_halcyon &rarr; Show Presets</strong></li>\r\n	<li>Configure the Settings</li>\r\n	<li>Click <strong>(J15) Save Custom Presets as New</strong>; <strong>(J17) Save Preset</strong></li>\r\n	<li>Follow the <strong>Preset Saver procedure</strong></li>\r\n</ul>\r\n\r\n<p class="notice">You can edit the prebuilt presets in the <strong>gantry.config.php</strong> file, or use the User Interface method outlined above.</p>', 1, 'mainbottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(242, 'Preset Bottom B', '', '<br /><br />\r\n<img class="rt-image floatleft medmarginright " alt="Image" src="images/stories/demo/general/style-1.jpg" height="134" width="200" />\r\n<img class="rt-image " alt="Image" src="images/stories/demo/general/style-2.jpg" height="134" width="200" />', 1, 'mainbottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(251, 'Core Features', '', '<ul class="checkmark green nomarginbottom normalfont">\r\n	<li>10 Preset Styles</li>\r\n	<li>80 Module Positions</li>\r\n	<li>50+ Variations</li>\r\n	<li>FF, Safari, Chrome, Opera, IE7+ Compatible</li>	\r\n	<li>Fusion with MegaMenu, SpliceMenu &amp; SplitMenu</li>\r\n	<li>Ecwid Styling</li>\r\n	<li>RocketTheme Addons</li>\r\n	<li>Custom Typography</li>\r\n	<li>Load Transitions</li>\r\n	<li>RTL Support</li>\r\n	<li>W3C XHTML/CSS Valid</li>\r\n</ul>', 4, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(252, 'Gantry Features', '', '<ul class="checkmark green normalfont nomarginbottom">\r\n	<li>960 Grid System</li>\r\n	<li>Ajax Article Loading</li>\r\n	<li>Image Smart Loading</li>\r\n	<li>Extensive &amp; Intuitive User Interface</li>\r\n	<li>Per-Menu Control</li>\r\n	<li>Per Browser CSS/JS</li>\r\n	<li>iPhone Mobile Theme</li>\r\n	<li>Android Mobile Theme</li>\r\n	<li>GZip/Standard Caching</li>\r\n	<li>Google Web Fonts</li>\r\n	<li>Tableless Overrides</li>\r\n</ul>\r\n<ul class="checkmark red normalfont nomarginbottom">\r\n	<li><a href="http://gantry-framework.org/" target="_blank">More Features</a></li>\r\n</ul>', 1, 'sidebar-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(253, 'Who''s Online', '', '', 14, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_whosonline', 1, 1, '{"showmode":"0","linknames":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(254, 'Forum Guides', '', '<ul class="dots">\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152329&amp;rb_v=viewtopic" target="_blank">Template FAQs</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152327&amp;rb_v=viewtopic" target="_blank">User Guide &amp; Support</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152323&amp;rb_v=viewtopic" target="_blank">Mobile Theme Settings</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152324&amp;rb_v=viewtopic" target="_blank">Demo Content Info</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152307&amp;rb_v=viewtopic" target="_blank">Editing the Logo</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152316&amp;rb_v=viewtopic" target="_blank">Editing Template Text</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152320&amp;rb_v=viewtopic" target="_blank">Popup Module</a></li>\r\n	<li><a class="normalfont" href="http://www.rockettheme.com/forum/index.php?f=577&amp;t=152318&amp;rb_v=viewtopic" target="_blank">RokBox Member Login</a></li>\r\n</ul>\r\n<a class="readon" target="_blank" href="http://www.rockettheme.com/forum/index.php?f=577&amp;rb_v=viewforum"><span>View All</span></a>', 2, 'sidebar-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(255, 'FP Footer A', '', '<span class="text-icon phone smallmarginbottom">+1 (555) 555-5555 / 5556</span>', 0, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(256, 'FP Footer B', '', '<span class="text-icon email smallmarginbottom">noreply&nbsp;@rockettheme.com</span>', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(257, 'FP Footer C', '', '<span class="text-icon facebook smallmarginbottom">facebook.com/rockettheme</span>', 1, 'footer-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(258, 'FP Footer D', '', '<span class="text-icon twitter smallmarginbottom">@rockettheme #halcyon</span>', 1, 'footer-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(259, 'FP Bottom A', '', '<div class="floatleft">\r\n	<div class="smallmarginbottom"><em class="bold nobold">Products</em></div>\r\n	<ul class="dots nomarginbottom">\r\n		<li><a href="#"><em class="nobold normal">Laptops</em></a></li>\r\n		<li><a href="#"><em class="nobold normal">Desktop PC</em></a></li>\r\n		<li><a href="#"><em class="nobold normal">Printers</em></a></li>\r\n		<li class="nomarginbottom"><a href="#"><em class="nobold normal">Tablets</em></a></li>\r\n	</ul>\r\n</div>\r\n<div class="floatleft largemarginleft">\r\n	<div class="smallmarginbottom">&nbsp;</div>\r\n	<ul class="dots nomarginbottom">\r\n		<li><a href="#"><em class="nobold normal">Monitors</em></a></li>\r\n		<li><a href="#"><em class="nobold normal">Keyboards</em></a></li>\r\n		<li><a href="#"><em class="nobold normal">Speakers</em></a></li>\r\n		<li class="nomarginbottom"><a href="#"><em class="nobold normal">Cameras</em></a></li>\r\n	</ul>\r\n</div>\r\n<div class="floatleft largemarginleft">\r\n	<div class="smallmarginbottom">&nbsp;</div>\r\n	<ul class="dots nomarginbottom">\r\n		<li><a href="#"><em class="nobold normal">Storage</em></a></li>\r\n		<li><a href="#"><em class="nobold normal">Phones</em></a></li>\r\n		<li><a href="#"><em class="nobold normal">Accessories</em></a></li>\r\n		<li class="nomarginbottom"><a href="#"><em class="nobold normal">Seasonal</em></a></li>\r\n	</ul>\r\n</div>\r\n<div class="floatleft nomarginright largemarginleft">\r\n	<div class="smallmarginbottom">&nbsp;</div>\r\n	<ul class="dots nomarginbottom">\r\n		<li><a href="#"><em class="nobold normal">Delivery</em></a></li>\r\n		<li><a href="#"><em class="nobold normal">Refunds</em></a></li>\r\n		<li><a href="#"><em class="nobold normal">Careers</em></a></li>\r\n		<li class="nomarginbottom"><a href="#"><em class="nobold normal">Sitemap</em></a></li>\r\n	</ul>\r\n</div>', 1, 'bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(260, 'Demo Information', '', '<div class="floatleft">\r\n	<div class="smallmarginbottom"><em class="bold nobold">Demo Information</em></div>\r\n	<a class="nobold">All demo content is for <strong>sample</strong> purposes only, intended to represent a live site. All images are the copyright of their respective owners. Please download the <strong>RocketLauncher</strong> pack to install a copy of the demo.</a>\r\n</div>', 1, 'bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(261, 'Other Menu Options', '', '<div class="fp-side largepaddingbottom largemarginbottom">\r\n	<img src="images/stories/demo/frontpage/ex1.jpg" width="110" height="82" alt="image" class="rt-image floatleft"/>\r\n	<span><strong>SplitMenu</strong></span><br />\r\n	<span>A basic, horizontal <em>dropline</em> menu system, with configurable options such as <em>suffix</em> and position.</span>\r\n	<div class="clear"></div>\r\n</div>\r\n<div>\r\n	<img src="images/stories/demo/frontpage/ex2.jpg" width="110" height="82" alt="image" class="rt-image floatleft"/>\r\n	<span><strong>Fusion with MegaMenu</strong></span><br />\r\n	<span>A <em>Mootools</em> enhanced, CSS <em>dropdown</em> menu, with animated dropdowns, column width/allocation control plus much more.</span>\r\n	<div class="clear"></div>\r\n</div>', 1, 'extension-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(262, 'Tutorials', '', '<p>Instructions on how to <strong>install</strong> RocketLauncher (demo replica) and the standalone/bundled <strong>template</strong> packages.</p>\r\n<p><a href="index.php?option=com_content&amp;id=7&amp;Itemid=113" class="readon"><span>How to Install</span></a></p>\r\n\r\n<p>Guide on how to customize the logo using the <strong>Adobe&reg; Fireworks</strong> PNG Source images.</p>\r\n<a href="index.php?option=com_content&amp;id=9&amp;Itemid=115" class="readon"><span>Logo Customization</span></a>', 1, 'extension-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(263, 'Promotion', '', '<p><img src="images/stories/demo/frontpage/ex3.jpg" alt="image" width="240" height="180" class="rt-image" /></p>\r\n<span class="rt-upper">Advertisement</span>', 1, 'extension-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(264, 'Individual Module Styling', '', '<p>An assortment of over <strong>50</strong> module class suffixes, both structural and <strong>stylistic</strong>, to create an individual <strong>module</strong> appearance.</p>\r\n<a href="index.php?option=com_content&amp;id=2&amp;Itemid=108" class="readon"><span>More Information</span></a>', 1, 'mainbottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(265, 'Quick Demo Replication', '', '<p><strong>RocketLauncher</strong> is a customized Joomla install, bundled with the <strong>template</strong>, extensions and custom <strong>sample data</strong> and images.</p>\r\n<a href="index.php?option=com_content&amp;id=7&amp;Itemid=113" class="readon"><span>More Information</span></a>', 1, 'mainbottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(266, 'Product Reviews', '', '<blockquote><p>Halcyon is an elegant, subtle and conservatively driven design with many features.</p></blockquote>', 1, 'mainbottom-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(267, 'FP Feature A', '', '<p><img src="images/stories/demo/frontpage/ft1.jpg" alt="image" width="182" height="135" class="rt-image" /></p>\r\n<div class="module-title"><h2 class="title">Ecwid Styling</h2></div>\r\n<p class="nomarginbottom">A <strong>free</strong> and popular third party <strong>ecommerce</strong> extension.</p>', 1, 'feature-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(268, 'FP Feature B', '', '<p><img src="images/stories/demo/frontpage/ft2.jpg" alt="image" width="182" height="135" class="rt-image" /></p>\r\n<div class="module-title"><h2 class="title">SpliceMenu Option</h2></div>\r\n<p class="nomarginbottom">A <strong>dynamic</strong>, interactive, triple level <strong>dropline</strong> menu option.</p>', 1, 'feature-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(269, 'FP Feature C', '', '<p><img src="images/stories/demo/frontpage/ft3.jpg" alt="image" width="182" height="135" class="rt-image" /></p>\r\n<div class="module-title"><h2 class="title">Gantry Framework</h2></div>\r\n<p class="nomarginbottom">The <strong>foundational</strong> platform for all core template <strong>features</strong>.</p>', 1, 'feature-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(270, 'FP Feature D', '', '<p><img src="images/stories/demo/frontpage/ft4.jpg" alt="image" width="182" height="135" class="rt-image" /></p>\r\n<div class="module-title"><h2 class="title">Light &amp; Dark</h2></div>\r\n<p class="nomarginbottom">Configurable <strong>Light</strong> or <strong>Dark</strong> Mainbody styling.</p>', 1, 'feature-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"title1","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(271, 'Top Sellers', '', '<div class="fp-side largemarginbottom"></div>\r\n<div class="fp-side largemarginbottom">\r\n	<img src="images/stories/demo/frontpage/ts1.jpg" width="80" height="62" alt="image" class="rt-image floatleft largemarginbottom" />\r\n	<span><strong>iHome iD3 Speakers</strong></span><br />\r\n	<a href="#">$199.99</a>\r\n	<div class="clear"></div>\r\n</div>\r\n<div class="fp-side largemarginbottom">\r\n	<img src="images/stories/demo/frontpage/ts2.jpg" width="80" height="62" alt="image" class="rt-image floatleft largemarginbottom" />\r\n	<span><strong>Incase Workstation</strong></span><br />\r\n	<a href="#">$29.99</a>\r\n	<div class="clear"></div>\r\n</div>\r\n<div class="fp-side largemarginbottom">\r\n	<img src="images/stories/demo/frontpage/ts3.jpg" width="80" height="62" alt="image" class="rt-image floatleft largemarginbottom" />\r\n	<span><strong>Remote Control Car</strong></span><br />\r\n	<a href="#">$79.99</a>\r\n	<div class="clear"></div>\r\n</div>\r\n<div class="fp-side largemarginbottom">\r\n	<img src="images/stories/demo/frontpage/ts4.jpg" width="80" height="62" alt="image" class="rt-image floatleft largemarginbottom" />\r\n	<span><strong>iPhone Zip Wallet</strong></span><br />\r\n	<a href="#">$89.99</a>\r\n	<div class="clear"></div>\r\n</div>\r\n<div class="fp-side largemarginbottom">\r\n	<img src="images/stories/demo/frontpage/ts5.jpg" width="80" height="62" alt="image" class="rt-image floatleft largemarginbottom" />\r\n	<span><strong>Apple World Travel Kit</strong></span><br />\r\n	<a href="#">$39.99</a>\r\n	<div class="clear"></div>\r\n</div>\r\n<div class="clear"></div>\r\n\r\n<a href="#" class="readon"><span>More Products</span></a>', 2, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon16","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(272, 'FP RokTabs', '', '', 1, 'fproktabs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_roktabs', 1, 0, '{"style":"base","content_type":"joomla","catid":["14"],"show_front":"1","itemsOrdering":"order","strip_tags":"a,i,br,img,div,strong,span,em","show_readmore":"1","readmore":"Read more...","width":"670","tabs_count":"3","duration":"600","transition_type":"scrolling","transition_fx":"Quad.easeInOut","linksMargins":"0","navscrolling":"1","tabs_position":"top","tabs_event":"click","tabs_title":"content","tabs_incremental":"Tab ","tabs_hideh6":"1","tabs_prefixed":"0","tabs_showicons":"0","tabs_iconside":"left","tabs_iconpath":"__module__\\/images","tabs_icon":"icon_home.gif,icon_security.gif,icon_comment.gif,icon_world.gif,icon_note.gif","autoplay":"0","autoplay_delay":"2000","moduleclass_sfx":"","cache":"0","module_cache":"0","cache_time":"900"}', 0, '*'),
(273, 'FP Showcase A', '', '<a href="#" class="readon largemarginleft largemarginright"><span>Free Delivery &amp; Returns</span></a>\r\n<a href="#" class="readon largemarginleft largemarginright"><span>Special/Seasonal Offers</span></a>\r\n<a href="#" class="readon largemarginleft largemarginright"><span>Low Prices Every Week</span></a>\r\n<a href="#" class="readon largemarginleft largemarginright"><span>Request a Catalogue</span></a>', 3, 'showcase-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"nomargintop nopaddingtop nomarginbottom rt-center","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(274, 'FP RokStories', '', '', 2, 'showcase-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_rokstories', 1, 0, '{"moduleclass_sfx":"nopaddingbottom","load_css":"0","layout_type":"layout4","content_type":"","catid":"15","show_front":"1","article_count":"4","itemsOrdering":"order","strip_tags":"a,i,br","content_position":"right","show_article_title":"1","show_created_date":"0","show_article":"0","show_article_link":"0","legacy_readmore":"0","thumb_width":"90","start_width":"auto","user_id":"0","start_element":"0","thumbs_opacity":"0.3","fixed_height":"0","mouse_type":"click","autoplay":"0","autoplay_delay":"5000","show_label_article_title":"1","show_arrows":"1","show_circles":"1","arrows_placement":"inside","show_thumbs":"0","fixed_thumb":"1","link_titles":"0","link_labels":"0","link_images":"0","show_mask":"1","mask_desc_dir":"topdown","mask_imgs_dir":"bottomup","scrollerDuration":"1000","scrollerTransition":"Expo.easeInOut","show_controls":"1","left_offset_x":"-40","left_offset_y":"-100","right_offset_x":"-30","right_offset_y":"-100","left_f_offset_x":"-40","left_f_offset_y":"-100","right_f_offset_x":"-30","right_f_offset_y":"-100","cache":"0","module_cache":"1","cache_time":"900"}', 0, '*'),
(275, 'RokAjaxSearch', '', '', 1, 'header-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_rokajaxsearch', 1, 0, '{"moduleclass_sfx":"","search_page":"index.php?option=com_search&view=search&tmpl=component","adv_search_page":"index.php?option=com_search&view=search","include_css":"0","theme":"dark","searchphrase":"any","ordering":"newest","limit":"10","perpage":"3","websearch":"0","blogsearch":"0","imagesearch":"0","videosearch":"0","websearch_api":"","show_pagination":"1","safesearch":"MODERATE","image_size":"MEDIUM","show_estimated":"1","hide_divs":"","include_link":"1","show_description":"1","include_category":"1","show_readmore":"1"}', 0, '*'),
(276, 'Sample Cart', '', '<div class="cart-badge"><div class="cart-badge-inner">\r\n    	<div class="cart-count">0</div>\r\n    	<div class="cart-title">Shopping Cart</div>\r\n        <div class="cart-desc"><a href="#">Info on Ecwid eCommerce.</a></div>\r\n</div></div>', 1, 'top-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(277, 'Top Menu', '', '', 0, 'top-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{"menutype":"topmenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"horizmenu flush","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(278, 'Joomla! Documentation', '', '<p>Joomla.org is an invaluable resource for general instructions and information on how to use, configure and modify Joomla.</p>\r\n<a href="http://docs.joomla.org" class="readon" target="_blank"><span>Read More</span></a>', 0, 'mainbottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(279, 'Gantry Support', '', '<p>More extensive details of the Gantry Framework, inclusive of both written and video tutorials, available on the Gantry site.</p>\r\n<a href="http://gantry-framework.org/" target="_blank" class="readon"><span>Read More</span></a>', 1, 'mainbottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(280, 'Sidebar A', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-a</a> <em>using</em> the <strong>icon26</strong> suffix</p>\r\n<p>Cras auctor libero vitae sem vestibul.</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 15, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon26","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(281, 'Sidebar B', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-b</a> <em>using</em> the <strong>icon27</strong> suffix</p>\r\n<p>Cras auctor libero vitae sem vestibul.</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 6, 'sidebar-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon27","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(282, 'Sidebar C', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-c</a> <em>using</em> the <strong>icon28</strong> suffix</p>\r\n<p>Cras auctor libero vitae sem vestibul.</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 4, 'sidebar-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon28","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(283, 'Sidebar A', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-a</a> <em>using</em> the <strong>icon29</strong> suffix</p>\r\n<p>Cras auctor libero vitae sem vestibul.</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 16, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon29","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(284, 'Sidebar B', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-b</a> <em>using</em> the <strong>icon30</strong> suffix</p>\r\n<p>Cras auctor libero vitae sem vestibul.</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 7, 'sidebar-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"icon30","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(285, 'Sidebar C', '', '<p><a class="rt-upper" href="javascript:void(0);">sidebar-c</a> <em>with</em> its <strong>default</strong> styling.</p>\r\n<p>Cras auctor libero vitae sem vestibul.</p>\r\n<a href="javascript:void(0);" class="readon"><span>More</span></a>', 5, 'sidebar-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(286, 'Extension A', '', '<p><a class="rt-upper" href="javascript:void(0);">extension-a</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'extension-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(287, 'Extension B', '', '<p><a class="rt-upper" href="javascript:void(0);">extension-b</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'extension-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(288, 'Extension C', '', '<p><a class="rt-upper" href="javascript:void(0);">extension-c</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'extension-c', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(289, 'Extension D', '', '<p><a class="rt-upper" href="javascript:void(0);">extension-b</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'extension-d', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(290, 'Extension E', '', '<p><a class="rt-upper" href="javascript:void(0);">extension-e</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'extension-e', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(291, 'Extension F', '', '<p><a class="rt-upper" href="javascript:void(0);">extension-f</a> <em>with</em> its <strong>default</strong> styling.</p>', 1, 'extension-f', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(292, 'Three Menu Options', '', '<p>Support Menus: <strong>Fusion</strong>, the Mootools enhanced CSS dropdown menu; <strong>SpliceMenu</strong>, the dynamic dropline system; and <strong>Splitmenu</strong>.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=114" class="readon"><span>More Information</span></a>', 1, 'feature-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(293, 'Logo Customization', '', '<p>Adobe® <strong>Fireworks</strong> CS5 PNG source files, allowing for <strong>quick</strong> and <strong>easy</strong> modification of the logo, and <strong>other</strong> template image elements.</p>\r\n<a href="index.php?option=com_content&amp;view=article&amp;id=8&amp;Itemid=115" class="readon"><span>More Information</span></a>', 1, 'feature-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(294, 'Newsflash Item', '', '', 1, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_articles_news', 1, 1, '{"catid":["11"],"image":"0","item_title":"0","link_titles":"","item_heading":"h4","showLastSeparator":"1","readmore":"0","count":"1","ordering":"a.publish_up","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(295, 'Product Categories', '', '', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_rokecwid_categories', 1, 1, '{"moduleclass_sfx":"","categoryLayout":"xVCategories"}', 0, '*'),
(296, 'Ecwid Cart', '', '', 0, 'top-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_rokecwid_minicart', 1, 0, '{"moduleclass_sfx":""}', 0, '*'),
(297, 'Ecwid Demo Store Information', '', '<p>This page is a demonstration of an example store by Ecwid, as integrated by the RokEcwid component. You can proceed with ''demo'' purchases to check out the process. All images and products are the copyright of their respective owners.</p>\r\n<a href="index.php?<a href="index.php?option=com_rokecwid&amp;view=ecwid&amp;Itemid=145"  class="readon"><span>More Information</span></a>', 1, 'footer-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(298, 'RokEcwid Component', '', '<p>The RokECWID component integrates ECWID directly into Joomla. It is available for download in the template download area, as part of the extensions bundle. You will need to install it, and configure it to your store ID for ECWID to work.</p>\r\n<a href="index.php?option=com_rokecwid&amp;view=ecwid&amp;Itemid=145"  class="readon"><span>More Information</span></a>', 1, 'footer-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(299, 'Ecwid Styled Support', '', '<p>Integrated <strong>styling</strong> for the popular, free and platform independent, <strong>ecommerce</strong> extension, <strong>Ecwid</strong>, inclusive of modules.</p>\r\n<a href="index.php?option=com_rokecwid&amp;view=ecwid&amp;Itemid=145" class="readon"><span>More Information</span></a>', 1, 'feature-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(300, 'RokBox Plugin', '', '<img width="80" height="80" alt="image" src="images/stories/demo/general/ext/rokbox.png" class="floatleft" />\r\n<p>RokBox is a popup plugin, that can load images, videos, web pages and other elements in a styled popup.</p>\r\n\r\n<a href="http://www.rockettheme.com/extensions-joomla/rokbox" target="_blank" class="readon"><span>More Information</span></a>', 3, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"nomargintop nopaddingtop","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(301, 'RokGZipper Plugin', '', '<img width="80" height="80" alt="image" src="images/stories/demo/general/ext/rokgzipper.png" class="floatleft" />\r\n<p>RokGZipper is a performance utility that compresses JS and CSS files into one, increasing page speed.</p>\r\n\r\n<a href="http://www.rockettheme.com/extensions-joomla/rokgzipper" target="_blank" class="readon"><span>More Information</span></a>', 3, 'content-bottom-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(302, 'RokCandy Component/Plugin', '', '<img width="80" height="80" alt="image" src="images/stories/demo/general/ext/rokcandy.png" class="floatleft" />\r\n<p>RokCandy is a snippet inserter, that transforms custom syntax into complex, HTML elements.</p>\r\n\r\n<a href="http://www.rockettheme.com/extensions-joomla/rokcandy" target="_blank" class="readon"><span>More Information</span></a>', 2, 'content-bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"nomargintop nopaddingtop","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(303, 'RokPad Editor', '', '<img width="80" height="80" alt="image" src="images/stories/demo/general/ext/rokpad.png" class="floatleft" />\r\n<p>RokPad is a code editor for Joomla, providing a rich UI and advanced features for HTML code editing.</p>\r\n\r\n<a href="http://www.rockettheme.com/extensions-joomla/rokpad" target="_blank" class="readon"><span>More Information</span></a>', 3, 'content-bottom-b', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(304, 'Sample RokTabs', '', '', 0, 'content-top-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_roktabs', 1, 0, '{"style":"base","content_type":"joomla","catid":["11"],"show_front":"1","itemsOrdering":"","strip_tags":"a,i,br,img","show_readmore":"1","readmore":"Read more...","width":"590","tabs_count":"0","duration":"600","transition_type":"scrolling","transition_fx":"Quad.easeInOut","linksMargins":"0","navscrolling":"1","tabs_position":"top","tabs_event":"click","tabs_title":"incremental","tabs_incremental":"Tab  #","tabs_hideh6":"1","tabs_prefixed":"0","tabs_showicons":"0","tabs_iconside":"left","tabs_iconpath":"__module__\\/images","tabs_icon":"icon_home.gif,icon_security.gif,icon_comment.gif,icon_world.gif,icon_note.gif","autoplay":"0","autoplay_delay":"2000","moduleclass_sfx":"nomarginbottom nopaddingbottom","cache":"0","module_cache":"1","cache_time":"900"}', 0, '*'),
(305, 'Sample RokNewsPager', '', '', 0, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_roknewspager', 1, 0, '{"load_css":"0","theme":"light","content_type":"joomla","catid":["11"],"show_front":"1","article_count":"5","show_accordion":"1","show_paging":"1","maxpages":"8","show_title":"1","show_thumbnails":"1","thumb_width":"90","thumbnail_link":"1","show_overlay":"1","overlay":"-1","show_ratings":"1","show_readmore":"1","readmore_text":"Read More...","itemsOrdering":"","show_preview_text":"1","strip_tags":"a,br","preview_count":"200","show_comment_count":"0","show_author":"0","show_published_date":"0","autoupdate":"0","autoupdate_delay":"5000","moduleclass_sfx":"","cache":"0","module_ident":"id","cache_time":"900"}', 0, '*'),
(306, 'RokFeatureTable', '', '', 1, 'feature-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_rokfeaturetable', 1, 0, '{"moduleclass_sfx":"","builtin_css":"0","highlight-col":"1","data_col1":"name::row-1|Free\\r\\nname-sub::row-1\\r\\nname-link::row-1\\r\\nprice::$0\\r\\nprice-sub::per month\\r\\nrow-3::2 Users\\r\\nrow-4::1 GB Storage\\r\\nrow-5::No Customization\\r\\nrow-6::height:89px;|\\u2295 iPhone App\\r\\nbutton-text::Sign Up Now\\r\\nbutton-text-sub::Sign Up to get access now!\\r\\nbutton-text-link::#\\r\\nbutton-text-classes::button4\\r\\n","data_col2":"name::Basic\\r\\nname-classes::B\\r\\nprice::$29\\r\\nprice-sub::per month\\r\\nrow-3::10 Users\\r\\nrow-4::5GB Storage\\r\\nrow-5::Basic Customization\\r\\nrow-6::height:89px;|\\u2295 iPhone App\\u2295 Basic Audit Trail\\r\\nbutton-text::Sign Up Now\\r\\nbutton-text-sub::Sign Up to get access now!\\r\\nbutton-text-link::#\\r\\nbutton-text-classes::button4\\r\\n","data_col3":"name::Pro\\r\\nname-classes::P\\r\\nprice::$49\\r\\nprice-sub::per month\\r\\nrow-3::50 Users\\r\\nrow-4::25GB Storage\\r\\nrow-5::Full Customization\\r\\nrow-6::height:89px;|\\u2295 iPhone App\\u2295 Full Audit Trail\\u2295 Enhanced Security (SSL)\\u2295 Custom Domains\\r\\nbutton-text::Sign Up Now\\r\\nbutton-text-sub::Sign Up to get access now!\\r\\nbutton-text-link::#\\r\\n","data_col4":"name::Enterprise\\r\\nname-classes::E\\r\\nprice::$199\\r\\nprice-sub::per month\\r\\nrow-3::Unlimited Users\\r\\nrow-4::100GB Storage\\r\\nrow-5::Full Customization\\r\\nrow-6::height:89px;|\\u2295 iPhone App\\u2295 Full Audit Trail\\u2295 Enhanced Security (SSL)\\u2295 Custom Domains\\r\\nbutton-text::Sign Up Now\\r\\nbutton-text-sub::Sign Up to get access now!\\r\\nbutton-text-link::#\\r\\nbutton-text-classes::button4\\r\\n","data_col5":"","data_col6":"","cache":"0","module_cache":"1","cache_time":"900"}', 0, '*'),
(307, 'Ecwid Info', '', '<p class="notice">Activate Ecwid Styling at <em>Admin &rarr; Extensions &rarr; Template Manager &rarr; rt_halcyon_j15 or rt_halcyon &rarr; Advanced</em>. RokEcwid needs to be installed.</p>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"nomargintop nopaddingtop","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(308, 'FP Utility iPhone', '', '<img src="images/stories/demo/frontpage/fp-rokstories1-blank.png" width="100%" alt="" />', 1, 'mobile-utility', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(309, 'K2 Information', '', '<p class="attention">RocketTheme Extension K2 support is restricted to Joomla 1.5.x only, and is not offered or supported for Joomla 1.7.x.</p>', 1, 'sidebar-a', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(310, 'Breadcrumb', '', '', 0, 'breadcrumb', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 1, '{"showHere":"0","showHome":"1","homeText":"","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*');

-- --------------------------------------------------------

--
-- Table structure for table `#__modules_menu`
--

DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE IF NOT EXISTS `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
);

--
-- Dumping data for table `#__modules_menu`
--

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES
(2, 0),
(3, 0),
(4, 0),
(6, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(12, 0),
(13, 0),
(14, 0),
(15, 0),
(79, 0),
(85, 108),
(86, 108),
(87, 108),
(88, 108),
(89, 108),
(90, 108),
(91, 108),
(92, 108),
(93, 108),
(94, 108),
(95, 108),
(96, 108),
(97, 108),
(98, 108),
(99, 108),
(100, 108),
(101, 108),
(102, 108),
(103, 108),
(104, 108),
(105, 108),
(106, 108),
(107, 108),
(108, 108),
(109, 108),
(110, 108),
(111, 108),
(112, 108),
(113, 108),
(114, 108),
(115, 108),
(116, 108),
(117, 108),
(118, 108),
(119, 108),
(120, 108),
(121, 108),
(122, 108),
(123, 108),
(124, 108),
(125, 108),
(126, 108),
(127, 108),
(128, 108),
(129, 108),
(130, 108),
(131, 108),
(132, 108),
(133, 108),
(134, 108),
(135, 108),
(136, 108),
(137, 108),
(138, 108),
(139, 108),
(140, 108),
(141, 108),
(142, 108),
(143, 108),
(144, 108),
(145, 108),
(146, 108),
(147, 108),
(148, 108),
(149, 108),
(150, 108),
(151, 108),
(152, 108),
(153, 108),
(154, 111),
(154, 112),
(154, 113),
(154, 114),
(154, 115),
(154, 116),
(154, 126),
(154, 127),
(154, 128),
(154, 129),
(154, 130),
(154, 131),
(154, 132),
(154, 133),
(154, 134),
(154, 161),
(155, 111),
(155, 112),
(155, 113),
(155, 114),
(155, 115),
(155, 116),
(155, 126),
(155, 127),
(155, 128),
(155, 129),
(155, 130),
(155, 131),
(155, 132),
(155, 133),
(155, 134),
(155, 161),
(156, 111),
(156, 112),
(156, 113),
(156, 114),
(156, 115),
(156, 116),
(156, 126),
(156, 127),
(156, 128),
(156, 129),
(156, 130),
(156, 131),
(156, 132),
(156, 133),
(156, 134),
(156, 161),
(157, 107),
(157, 109),
(157, 110),
(157, 117),
(157, 118),
(157, 119),
(157, 120),
(157, 121),
(158, 107),
(158, 109),
(158, 110),
(158, 117),
(158, 118),
(158, 119),
(158, 120),
(158, 121),
(159, 107),
(159, 109),
(159, 110),
(159, 117),
(159, 118),
(159, 119),
(159, 120),
(159, 121),
(160, 112),
(160, 114),
(160, 115),
(160, 126),
(160, 127),
(160, 128),
(160, 129),
(160, 130),
(161, 112),
(161, 114),
(161, 115),
(161, 126),
(161, 127),
(161, 128),
(161, 129),
(161, 130),
(162, 113),
(163, 113),
(225, 109),
(225, 110),
(225, 113),
(225, 114),
(225, 115),
(225, 127),
(225, 131),
(225, 132),
(225, 133),
(225, 134),
(225, 161),
(226, 126),
(226, 127),
(226, 128),
(226, 129),
(226, 130),
(227, 109),
(227, 110),
(227, 112),
(227, 113),
(227, 114),
(227, 115),
(227, 116),
(227, 127),
(227, 128),
(227, 129),
(227, 130),
(227, 131),
(227, 132),
(227, 133),
(227, 134),
(227, 161),
(228, 109),
(228, 110),
(228, 113),
(228, 114),
(228, 115),
(228, 116),
(228, 126),
(228, 127),
(228, 131),
(228, 132),
(228, 133),
(228, 134),
(228, 161),
(229, 111),
(230, 111),
(231, 111),
(232, 113),
(233, 113),
(234, 114),
(235, 114),
(236, 114),
(237, 114),
(238, 115),
(239, 115),
(240, 116),
(241, 116),
(242, 116),
(251, 107),
(252, 107),
(253, 109),
(253, 110),
(253, 113),
(253, 114),
(253, 115),
(253, 116),
(253, 117),
(253, 118),
(253, 119),
(253, 120),
(253, 121),
(253, 122),
(253, 126),
(253, 127),
(253, 128),
(253, 129),
(253, 130),
(253, 131),
(253, 132),
(253, 133),
(253, 134),
(253, 161),
(254, 112),
(254, 128),
(254, 129),
(254, 130),
(255, 101),
(256, 101),
(257, 101),
(258, 101),
(259, 101),
(260, 101),
(261, 101),
(262, 101),
(263, 101),
(264, 101),
(265, 101),
(266, 101),
(267, 101),
(268, 101),
(269, 101),
(270, 101),
(271, 101),
(272, 101),
(273, 101),
(274, 101),
(274, 131),
(275, -108),
(276, -145),
(276, -108),
(277, -108),
(278, 107),
(278, 109),
(278, 110),
(278, 117),
(278, 118),
(278, 119),
(278, 120),
(278, 121),
(279, 107),
(279, 109),
(279, 110),
(279, 117),
(279, 118),
(279, 119),
(279, 120),
(279, 121),
(280, 108),
(281, 108),
(282, 108),
(283, 108),
(284, 108),
(285, 108),
(286, 108),
(287, 108),
(288, 108),
(289, 108),
(290, 108),
(291, 108),
(292, 107),
(292, 112),
(293, 112),
(294, 128),
(294, 130),
(295, 145),
(296, 145),
(297, 145),
(298, 145),
(299, 107),
(300, 111),
(301, 111),
(302, 111),
(303, 111),
(304, 133),
(305, 132),
(306, 134),
(307, 145),
(308, 101),
(309, 131),
(309, 132),
(309, 133),
(310, 108);

-- --------------------------------------------------------

--
-- Table structure for table `#__newsfeeds`
--

DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE IF NOT EXISTS `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `filename` varchar(200) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
);

--
-- Dumping data for table `#__newsfeeds`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__redirect_links`
--

DROP TABLE IF EXISTS `#__redirect_links`;
CREATE TABLE IF NOT EXISTS `#__redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(255) NOT NULL,
  `new_url` varchar(255) NOT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
);

--
-- Dumping data for table `#__redirect_links`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__rokcandy`
--

DROP TABLE IF EXISTS `#__rokcandy`;
CREATE TABLE IF NOT EXISTS `#__rokcandy` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL,
  `macro` text NOT NULL,
  `html` text NOT NULL,
  `published` tinyint(1) NOT NULL,
  `checked_out` int(11) NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `ordering` int(11) NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY (`id`)
);

--
-- Dumping data for table `#__rokcandy`
--

INSERT INTO `#__rokcandy` (`id`, `catid`, `macro`, `html`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`) VALUES
(20, 7, '[code]{text}[/code]', '<code>{text}</code>', 1, 0, '0000-00-00 00:00:00', 7, ''),
(21, 7, '[i]{text}[/i]', '<em>{text}</em>', 1, 0, '0000-00-00 00:00:00', 6, ''),
(22, 7, '[b]{text}[/b]', '<strong>{text}</strong>', 1, 0, '0000-00-00 00:00:00', 5, ''),
(23, 7, '[h4]{text}[/h4]', '<h4>{text}</h4>', 1, 0, '0000-00-00 00:00:00', 4, ''),
(24, 7, '[h1]{text}[/h1]', '<h1>{text}</h1>', 1, 0, '0000-00-00 00:00:00', 1, ''),
(25, 7, '[h2]{text}[/h2]', '<h2>{text}</h2>', 1, 0, '0000-00-00 00:00:00', 2, ''),
(26, 7, '[h3]{text}[/h3]', '<h3>{text}</h3>', 1, 0, '0000-00-00 00:00:00', 3, '');

-- --------------------------------------------------------

--
-- Table structure for table `#__schemas`
--

DROP TABLE IF EXISTS `#__schemas`;
CREATE TABLE IF NOT EXISTS `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
);

--
-- Dumping data for table `#__schemas`
--

INSERT INTO `#__schemas` (`extension_id`, `version_id`) VALUES
(700, '1.7.3-2011-11-10');

-- --------------------------------------------------------

--
-- Table structure for table `#__session`
--

DROP TABLE IF EXISTS `#__session`;
CREATE TABLE IF NOT EXISTS `#__session` (
  `session_id` varchar(200) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` mediumtext,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT '',
  `usertype` varchar(50) DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `whosonline` (`guest`,`usertype`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
);
-- --------------------------------------------------------

--
-- Table structure for table `#__template_styles`
--

DROP TABLE IF EXISTS `#__template_styles`;
CREATE TABLE IF NOT EXISTS `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
);

--
-- Dumping data for table `#__template_styles`
--

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES
(2, 'bluestork', 1, '1', 'Bluestork - Default', '{"useRoundedCorners":"1","showSiteName":"0"}'),
(3, 'atomic', 0, '0', 'Atomic - Default', '{}'),
(4, 'beez_20', 0, '0', 'Beez2 - Default', '{"wrapperSmall":"53","wrapperLarge":"72","logo":"images\\/joomla_black.gif","sitetitle":"Joomla!","sitedescription":"Open Source Content Management","navposition":"left","templatecolor":"personal","html5":"0"}'),
(5, 'hathor', 1, '0', 'Hathor - Default', '{"showSiteName":"0","colourChoice":"","boldText":"0"}'),
(6, 'beez5', 0, '0', 'Beez5 - Default', '{"wrapperSmall":"53","wrapperLarge":"72","logo":"images\\/sampledata\\/fruitshop\\/fruits.gif","sitetitle":"Joomla!","sitedescription":"Open Source Content Management","navposition":"left","html5":"0"}'),
(7, 'rt_halcyon', 0, '1', 'rt_halcyon - Default', '{"master":"true","current_id":"7","template_full_name":"Halcyon","grid_system":"12","template_prefix":"halcyon-","cookie_time":"31536000","name":"Preset1","copy_lang_files_if_diff":"1","topblock":{"background":"#191919","overlay":"dark","link":"#fff"},"main":{"body":"light","color":"lightblue"},"bottomblock":{"background":"#191919","overlay":"dark","link":"#ccc"},"loadtransition":"1","webfonts":{"enabled":"0","source":"google"},"font":{"family":"helveticaneue","size":"default","size-is":"default"},"viewswitcher-priority":"1","logo-priority":"2","copyright-priority":"3","styledeclaration-priority":"4","iphonegradients-priority":"5","date-priority":"6","fontsizer-priority":"7","totop-priority":"8","systemmessages-priority":"9","inactive-priority":"10","iphoneimages-priority":"11","morearticles-priority":"12","smartload-priority":"13","pagesuffix-priority":"14","resetsettings-priority":"15","analytics-priority":"16","belatedpng-priority":"17","fusionmenu-priority":"18","ie6splash-priority":"19","jstools-priority":"21","moduleoverlays-priority":"22","rtl-priority":"23","splitmenu-priority":"24","splicemenu-priority":"25","touchmenu-priority":"26","webfonts-priority":"27","styledeclaration-enabled":"1","logo":{"enabled":"1","position":"header-a","autosize":"1","perstyle":"1","css":"body #rt-logo"},"date":{"enabled":"0","position":"utility-a","clientside":"0","formats":"%A, %B %d, %Y"},"fontsizer":{"enabled":"0","position":"utility-b"},"login":{"enabled":"0","position":"utility-c","text":"Member Login","logouttext":"Logout"},"popup":{"enabled":"0","position":"utility-d","text":"Popup Module","width":"250","height":"235"},"branding":{"enabled":"1","position":"copyright-c"},"copyright":{"enabled":"1","position":"copyright-a","text":"Designed by RocketTheme","layout":"3,3,3,3","showall":"0","showmax":"6"},"smartload":{"enabled":"1","text":"200","ignores":"com_community,com_contact,com_k2,com_tienda,com_weblinks","exclusion":""},"morearticles":{"enabled":"0","text":"Load More Articles","pagination":"1"},"totop":{"enabled":"1","position":"copyright-b","text":"Back to Top"},"systemmessages":{"enabled":"1","position":"drawer"},"resetsettings":{"enabled":"0","position":"footer-b","text":"Reset Settings"},"analytics":{"enabled":"0","code":"","position":"analytics"},"menu":{"enabled":"1","type":"splicemenu","fusionmenu":{"menutype":"mainmenu","position":"navigation","enable_js":"1","opacity":"1","effect":"slidefade","hidedelay":"500","menu-animation":"Circ.easeOut","menu-duration":"300","centered-offset":"0","tweak-initial-x":"-10","tweak-initial-y":"-18","tweak-subsequent-x":"0","tweak-subsequent-y":"0","tweak-width":"20","tweak-height":"20","enable-current-id":"0","theme":"gantry-fusion","limit_levels":"0","startLevel":"0","showAllChildren":"1","class_sfx":"top","cache":"0","module_cache":"1"},"splitmenu":{"roknavmenu_fusion_enable-current-id":"0","menutype":"mainmenu","theme":"gantry-splitmenu","cache":"0","module_cache":"1","mainmenu-position":"navigation","mainmenu-limit_levels":"1","mainmenu-startLevel":"0","mainmenu-endLevel":"0","mainmenu-class_sfx":"top","submenu-position":"subnavigation","submenu-limit_levels":"1","submenu-startLevel":"1","submenu-endLevel":"1","submenu-class_sfx":"","sidemenu-position":"sidebar-a","sidemenu-module_sfx":"","sidemenu-limit_levels":"1","sidemenu-startLevel":"2","sidemenu-endLevel":"9"},"splicemenu":{"menutype":"mainmenu","theme":"splicemenu","cache":"0","module_cache":"1","mainmenu-position":"navigation","mainmenu-limit_levels":"1","mainmenu-startLevel":"0","mainmenu-endLevel":"0","mainmenu-class_sfx":"top","mainmenu-fulllevel":"0","submenu-position":"subnavigation","submenu-limit_levels":"1","submenu-startLevel":"1","submenu-endLevel":"1","submenu-fulllevel":"1","submenu-showAllChildren":"1","sidemenu-position":"sidebar-a","sidemenu-class_sfx":"","sidemenu-module_sfx":"","sidemenu-limit_levels":"1","sidemenu-startLevel":"2","sidemenu-endLevel":"9","sidemenu-fulllevel":"0","topbar-pill":{"enabled":"1","duration":"200","animation":"Sine.easeOut"},"arrowindicator":{"duration":"200","animation":"Sine.easeOut"},"subpanel":{"duration":"200","animation":"Sine.easeOut"}}},"top":{"layout":"5,7","showall":"0","showmax":"6"},"header":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"showcase":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"feature":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"utility":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"maintop":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"mainbodyPosition":"a:1:{i:12;a:1:{i:2;a:2:{s:2:\\"mb\\";i:8;s:2:\\"sa\\";i:4;}}}","mainbottom":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"extension":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"bottom":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"footer":{"layout":"3,3,3,3","showall":"0","showmax":"6"},"iphone-enabled":"1","android-enabled":"1","iphone-scalable":"0","iphone-switcher":{"enabled":"1","position":"mobile-copyright"},"touchmenu":{"menutype":"mainmenu","enabled":"1","position":"mobile-navigation","theme":"touch","animation":"cube","cache":"0","module_cache":"1","startLevel":"0","endLevel":"20","showAllChildren":"1"},"iphoneimages":{"enabled":"1","minWidth":"80","percentage":"25"},"mobile":{"drawer":"drawer","top":"header-a","header":"header-c","navigation":"mobile-navigation","showcase":"mobile-showcase","feature":"content-top-a","utility":"mobile-utility","extension":"extension-a","bottom":"bottom-b","footer":"footer-a","copyright":"copyright-a"},"cache":{"enabled":"1","time":"900"},"gzipper":{"enabled":"0","time":"600","expirestime":"1440","stripwhitespace":"1"},"inputstyling":{"enabled":"1","exclusions":"''.content_vote'',''#rt-popup'',''#rt-popuplogin'',''#vmMainPage''"},"file-inline-js-enabled":"0","component-enabled":"1","mainbody-enabled":"1","rtl-enabled":"1","buildspans-enabled":"1","moduleoverlays-enabled":"1","pagesuffix-enabled":"1","typography":{"enabled":"1","style":"light"},"extensions":"1","ecwid":"1","inactive":{"enabled":"1","menuitem":"101"},"ie6splash-enabled":"1"}'),
(8, 'rt_halcyon', 0, '0', 'rt_halcyon - Home', '{"master":"7","current_id":"8","mainbodyPosition":"a:1:{i:12;a:1:{i:2;a:2:{s:2:\\"sa\\";i:3;s:2:\\"mb\\";i:9;}}}","extension":{"layout":"a:1:{i:12;a:1:{i:3;a:3:{i:0;i:5;i:1;i:3;i:2;i:4;}}}"},"bottom":{"layout":"a:1:{i:12;a:1:{i:2;a:2:{i:0;i:8;i:1;i:4;}}}"}}'),
(10, 'rt_halcyon', 0, '0', 'rt_halcyon - Logo Editing', '{"master":"7","current_id":"10","feature":{"layout":"a:1:{i:12;a:2:{i:2;a:2:{i:0;i:8;i:1;i:4;}i:4;a:4:{i:0;i:3;i:1;i:3;i:2;i:3;i:3;i:3;}}}"},"extension":{"layout":"a:1:{i:12;a:1:{i:3;a:3:{i:0;i:5;i:1;i:3;i:2;i:4;}}}"},"bottom":{"layout":"a:1:{i:12;a:1:{i:2;a:2:{i:0;i:8;i:1;i:4;}}}"}}');

-- --------------------------------------------------------

--
-- Table structure for table `#__updates`
--

DROP TABLE IF EXISTS `#__updates`;
CREATE TABLE IF NOT EXISTS `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `categoryid` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Available Updates';

--
-- Dumping data for table `#__updates`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__update_categories`
--

DROP TABLE IF EXISTS `#__update_categories`;
CREATE TABLE IF NOT EXISTS `#__update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Update Categories';

--
-- Dumping data for table `#__update_categories`
--


-- --------------------------------------------------------

--
-- Table structure for table `#__update_sites`
--

DROP TABLE IF EXISTS `#__update_sites`;
CREATE TABLE IF NOT EXISTS `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Update Sites';

--
-- Dumping data for table `#__update_sites`
--

INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`) VALUES
(1, 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', 1),
(2, 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 1),
(3, 'Gantry Framework Update Site', 'extension', 'http://www.gantry-framework.org/updates/joomla16/gantry.xml', 1);

-- --------------------------------------------------------

--
-- Table structure for table `#__update_sites_extensions`
--

DROP TABLE IF EXISTS `#__update_sites_extensions`;
CREATE TABLE IF NOT EXISTS `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Links extensions to update sites';

--
-- Dumping data for table `#__update_sites_extensions`
--

INSERT INTO `#__update_sites_extensions` (`update_site_id`, `extension_id`) VALUES
(1, 700),
(2, 700),
(3, 10001);

-- --------------------------------------------------------

--
-- Table structure for table `#__users`
--

DROP TABLE IF EXISTS `#__users`;
CREATE TABLE IF NOT EXISTS `#__users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `usertype` varchar(25) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `usertype` (`usertype`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
);


-- --------------------------------------------------------

--
-- Table structure for table `#__viewlevels`
--

DROP TABLE IF EXISTS `#__viewlevels`;
CREATE TABLE IF NOT EXISTS `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
);

--
-- Dumping data for table `#__viewlevels`
--

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES
(1, 'Public', 0, '[1]'),
(2, 'Registered', 1, '[6,2,8]'),
(3, 'Special', 2, '[6,3,8]');

-- --------------------------------------------------------

--
-- Table structure for table `#__weblinks`
--

DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE IF NOT EXISTS `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
);

--
-- Dumping data for table `#__weblinks`
--

INSERT INTO `#__weblinks` (`id`, `catid`, `sid`, `title`, `alias`, `url`, `description`, `date`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`) VALUES
(1, 12, 0, 'Joomla Templates', 'joomla-templates', 'http://www.rockettheme.com/joomla', '', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 1, 0, 1, 1, '{"target":"","width":"","height":"","count_clicks":""}', '*', '2011-12-15 16:14:10', 42, '', '0000-00-00 00:00:00', 0, '', '', '', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(2, 12, 0, 'Drupal Themes', 'drupal-themes', 'http://www.rockettheme.com/drupal', '', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 2, 0, 1, 1, '{"target":"","width":"","height":"","count_clicks":""}', '*', '2011-12-15 16:14:28', 42, '', '0000-00-00 00:00:00', 0, '', '', '', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(3, 12, 0, 'WordPress Themes', 'wordpress-themes', 'http://www.rockettheme.com/wordpress', '', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 3, 0, 1, 1, '{"target":"","width":"","height":"","count_clicks":""}', '*', '2011-12-15 16:14:52', 42, '', '0000-00-00 00:00:00', 0, '', '', '', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(4, 12, 0, 'Magento Templates', 'magento-templates', 'http://www.rockettheme.com/magento', '', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 4, 0, 1, 1, '{"target":"","width":"","height":"","count_clicks":""}', '*', '2011-12-15 16:15:05', 42, '', '0000-00-00 00:00:00', 0, '', '', '', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(5, 12, 0, 'phpBB3 Styles', 'phpbb3-styles', 'http://www.rockettheme.com/phpbb3', '', '0000-00-00 00:00:00', 0, 1, 0, '0000-00-00 00:00:00', 5, 0, 1, 1, '{"target":"","width":"","height":"","count_clicks":""}', '*', '2011-12-15 16:15:50', 42, '', '0000-00-00 00:00:00', 0, '', '', '', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00');
